/*	Make link relative
------------------------------------------
Jonas Norberg <jn@earthling.net>

Removes a symbolic link and creates a
new one who links	to the same file but
relative.

!!!!!!  ATTENTION X86 RECOMPILERS !!!!!!
Don't forget that this is supposed to be
compiled as a shared library.
------------------------------------------*/

#include <string.h>
#include <StorageKit.h>

__declspec(dllexport) void process_refs(entry_ref ref,BMessage *msg,void *ptr);

void convert(char *dst, char *src, char *file);
int higher(char *s1, char *s2, char **set);


/*	Higher
------------------------------------------
s1=	/boot/home/config/fil1
s2=	/boot/home/fil1
should return 1

s1=	/boot/home/config/kat1/fil1
s2=	/boot/fil1
should return 3
------------------------------------------*/
int higher(char *s1, char *s2, char **set)
{
	int c=0;

	while (*s1==*s2){	// skip common
		s1++;
		s2++;
		if ('/'==*s1)*set=s1+1;	// remember last '/' where s1 'fell off'
	}

	
	while (*s2){	//count '/'
		s2++;
		if ('/'==*s2) c++;
	}
	
	return c;
}

/*	Convert
------------------------------------------
from absolute to relative
file = "/boot/home/nisse lnk"
src  = "/boot/home/kat/nisse"

should result in:
dst  = "kat/nisse""
------------------------------------------*/
void convert(char *dst, char *src, char *file)
{
	char *from;
	int c=higher(src,file,&from);

	*dst=0;	 
	for (;c>0;c--) strcat(dst,"../");
	strcat(dst,from);

	//printf("f=	%s\na=	%s\nr=	%s\n",file,src,dst);	// debug-info
}


void process_refs(entry_ref ref,BMessage *msg,void *ptr)
{
	entry_ref file_ref;
	int32 cnt=0;

	char file[B_PATH_NAME_LENGTH];
	char linksto[B_PATH_NAME_LENGTH];
	char linksrel[B_PATH_NAME_LENGTH];

	BDirectory d;
	BPath path;
		
	while (msg->FindRef("refs",cnt++,&file_ref)==B_OK)
	{
		BEntry entry(&file_ref,false);		// create entry
		if (!entry.IsSymLink()) continue; // test if symlink
		
		entry.GetPath(&path);
		strcpy(file,path.Path());

		BSymLink symlink(&file_ref);
		symlink.ReadLink(linksto,B_PATH_NAME_LENGTH);

		if ('/'!=(*linksto)) continue;			// is not absolute
		
		convert(linksrel,linksto,file);

		// delete old symlink
		entry.Remove();
				
		// create new symlink (beige way)
		BSymLink syml;
		d.CreateSymLink(file,linksrel,&syml);
				
	}//end while-loop
}
