#include <Application.h>
#include <Screen.h>
#include <Window.h>
#include <DataIO.h>
#include <translation/TranslationUtils.h>

#include "stAboutWindow.h"
#include "stAboutView.h"

const uint8 about_bitmap [] = {
#include "data/about_bitmap.h"
};

stAboutWindow::stAboutWindow():
	BWindow(BRect(10,10,200,200),"About AIFF", B_MODAL_WINDOW_LOOK,
	B_FLOATING_APP_WINDOW_FEEL, B_NOT_RESIZABLE | B_NOT_ZOOMABLE )
{
	BMemoryIO *io = new BMemoryIO((void*)about_bitmap, sizeof(about_bitmap));
	bm = BTranslationUtils::GetBitmap(io);

	BScreen screen(this);
	BRect bigr = screen.Frame();
	BRect rect = bm->Bounds();
	
	MoveTo((bigr.right-rect.right) / 2, (bigr.bottom-rect.bottom) / 2);
	ResizeTo(rect.right,rect.bottom);
	
	v = new stAboutView(rect,bm);
	AddChild(v);
}

stAboutWindow::~stAboutWindow()
{
	delete bm;
}

