#include "stApp.h"
#include "stMainWindow.h"

#include <FilePanel.h>

stApp::stApp(char *signature):BApplication(signature)
{
	SetPulseRate(1000000);

	BPath path;
	find_directory(B_USER_DIRECTORY, &path);
	load = new BFilePanel(B_OPEN_PANEL);
	load->SetPanelDirectory(path.Path());
}

stApp::~stApp()
{
	delete load;
}

void stApp::AboutRequested()
{
	BAlert *alert=new BAlert("About","Sawteeth Editor","OK");
	alert->Go();
}

#include <stdio.h>
void stApp::ReadyToRun()
{
	stMainWindow *win=new stMainWindow(BRect(10,29,450,150),NULL);
	win->Show();
}

void stApp::MessageReceived(BMessage *message)
{
	switch(message->what){
	case ST_OPEN_SONG:
		load->Show();
		break;
	case ST_NEW_SONG:
	{
		stMainWindow *win = new stMainWindow(BRect(10,29,450,150),NULL);
		win->Show();
	}break;
	default:
		BApplication::MessageReceived(message);
	}
}

void stApp::Pulse()
{
	if(!IsLaunching() && CountWindows() <= WINDOWS_TO_IGNORE)
	{
		PostMessage(B_QUIT_REQUESTED);
	}
}

void stApp::RefsReceived(BMessage *message)
{
	uint32 type; 
	int32 count;
	entry_ref ref;
	BPath path;

	message->GetInfo("refs", &type, &count); 
	if ( type != B_REF_TYPE ) return; 

	for ( long i = --count; i >= 0; i-- ) { 
		if ( message->FindRef("refs", i, &ref) == B_OK ) { 
			BEntry entry(&ref, true);
			if ( entry.IsFile() && entry.GetPath(&path)==B_OK){
				stMainWindow *win = new stMainWindow(BRect(10,29,450,150),path.Path());
				if (JNG_OK !=win->InitCheck()){
					win->Quit();
					BAlert *alert=new BAlert(
						"Not Valid","Not a valid sawteeth song",
						"OK",0,0,B_WIDTH_AS_USUAL,B_STOP_ALERT);
					alert->Go();
				}else
					win->Show();
			}
		} 
	} 
}


int main()
{
	new stApp("application/x-vnd.Jonas_Norberg-Sawteeth");
	be_app->Run();
	
	delete be_app;
}