#ifndef _INSTRUMENT_WINDOW_H
#define _INSTRUMENT_WINDOW_H

#include <Window.h>
#include <Path.h>
#include <MenuBar.h>
#include <Bitmap.h>

#include "stPartWindow.h"
#include "stInstrumentWindow.h"
#include "stSeqView.h"
#include "stsp.h"

class stInstrumentWindow;

enum
{
	ST_Cut=				'saw ',
	ST_Copy,
	ST_Paste,
	ST_ZoomIn,
	ST_ZoomOut,
	ST_ZoomNormal,
	ST_NEW_SONG,
	ST_OPEN_SONG,
	ST_SAVE_SONG,
	ST_SAVE_SONG_AS,
	ST_NEW_CHANNEL,
	ST_DELETE_CHANNEL,
	ST_NEW_PART,
	ST_DELETE_PART,
	ST_EDIT_PART,
	ST_NEW_INS,
	ST_EDIT_INS,
	ST_PART_CHANGED,
	ST_PLAY_START,
	ST_PLAY_CONT
};

class stMainWindow : public BWindow
{
public:
	stMainWindow(BRect frame, const char *filename=NULL);
	~stMainWindow();
	// virtual void FrameMoved(BPoint scrPt);
	// virtual void FrameResized(float w, float h);
	// virtual void MenusBeginning(void);
	// virtual void MenusEnding(void);
	// virtual void Minimize(bool min);
	// virtual void ScreenChanged(BRect frame, color_space mode);
	// virtual void WindowActivated(bool active);
	// virtual void WorkspaceActivated(int32 workspc, bool active);
	// virtual void WorkspaceChanged(int32 oldworkspc, int32 newworkspc);
	// virtual void Zoom(BPoint lefttop, float wide, float high);
	virtual void MessageReceived(BMessage *message);

	void CurrentFile(char *filename);
	void ClosePartWin(Part *part);
	void CloseInsWin(Ins *ins);
private:
	void BuildPartMenu();
	void BuildInstrumentMenu();

	stPartWindow *pw[PARTS]; // alla parts.
	stInstrumentWindow *iw[INS]; // alla instrumet.

	BFilePanel *save; // the save-panel

	float zoom;
	BPath *file_name;
	stSeqView *st_seq_view;
	BMenuBar *menu; // the menu
	BMenu *part_menu; // the part menu
	BMenu *instrument_menu; // the instrument menu
	BMenuItem *save_item;
	BMenuItem *play_item;
	bool playing;
	
	stsp *song;
};

#endif // _INSTRUMENT_WINDOW_H
