#include <ScrollView.h>
#include <TextControl.h>

#include "stTrackerControl.h"

stTrackerControl::stTrackerControl(BRect bounds,uint8 num_lines,field_type *type_list,uint8 num_fields,BMessage *message,int32 resize):BBox(bounds,"TrackerControl",resize,B_FRAME_EVENTS,B_NO_BORDER)
{
	return_message=message;
	SetViewColor(B_TRANSPARENT_COLOR);

	bounds.OffsetTo(0,0);
	bounds.bottom-=25;
	tracker_view=new stTrackerView(bounds,num_lines,type_list,num_fields,message);
	tracker_frame=tracker_view->Frame();

	AddChild((BView*)new BScrollView("tracker_scroll",tracker_view,B_FOLLOW_TOP_BOTTOM | B_FOLLOW_LEFT,0,false,true));

	BMessage *control_message;
	control_message=new BMessage(*return_message);
	control_message->AddInt8("action",ST_SET_LENGTH);
	control_message->AddPointer("control",this);
	
	length_string = new BTextControl(BRect(0,tracker_frame.Height()+4,tracker_frame.Width(),tracker_frame.Height()+24),"set_length","Length:","",control_message,B_FOLLOW_BOTTOM | B_FOLLOW_LEFT);
	AddChild((BView*)length_string);
	
	ResizeTo(tracker_frame.Width() + B_V_SCROLL_BAR_WIDTH,tracker_frame.Height() + 25.0);
}
stTrackerControl::~stTrackerControl()
{
}

void stTrackerControl::FrameResized(float width,float height)
{
	tracker_view->ResizeTo(tracker_view->Frame().Width(),height - 25.0);
}
