#ifndef INSPARTCHANNEL
#define INSPARTCHANNEL

#include "types.h"
struct InsStep
{
	uint8 note;	//8bit note
	uint8 relative;		// 0-1
	uint8 wform;		// max 15
};

struct TimeLev
{
	uint8 time;
	uint8 lev;
};

class Ins
{
public:
	Ins();
	~Ins();
	
	void SetName(char *iname);
	char *name;

	InsStep *steps;

	// Filter - Amp
	TimeLev *amp;
	TimeLev *filter;

	uint8 amppoints;
	uint8 filterpoints;

	uint8 filtermode;
	uint8 clipmode;
	
	uint8 sps;	// PAL-screens per step	
	uint8 res;	// resonance

	uint8 vibs;
	uint8 vibd;
	
	uint8 pwms;
	uint8 pwmd;
	
	uint8 len;	// msb means loop
};


struct Step
{
	uint8 note;
	uint8 ins;
	uint8 eff;		//4bits eff 4bits value
};

class Part
{
public:
	Part();
	~Part();
	void SetName(char *iname);
	char *name;

	Step *steps;
	uint8 sps;		// PAL-screens per step	
	uint8 len;

};

struct ChStep
{
	uint8 part;
	int8 transp;
};

class Channel
{
public:
	Channel();
	~Channel();
	
	void SetName(char* iname);
	char *name;

	uint8 len;
	ChStep *steps;
};

class BreakPoint
{
public:
	uint32	PAL;
	uint32	command;
};

#endif