#ifndef Song___H
#define Song___H

#include "stdlib.h"
#include "string.h"
#include "types.h"
#include "ins_part_channel.h"
// välj vad som skall kompileras
#define TARGET_EDITOR

const int CHN		= 8;
const int CHNSTEPS	= 256;
const int PARTS		= 256;
const int PARTSTEPS	= 256;
const int INS		= 256;
const int INSSTEPS	= 128;
const int INSPOINTS	= 32;
const int BREAKPOINTS = 256;


class Song
{
friend class Player;
friend class InsPly;
public:

	Song( char *filename = 0L);
	virtual ~Song();

	status_t	Load( char *filename);
	status_t	InitCheck();
	void		Play( float *Buffer, uint32 SampleCount );

// hook funktion implemented by derived class to time breakpoints
virtual void	Break(uint32 command);
	
	uint32		GetPos();
	void		SetPos( uint32 PALs );

#ifdef TARGET_EDITOR
	void		PartPlay( float *Buffer, uint32 SampleCount );
	void		SetPartToPlay( uint8 part = 0 );


	void		Save( char *filename, bool bin=false );
	uint32		SimpLen(); // len i pals
	uint32		Sps();

	// // // // // // // // // // CHANNEL stuff
	uint8		ChannelCount();
	Channel		*GetChannel( uint8 c );
	uint8		NewChannel(); // returnerar den som skapats
	status_t	RemoveChannel( uint8 channel );

	// // // // // // // // // // PART stuff
	uint8		PartCount();
	Part		*GetPart( uint8 part );
	uint8		NewPart( Part *copy_me = 0L );
	status_t	RemovePart( uint8 part );	// B_ERROR if part is used

	// // // // // // // // // // INS stuff
	uint8		InsCount();
	Ins			*GetIns( uint8 i );
	uint8		NewIns( Ins *copy_me =0L );
	status_t	RemoveIns(uint8 l_ins);


	// // // // // // // // // // BREAKPOINT stuff
	uint8		BreakPointCount();
	uint8		GetBreakPointIndex( uint32 PAL );
	uint32		GetBreakPointByIndex( uint8 index );
	void		SetBreakPointByIndex( uint8 index, uint32 command );
	uint32		GetBreakPoint( uint32 PAL );
	void		NewBreakPoint( uint32 PAL, uint32 command );
	void		RemoveBreakPoint( uint32 PAL );

	// // // // // // // // // // OPTIONAL stuff
	status_t	Optimize();		//B_OK if something was removed.
#endif
	
	char	*name;
	float	*N2F;
	float	*R2F;

private:
	
	void	FreeSong();
	void	AllocDefSong(); // only called by constructor
	
	uint16 spspal;

	uint8 channelcount;
	uint8 partcount;
	uint8 instrumentcount;	// anger inte antal instrument, ett för mycket
	uint8 breakpcount;
	
	Channel	*chan;
	Part	*parts;
	Ins		*ins;

	BreakPoint *breakpoints;
	int		bpcount;		// counting the current bp
	status_t init;	

	// player
	void MemAdd( float *d, float *s, uint32 count);
	uint32 PALs;
	uint32 smp_left;
	float *bs;
	Player **p;
	
#ifdef TARGET_EDITOR
	// partplay
	Channel pchan;
	ChStep pchanstep;
	uint32 psmp_left;
	float *pbs;
	Player *pp;
#endif

};

#endif