#include <stdio.h>
#include "song.h"

void Big32(uint32 n){printf("%c%c%c%c",n>>24,(n>>16)&255,(n>>8)&255,n&255);}
void Big16(uint16 n){printf("%c%c",n>>8,n&255);}

// writes a AIFF header to a mono 16bit soundstream
void PrintHeader(uint32 samplecount)
{
	Big32( 'FORM' );
	Big32( (samplecount * 2) + 46 );
	Big32( 'AIFF' );
	Big32( 'COMM' );

	Big32( 18 );
	Big16( 0x0001);			// channelcount!!
	Big32( samplecount );
	Big16( 0x0010 );		// bitcount!!
	
	Big16( 0x400E );		// z = 400e - 400e ????
	Big16( 0xAC44 );		// rate = ac44 >> z
	Big16( 0x0000 );
	Big16( 0x0000 );

	Big16( 0x0000 );

	Big32( 'SSND' );
	Big32( (samplecount * 2) + 8 );

	Big32( 0x00000000 );
	Big32( 0x00000000 );
}

int main(int argc, char **argv)
{
	if (argc != 2){
		fprintf(stderr,"stPlay filename\nWill output an aiff-file on stdout\n");
		return -1;
	}
	float max = 0, min = 0;

	int16 tmp;
	
	Song *s = new Song(argv[1]);

	if (0 == s->InitCheck()){

		int sbufs = s->Sps();
		int bufc = s->SimpLen();
fprintf(stderr,"sbufs = %d\n",sbufs);
fprintf(stderr,"bufc = %d\n",bufc);
		float *sbuf = new float[sbufs];
						
		PrintHeader( bufc * sbufs );

		for(int bigc = 0 ; bigc < bufc ; bigc++){
			s->Play(sbuf,sbufs);
			for (int c = 0 ; c< sbufs; c++){

				//max and min?
				if (sbuf[c] > max) max = sbuf[c];
				if (sbuf[c] < min) min = sbuf[c];
				// clipping
				if (sbuf[c] > 0.999) sbuf[c] = 0.999;
				if (sbuf[c] < -0.999) sbuf[c] = -0.999;
				
				tmp = (int16)(30000.0 * sbuf[c]);
				putchar(tmp >> 8);
				putchar(tmp & 255);
			}
		}

		fprintf(stderr,"min = %f, max = %f\n",min,max);
		delete sbuf;
		delete s;
	}
}
