#ifndef _MY_PATHFINDER_
#define _MY_PATHFINDER_

#include <OS.h>
#include "WarPathfinder.h"
#include "WarPath.h"

class WarMap;
class WarEntityList;

class MyPathfinder:public WarPathfinder
{
public:
	MyPathfinder(WarMap *map,WarEntityList *ul,uint16 *tmp_map);
	virtual ~MyPathfinder();

	virtual uint8 FindPath();
	// should return which way to go if the unit
	// wants to go the the specified coordinates
	void NewPosition(uint16 x,uint16 y);
	// Updates the unit's location on the map
	// This function is called every time the unit
	// moves from one block to another
	void NewDestination(uint16 x,uint16 y,const uint8 spds[32]);
private:

	bool CheckLine(uint16 x1,uint16 y1,uint16 x2,uint16 y2);
	bool CheckBlock(uint16 x,uint16 y);
	bool CheckBlock(uint32 offs);
	void DrawLinePath(WarPath *,uint16 x1,uint16 y1,uint16 x2,uint16 y2);

	uint16 timeout;

	uint16 *dist_map;
	WarPath *path;
	uint16 unit_x,unit_y;
	WarMap *map;
	WarEntityList *ulist;
	uint8 *unit_speed;
	
	bool path_found;
};

#endif // _MY_PATHFINDER_