#ifndef _WAR_BLOCK_MAP_
#define _WAR_BLOCK_MAP_

// the block map can only have a size of (2^n) the n is the given size in the
// constructor

#include <OS.h>

template <class Item>
class WarBlockMap
{
public:
	WarBlockMap(int32 width_shift,int32 height_shift);
	virtual ~WarBlockMap();

	void SetValue(int32 x,int32 y,Item value);

	Item Value(int32 x,int32 y);

	int32 Width();
	int32 Height();
	
	Item operator[](int32 index);

	Item *Bits();

protected:
	Item *map; 

	int32 width,height;
	int32 width_shift;
};

template <class Item>
WarBlockMap<Item>::WarBlockMap(int32 w_shift,int32 h_shift)
{
	width = (1 << w_shift);
	height = (1 << h_shift);

	width_shift = w_shift;

	map = new Item[width * height];
	
	// !!! this should be replaced with some template dependent code !!!
	memset(map,0,width * height * sizeof(Item));
}

template <class Item>
WarBlockMap<Item>::~WarBlockMap()
{
	delete []map;
}

template <class Item>
inline void WarBlockMap<Item>::SetValue(int32 x,int32 y,Item value)
{
//	#ifdef _DEBUG
		if (y<0 || y>=height || x<0 || x>=width)
		{
			printf("block map adress out of bounds!\n");
			exit(1);
		}
//	#endif
	map[(y<<width_shift) + x] = value;
}

template <class Item>
inline Item WarBlockMap<Item>::Value(int32 x,int32 y)
{
//	#ifdef _DEBUG
		if (y<0 || y>=height || x<0 || x>=width)
		{
			printf("block map adress out of bounds!\n");
			exit(1);
		}
//	#endif
	return map[(y<<width_shift) + x];
}

template <class Item>
inline Item *WarBlockMap<Item>::Bits()
{
	return map;
}

template <class Item>
inline int32 WarBlockMap<Item>::Width()
{
	return width;
}

template <class Item>
inline Item WarBlockMap<Item>::operator[](int32 index)
{
	return map[index];
}

template <class Item>
inline int32 WarBlockMap<Item>::Height()
{
	return height;
}

#endif // _WAR_BLOCK_MAP_
