#ifndef _WAR_BOX_H_
#define _WAR_BOX_H_

#include "WarVertex.h"

#include <OS.h>
#include <gl.h>
#include <math.h>

class WarBox
{
public:
	WarBox();
	WarBox(float width,float length,float height);
	void SetTo(float width,float length,float height);

	WarVertex *Point(uint8 index);
	
	void Draw();

	void OffsetBy(WarVertex position);
	void RotateBy(WarVertex vertex);
private:
	WarVertex points[8];
};

inline void WarBox::RotateBy(WarVertex vertex)
{
	points[0].RotateBy(vertex);
	points[1].RotateBy(vertex);
	points[2].RotateBy(vertex);
	points[3].RotateBy(vertex);
	points[4].RotateBy(vertex);
	points[5].RotateBy(vertex);
	points[6].RotateBy(vertex);
	points[7].RotateBy(vertex);
}

inline void WarBox::OffsetBy(WarVertex vertex)
{
	points[0]+=vertex;
	points[1]+=vertex;
	points[2]+=vertex;
	points[3]+=vertex;
	points[4]+=vertex;
	points[5]+=vertex;
	points[6]+=vertex;
	points[7]+=vertex;
}

inline void WarBox::SetTo(float width,float length,float height)
{
	points[0].SetTo(length/2,width/2,height/2);
	points[1].SetTo(length/2,-width/2,height/2);
	points[2].SetTo(-length/2,-width/2,height/2);
	points[3].SetTo(-length/2,width/2,height/2);

	points[4].SetTo(length/2,width/2,-height/2);
	points[5].SetTo(length/2,-width/2,-height/2);
	points[6].SetTo(-length/2,-width/2,-height/2);
	points[7].SetTo(-length/2,width/2,-height/2);
}

inline WarVertex *WarBox::Point(uint8 index)
{
	return &points[index];
}

#endif // _WAR_BOX_H_
