#ifndef _WAR_CLASS_
#define _WAR_CLASS_

#include <SupportDefs.h>

#include "WarBuffer.h"
#include "WarBox.h"

class WarEntityList;
class WarMap;
class WarBrain;
class WarUnit;
class WarServer;
class WarColor;

class WarClass
{
public:
	WarClass(BDirectory *unit_dir,uint16 class_id);
	virtual ~WarClass();

	virtual WarUnit *InstantiateBody(float x,float y,float z,uint8 angle,uint8 team,WarColor color,WarMap *map,uint16 id);
	virtual WarUnit *InstantiateBody(WarMap *map,WarBuffer *buffer);
	virtual WarBrain *InstantiateBrain(WarMap *map,WarEntityList *ulist,uint8 team,uint16 id,int32 x,int32 y,WarUnit *body,WarServer *server);

	virtual bool IsFlying();
	virtual WarBox BoundingBox();

	virtual char *Name();
	virtual char *Description();

	void IncreaseLoads();
	bool DecreaseLoads();
	
	uint16 Id();
protected:
	WarBox bounding_box;
private:
	void PrecalcPointNorms();
	uint16 id; // the class id#

	uint32 loaded;
};

// inline definitios

inline uint16 WarClass::Id()
{
	return id;
}

inline void WarClass::IncreaseLoads()
{
	loaded++;
}

inline bool WarClass::DecreaseLoads()
{
	loaded--;
	return loaded == 0;
}

#endif // _WAR_CLASS_
