#ifndef _WAR_FACE_H_
#define _WAR_FACE_H_

#include "WarVertex.h"
#include "WarColor.h"

#include <OS.h>
#include <GraphicsDefs.h>
#include <Point.h>

class WarFace
{
public:
	WarFace(uint16 num_vertices);
	virtual ~WarFace();

	bool IsFront();
	void CalcNormal();

	uint16 VertexCount();
	WarVertex Normal();

	WarVertex **vex;		// pekare till hörnen
	BPoint *texture_coords;

	uint16 material;

private:
	WarVertex normal;

	uint16 num_vertices;
};

// inline definitions

inline uint16 WarFace::VertexCount()
{
	return num_vertices;
}

inline WarVertex WarFace::Normal()
{
	return normal;
}

#endif // _WAR_FACE_H_