#ifndef _WAR_GRID_
#define _WAR_GRID_

#include "WarList.h"

// the grid can only have a size of (2^n + 1) the n is the given size in the
// constructor

template <class Item>
class WarGrid
{
public:
	WarGrid(int32 width_shift,int32 height_shift);
	virtual ~WarGrid();

	void SetValue(int32 x,int32 y,Item value);

	Item Value(int32 x,int32 y);

	int32 Width();
	int32 Height();
	
	Item operator[](int32 index);

	Item *Bits();

protected:
	Item *grid; 

	int32 width,height;
	int32 width_shift;
};

template <class Item>
WarGrid<Item>::WarGrid(int32 w_shift,int32 h_shift)
{
	width = (1 << w_shift) + 1;
	height = (1 << h_shift) + 1;

	width_shift = w_shift;

	grid = new Item[width * height];
	memset(grid,0,width * height * sizeof(Item));
}

template <class Item>
WarGrid<Item>::~WarGrid()
{
	delete []grid;
}

template <class Item>
inline void WarGrid<Item>::SetValue(int32 x,int32 y,Item value)
{
	grid[(y<<width_shift) + y + x] = value;
}

template <class Item>
inline Item WarGrid<Item>::Value(int32 x,int32 y)
{
	return grid[(y<<width_shift) + y + x];
}

template <class Item>
inline Item *WarGrid<Item>::Bits()
{
	return grid;
}

template <class Item>
inline int32 WarGrid<Item>::Width()
{
	return width;
}

template <class Item>
inline Item WarGrid<Item>::operator[](int32 index)
{
	return grid[index];
}

template <class Item>
inline int32 WarGrid<Item>::Height()
{
	return height;
}

#endif // _WAR_GRID_
