#ifndef _WAR_HEAPF_H_
#define _WAR_HEAPF_H_

#include <OS.h>
#include <List.h>
#include <stdio.h>

class WarHeapf
{
public:
	WarHeapf(uint32 size);
	~WarHeapf();
	void Push(uint16 x,uint16 y,uint8 level,float wt);
	bool Pop(uint16 *x,uint16 *y,uint8 *level,float *weight);
	bool TopWeight(float *wt);
	void Empty();
private:

	struct entry_data
	{
		int16 x;
		int16 y;
		uint8 level;
		float wt;
	};

	void make_float(uint32 index);
	void make_sink(uint32 index);
	void swap(uint32 index,uint32 index2);

	entry_data *heap;
	uint32 heap_size;
	uint32 element_count;
	uint32 tmp_index;
};

inline void WarHeapf::swap(uint32 index,uint32 index2)
{
	entry_data tmp = heap[index2];
	heap[index2] = heap[index];
	heap[index] = tmp;
}
/*
inline void WarHeapf::make_float(uint32 index)
{
//	printf("WarHeapf: make_float(%d)\n",index);
	tmp_index=index>>1;
	while (heap[tmp_index].level<heap[index].level && index!=1)
	{
		swap(index,tmp_index);
		index=tmp_index;
		tmp_index=index>>1;
	}
//	printf("WarHeapf: floated to %d\n",index);
}

inline void WarHeapf::make_sink(uint32 index)
{
	tmp_index=(heap[index<<1].level>heap[(index<<1)+1].level)?index<<1:(index<<1)+1;
	while (tmp_index<element_count && heap[index].level<heap[tmp_index].level)
	{
		swap(index,tmp_index);
		index=tmp_index;
		tmp_index=(heap[index<<1].level>heap[(index<<1)+1].level)?index<<1:(index<<1)+1;
	}
}
*/

inline void WarHeapf::make_float(uint32 index)
{
//	printf("WarHeapf: make_float(%d)\n",index);
	tmp_index=index>>1;
	while (heap[tmp_index].wt>heap[index].wt && index!=1)
	{
		swap(index,tmp_index);
		index=tmp_index;
		tmp_index=index>>1;
	}
//	printf("WarHeapf: floated to %d\n",index);
}

inline void WarHeapf::make_sink(uint32 index)
{
	tmp_index=(heap[index<<1].wt<heap[(index<<1)+1].wt)?index<<1:(index<<1)+1;
	while (tmp_index<element_count && heap[index].wt>heap[tmp_index].wt)
	{
		swap(index,tmp_index);
		index=tmp_index;
		tmp_index=(heap[index<<1].wt<heap[(index<<1)+1].wt)?index<<1:(index<<1)+1;
	}
}

inline bool WarHeapf::TopWeight(float *level)
{
	if (element_count==0) return false;
	*level=heap[1].level;
	return true;
}

#endif //_WAR_HEAPF_H_