#ifndef _WAR_OBJECT_H_
#define _WAR_OBJECT_H_

#include <gl.h>

#include "WarList.h"
#include "WarVertex.h"
#include "WarMatrix.h"

class WarObject;
class WarCamera;

class WarObject : public WarMatrix
{
public:
	WarObject(WarObject *object_to_copy);
	WarObject(BDirectory *dir,const char *filename);
	virtual ~WarObject();

	void AddSubObject(WarObject *obj);
	WarObject *Object(uint16 index);
	uint16 ObjectCount();

	void RotateToNormal(WarVertex *normal);

	virtual void Draw(WarCamera *camera);

private:

// refers to an already-initialized display list in the OpenGL
	GLuint model_id;

// describes the bounding box, is used when drawing the select cube around the unit
	float max_x,min_x;
	float max_y,min_y;
	float max_z,min_z;
	
	WarList<WarObject*> *sub_objects;
};

// inline definitions

inline uint16 WarObject::ObjectCount()
{
	return sub_objects->CountItems();
}

inline WarObject *WarObject::Object(uint16 index)
{
	return sub_objects->ItemAt(index);
}

#endif // _WAR_OBJECT_H_
