#ifndef _WAR_POINT_H_
#define _WAR_POINT_H_

#include <OS.h>
#include <gl.h>
#include <math.h>
#include <Point.h>

class WarPoint
{
public:
	WarPoint();
	WarPoint(float x,float y);

	void SetTo(float x,float y);

	float Angle(WarPoint vertex);
	float Abs();

	GLfloat x,y;	// the coordinates

	operator GLfloat*();
	operator BPoint();

	WarPoint operator=(WarPoint vec);
	WarPoint &operator=(WarPoint *vec);
	WarPoint &operator=(BPoint point);
	WarPoint &operator+=(WarPoint vec);
	WarPoint &operator+=(WarPoint *vec);
	WarPoint &operator/=(int32 val);
	WarPoint operator/(int32 val);
	WarPoint operator*(int32 val);
	WarPoint operator*(float val);
	void operator*=(float val);
	WarPoint operator+(WarPoint vec);
	WarPoint operator-(WarPoint vec);
	bool operator==(WarPoint vec);
	bool operator!=(WarPoint vec);
	WarPoint operator-();
};

// inline definitions

inline float WarPoint::Abs()
{
	return sqrt(x*x + y*y);
}

inline WarPoint::operator BPoint()
{
	return BPoint(x,y);
}

#endif // _WAR_POINT_H_
