#ifndef _WAR_POLYGON_
#define _WAR_POLYGON_

#include <Point.h>
#include <List.h>

class WarPolygon
{
public:
	WarPolygon();
	virtual ~WarPolygon();

	bool AddPoint(BPoint point);
	int32 CountPoints();
	
	bool Contains(BPoint point);
	void ExpandBy(BPoint point);
	
	void Empty();
	
	int32 TopPointIndex();
	int32 IterateLeft(int32 index);
	int32 IterateRight(int32 index);

	BPoint PointAt(int32 index);
	
	void Draw();

private:
	// tests if the two points (t_p1 & t_p2) is on the same side of the
	// line (l_p1 to l_p2)
	bool TestLine(BPoint l_p1,BPoint l_p2,BPoint t_p1,BPoint t_p2);

	BList *point_list; // a list of all points in the polygon
};

inline int32 WarPolygon::CountPoints()
{
	return point_list->CountItems();
}

inline BPoint WarPolygon::PointAt(int32 index)
{
	return BPoint(*((BPoint *)point_list->ItemAt(index)));
}

#endif //#ifndef _WAR_POLYGON_