#ifndef _WAR_SPLINE_GRID_
#define _WAR_SPLINE_GRID_

#include "WarList.h"

class WarSplineGrid
{
public:
	WarSplineGrid(uint16 width,uint16 height,float divider = 1.0);
	virtual ~WarSplineGrid();

	void SetKey(uint16 x,uint16 y,int8 value);

	float Value(float x,float y);
	
	uint16 Width();
	uint16 Height();

protected:
	float spline(int8 v0,int8 v1,int8 v2,int8 v3,float t);

	int8 *grid; 
	bool loop;
	float divider;

	uint16 width,height;
};

inline uint16 WarSplineGrid::Width()
{
	return width;
}

inline uint16 WarSplineGrid::Height()
{
	return height;
}

#endif // _WAR_SPLINE_GRID_
