#include "MyUnitClass.h"
#include "WarClass.h"
#include "WarBuffer.h"

#include "MyUnitEntity.h"
//#include "MyUnitBrain.h"

MyUnitClass::MyUnitClass(BDirectory *dir,uint16 class_id) : WarClass(dir,class_id)
{

// You have to initialize the bounding box!
	bounding_box.SetTo(1.0,1.7,.4);
	bounding_box.OffsetBy(WarVertex(0.0,0.0,0.2));

// load the model we wish to use. This constructor
// of WarObject() will load the model into memory, the other
// constructor that takes a WarObject pointer will copy the
// reference to that memory. So, when you construct your units
// you should copy the object by using the constructor
// that takes the WarObject. This constructor of WarObject 
// should only be called once.

	object=new WarObject(dir,"tank.lwo");
	object->ScaleTo(WarVertex(.5,.5,1.0));
	WarObject *sub_object=new WarObject(dir,"turret.lwo");
	sub_object->MoveTo(WarVertex(0.0,0.0,.2));
// as soon as we add the sub_object we hand over the responsibility to
// delete the object
	object->AddSubObject(sub_object);
}

MyUnitClass::~MyUnitClass()
{
	delete object;
}

WarUnit *MyUnitClass::InstantiateBody(float x,float y,float z,uint8 angle,uint8 team,WarColor color,WarMap *map,uint16 id)
{
// we construct our body object with the given parameters
// plus the object we loaded in the constructor. The WarUnit will
// copy the object (actually it's the WarObject that the WarUnit
// is inherited from that copies the object).
	return new MyUnitEntity(x,y,z,angle,team,color,map,id,object,this);
}
/*
WarBrain *MyUnitClass::InstantiateBrain(WarMap *map,WarEntityList *ulist,uint8 team,uint16 id,int32 x,int32 y,WarUnit *body,WarServer *server)
{
	return new MyUnitBrain(map,ulist,team,id,x,y,body,server);
}
*/
char *MyUnitClass::Name()
{
	return "medium tank";
}

char *MyUnitClass::Description()
{
	return "This is really not a tank.. it's anly a test unit";
}
