#ifndef _MY_UNIT_BODY_H
#define _MY_UNIT_BODY_H

#include "WarUnit.h"
#include "WarVertex.h"
#include "WarPoint.h"

struct line
{
	int8 x1,y1,x2,y2;
};

class MyUnitEntity:public WarUnit
{
public:
	MyUnitEntity(float x,float y,float z,uint16 direction,uint8 team_id,WarColor color,WarMap *map,uint16 id,WarObject *object_to_copy,WarClass *war_class);
	virtual void Cycle(void **data,float frame_time);
	virtual void Vision(WarMap *war_map,uint8 flags);
	
	virtual void Select(bool is);
	virtual bool IsSelected();
	
	virtual void JoinGroup(uint8 group_id);
	virtual void LeaveGroup();
	virtual uint8 Group();
private:
	bool selected;

	WarVertex centre;

	float time;
	float ground_z;
	WarMap *war_map;
	WarPoint slope;
	
	WarObject *turret;
	
	uint8 group;
};

//const uint8 num_lines=4;
//const line model[]={{6,4,-6,4},{-6,4,-6,-4},{-6,-4,6,-4},{6,-4,6,4}};
const uint8 num_lines=9;
const line model[]={{6,4,-6,4},{-6,4,-6,-4},{-6,-4,6,-4},{6,-4,6,4},{3,2,-3,2},{-3,2,-3,-2},{-3,-2,3,-2},{3,-2,3,2},{0,0,8,0}};


#endif // _MY_UNIT_BODY_H