#ifndef _WAR_MENU_
#define _WAR_MENU_
#include <gl.h>

#include "WarList.h"
#include "WarView.h"
#include "WarObject.h"
#include "WarFont.h"

class WarMenu: public WarView
{
public:
	WarMenu(int32 left,int32 top,int32 width,int32 height,WarFont *font,char *command_line);
	virtual ~WarMenu();

	void AddItem(const char *string,WarMenu *sub_menu = NULL);
	void AddSeparator();

	virtual void MouseDown(WarPoint point,uint8 button);
//	virtual void MouseUp(WarPoint point,uint8 button);
	virtual void MouseMoved(WarPoint point);

	int32 CurrentItem(); // returns the item the user currently is pointing at

protected:
	virtual void Update();
private:
	void Invoke();
	void SetParent(WarMenu *menu);// if this menu is a submenu, the parent menu probably wants
										// to know when an item is invoked
	WarFont *m_war_font;	// the font

	struct menu_item
	{
		BString *string; // if this is NULL it's a separator item
		WarMenu *sub_menu; // if this is NULL the item doesn't have a submenu
	};

	WarList<menu_item*> m_item_list;

	BString *m_command_line; // contains the commandline to execute after the selection is done.
	WarMenu *m_parent;

	int32 m_max_width;
	WarPoint m_mouse_position;

	int32 m_current_item;
	
	bool m_submenu;	// if this is true, the highlighted item should remain higlighted until the user
						// points at another item or this variable is false
};

// inline definitions

inline int32 WarMenu::CurrentItem()
{
	return m_current_item;
}

inline void WarMenu::SetParent(WarMenu *parent)
{
	m_parent = parent;
}

#endif // WAR_MENU_
