#ifndef _WAR_MOUSE_VIEW_
#define _WAR_MOUSE_VIEW_
#include <gl.h>

#include "WarList.h"
#include "WarView.h"
#include "WarObject.h"
#include <Point.h>

class WarMouseView: public WarView
{
public:
	WarMouseView(int32 left,int32 top,int32 width,int32 height);
	virtual ~WarMouseView();
	
	void SetMousePosition(WarPoint pos);
	WarPoint MousePosition();

	virtual void MouseMoved(WarPoint point);
	
	void LockCursor(bool lock);
	bool IsCursorLocked();

	void HideCursor(bool hidden);
	bool IsCursorHidden();

protected:
	virtual void Update();
private:
	bool m_hidden_cursor;
	bool m_locked_cursor;

	WarPoint m_mouse_position;
};

// inline definitions

inline WarPoint WarMouseView::MousePosition()
{
	return m_mouse_position;
}

inline void WarMouseView::LockCursor(bool lock)
{
	m_locked_cursor = lock;
}

inline bool WarMouseView::IsCursorLocked()
{
	return m_locked_cursor;
}

inline void WarMouseView::SetMousePosition(WarPoint pos)
{
	m_mouse_position = pos;
}

inline void WarMouseView::HideCursor(bool hidden)
{
	m_hidden_cursor = hidden;
}

inline bool WarMouseView::IsCursorHidden()
{
	return m_hidden_cursor;
}

#endif // WAR_MOUSE_VIEW_
