#ifndef _WAR_SELECTION_VIEW_
#define _WAR_SELECTION_VIEW_
#include <gl.h>

#include "WarList.h"
#include "WarView.h"
#include "WarFont.h"
#include "WarUnit.h"

class WarSelectionView: public WarView
{
public:
	WarSelectionView(int32 left,int32 top,int32 width,int32 height,WarFont *font);
	virtual ~WarSelectionView();

	void Add(WarUnit *entity);
	void Remove(WarUnit *entity);
	void RemoveAll();

	void Regenerate(); // regenerates the text to be drawn

protected:
	virtual void Update();
private:

	WarFont *war_font;
	
	char line[32][20 + 6];	// max 32 lines and a class name can be max 20 characters + 4 chars for the counter

	WarClass *war_class[32]; // the class for every line
	uint8 num_classes; // keeps count of the number of different classes are selected

	WarList<WarUnit*> *entity_list[32]; // the list of all selected entities
};

// inline definitions

#endif // WAR_SELECTION_VIEW_
