#ifndef _WAR_SKYDOME_
#define _WAR_SKYDOME_

#include <gl.h>

#include "WarWeather.h"

class WarSkydome
{
public:
	WarSkydome(WarWeather *weather,float detail_level);
	virtual ~WarSkydome();

	void Draw(); // draws the skydome

private:
	GLuint generate_dome(float detail_level);

// the gl display list id
	GLuint m_display_list;
// the weather
	WarWeather *m_weather;

// the time, tells how much the clouds should have moved over the sky
	float m_time;
};

// inline definitions

inline void WarSkydome::Draw()
{
	glMatrixMode( GL_TEXTURE );
	glLoadIdentity();
//	glScalef(1,5,5);
	glScalef(2,-1,1);

	glMatrixMode( GL_MODELVIEW );

	glDepthMask(GL_FALSE);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, m_weather->SkyTexture());
	glCallList(m_display_list);
	glDepthMask(GL_TRUE);

	glMatrixMode( GL_TEXTURE );
	glLoadIdentity();
	glMatrixMode( GL_MODELVIEW );

}

#endif // WAR_SKYDOME_
