#ifndef _WAR_STAT_VIEW_
#define _WAR_STAT_VIEW_
#include <gl.h>

#include "WarList.h"
#include "WarView.h"
#include "WarObject.h"
#include "WarFont.h"

class WarStatView: public WarView
{
public:
	WarStatView(int32 left,int32 top,int32 width,int32 height,WarFont *font);
	virtual ~WarStatView();

	void SetFps(float fps);
	void SetPolys(int32 polys);
	void SetFans(int32 fans);

protected:
	virtual void Update();
private:
	WarFont *war_font;
	
	float fps_counter; // contains the current rendering speed in frames per second
	int32 polygon_counter; // contains the current number of rendered polygons
	int32 fan_counter; // contains the current number of rendered triangle fans

	char tmp_string[100]; // string used temporarily while drawing text
};

// inline definitions

inline void WarStatView::SetFps(float fps)
{
	fps_counter = fps;
}

inline void WarStatView::SetPolys(int32 polys)
{
	polygon_counter = polys;
}

inline void WarStatView::SetFans(int32 fans)
{
	fan_counter = fans;
}

#endif // WAR_STAT_VIEW_
