#ifndef _WAR_TEXT_OUTPUT_
#define _WAR_TEXT_OUTPUT_
#include <gl.h>

#include "WarList.h"
#include "WarView.h"
#include "WarObject.h"
#include "WarFont.h"

const uint8 MAX_LINES = 32;

class WarTextOutput: public WarView
{
public:
	WarTextOutput(int32 left,int32 top,int32 width,int32 height,WarFont *font);
	virtual ~WarTextOutput();

	void PutLine(const char *line);

protected:
	virtual void Update();
private:
	WarFont *war_font;
	
	char *line[MAX_LINES];	// a pointer to every line written;
	bigtime_t timeout[MAX_LINES]; // the time (in micro seconds) when this line should be removed
	
	uint8 line_position; // the index of the last line written
	uint8 visible_lines; // is the number of line visible, most of the time it's zero
};

#endif // WAR_TEXT_OUTPUT_
