#ifndef _WAR_WEATHER_
#define _WAR_WEATHER_

#include "WarColor.h"
#include "WarVertex.h"
#include "WarPoint.h"

#include <GraphicsCard.h>
#include <List.h>
#include <gl.h>

class WarWeather
{
friend class WarGLView;
public:
	WarWeather(char *sky,WarColor color);
	virtual ~WarWeather();

	GLuint SkyTexture();
	GLfloat *FogColor();
	float FogStart();

	WarVertex *Color(WarPoint slope);

private:
	WarVertex color;
	GLuint texture_id;
	GLfloat fog_color[4];
};

// inline definitions

inline GLfloat *WarWeather::FogColor()
{
	return fog_color;
}

inline GLuint WarWeather::SkyTexture()
{
	return texture_id;
}

inline float WarWeather::FogStart()
{
	return 0.3;
}

inline WarVertex *WarWeather::Color(WarPoint slope)
{
	float tmp = ((slope.x + slope.y) * .15 + .75);

	if (tmp > 1.0) tmp = 1.0;
	else if (tmp < 0.0) tmp = 0.0;

	color.x = tmp;
	color.y = tmp*0.7;
	color.z = tmp*0.8;

	return &color;
}

/*
inline WarVertex WarWeather::Color(WarPoint *slope)
{
	float tmp = ((slope->x + slope->y) * .35 + .65);

	if (tmp > 1.0) tmp = 1.0;
	else if (tmp < 0.0) tmp = 0.0;

	return WarVertex(tmp,tmp,tmp);
}
*/
#endif // #ifndef _WAR_WEATHER_