#include "WarEntity.h"
#include "WarMap.h"
#include "WarColor.h"
#include "WarEntityList.h"
#include "WarBuffer.h"

_EXPORT WarEntity::WarEntity(float x,float y,float z,uint16 direction,uint8 team_id,WarColor color,WarMap *map,uint16 id,WarObject *model,WarClass *the_class):WarObject(model)
{
	team=team_id;
	unit_id=id;
	color=color;
	war_class = the_class;

	MoveTo(x,y,z);
}

_EXPORT WarEntity::WarEntity(WarBuffer *buffer,WarObject *model):WarObject(model)
{
	float x,y,z;
	team=buffer->PopUint8();
	unit_id=buffer->PopUint16();
// position
	x=buffer->PopFloat();
	y=buffer->PopFloat();
	z=buffer->PopFloat();
	MoveTo(x,y,z);
// rotation
	x=buffer->PopFloat();
	y=buffer->PopFloat();
	z=buffer->PopFloat();
	RotateTo(WarVertex(x,y,z));
// scale
	x=buffer->PopFloat();
	y=buffer->PopFloat();
	z=buffer->PopFloat();
	ScaleTo(WarVertex(x,y,z));
}

_EXPORT WarEntity::~WarEntity()
{
}

_EXPORT void WarEntity::MoveTo(float x,float y,float z)
{
	WarObject::MoveTo(WarVertex(x,y,z));
	block_x=(int)x/BLOCK_WIDTH;
	block_y=(int)y/BLOCK_WIDTH;
}

_EXPORT void WarEntity::Vision(WarMap *map,uint8 flag)
{
}

_EXPORT void WarEntity::Flatten(WarBuffer *buffer)
{
	buffer->PushUint8(team);
	buffer->PushUint16(unit_id);
// position
	buffer->PushFloat(XPosition());
	buffer->PushFloat(YPosition());
	buffer->PushFloat(ZPosition());
// rotation
	buffer->PushFloat(XDirection());
	buffer->PushFloat(YDirection());
	buffer->PushFloat(ZDirection());
// scale
	buffer->PushFloat(XScale());
	buffer->PushFloat(YScale());
	buffer->PushFloat(ZScale());
}

// ------------------------------------------
_EXPORT void WarEntity::MessageReceived(WarBuffer *message)
{
}

_EXPORT void WarEntity::Cycle(void **data,float frame_time)
{
}

// ------------------------------------------

_EXPORT uint16 WarEntity::MaxValue(uint8 index)
{
	return 0;
}

_EXPORT uint16 WarEntity::Value(uint8 index)
{
	return 0;
}

// ------------------------------------------

_EXPORT void WarEntity::Select(bool is)
{
}

_EXPORT bool WarEntity::IsSelected()
{
	return false;
}

// ------------------------------------------

void WarEntity::Draw(WarCamera *camera)
{
	if (IsSelected())
	{
		WarBox box;
		GetBoundingBox(&box);
		glColor3f(.6,1.0,.6);
		glDisable(GL_LIGHTING);
		glDisable(GL_TEXTURE_2D);
		box.Draw();
	}
 	glColor3f(1.0,1.0,1.0);
	WarObject::Draw(camera);
}

uint8 WarEntity::Group()
{
	return -1;
}

void WarEntity::LeaveGroup()
{
}

void WarEntity::JoinGroup(uint8 group)
{
}
