#include "WarEntity.h"
#include "WarMap.h"
#include "WarColor.h"
#include "WarEntityList.h"
#include "WarBuffer.h"

_EXPORT WarEntity::WarEntity(int32 id, float mass, WarVertex position, WarVertex rotation, WarVertex speed, WarVertex direction, WarVertex scale):
	WarMatrix(position,direction,scale),
	m_id(id),
	m_mass(mass),
	m_speed(speed),
	m_rotation(rotation)
{
}

_EXPORT WarEntity::~WarEntity()
{
}

// ------------------------------------------
_EXPORT void WarEntity::MessageReceived(WarBuffer *message)
{
}

_EXPORT void WarEntity::Cycle(double frame_time)
{
	MoveBy(m_speed * frame_time);
	RotateBy(m_rotation * frame_time);
}

// ------------------------------------------

_EXPORT uint16 WarEntity::MaxValue(uint8 index)
{
	return 0;
}

_EXPORT uint16 WarEntity::Value(uint8 index)
{
	return 0;
}

// ------------------------------------------

_EXPORT void WarEntity::Select(bool is)
{
}

_EXPORT bool WarEntity::IsSelected()
{
	return false;
}

// ------------------------------------------

_EXPORT void WarEntity::GetBoundingBox(WarBox *box)
{
/*
	*box = war_class->BoundingBox();
	box->RotateBy(Direction());
	box->OffsetBy(Position());
*/
}

_EXPORT void WarEntity::Update(WarCamera *camera)
{
}

_EXPORT void WarEntity::SetDetailLevel(float detail)
{
}

_EXPORT float WarEntity::DetailLevel()
{
	return 0.0;
}

_EXPORT uint8 WarEntity::Group()
{
	return 255;
}

_EXPORT void WarEntity::LeaveGroup()
{
}

_EXPORT void WarEntity::JoinGroup(uint8 group)
{
}
