#include <TranslationUtils.h>
#include <Bitmap.h>
#include <stdlib.h>
#include <stdio.h>
#include <gl.h>
#include <glu.h>
#include <string.h>
#include <File.h>
#include <Application.h>
#include <Path.h>

#include "Global.h"
#include "WarFont.h"

WarFont::WarFont(BDirectory *dir,char *filename)
{
	BPath font_path(dir,filename);
	BBitmap *bitmap=BTranslationUtils::GetBitmapFile(font_path.Path());
	glGenTextures(1,&font_texture);

	uint32 *buffer=(uint32*)bitmap->Bits();
	for (int32 i=0;i<bitmap->BitsLength()>>2;i++)
	{
		if ( (buffer[i]&0xff00)>>8 == (buffer[i]&0xff)) buffer[i]|=0xff000000;
		else buffer[i] =0;
	}

	glBindTexture(GL_TEXTURE_2D, font_texture);

	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

// and finally, load the graphics
	glTexImage2D(GL_TEXTURE_2D, 0, 4, bitmap->Bounds().IntegerWidth()+1, bitmap->Bounds().IntegerHeight()+1, 0, GL_RGBA, GL_UNSIGNED_BYTE, bitmap->Bits());

	char_width = (bitmap->Bounds().IntegerWidth() + 1)/8;
	char_height = (bitmap->Bounds().IntegerHeight() + 1)/16;

#ifdef _MEMORY_STATISTICS_
	fprintf(stderr,"WarFont\n");
	fprintf(stderr,"   bounds: (%ld,%ld)\n",bitmap->Bounds().IntegerWidth()+1,bitmap->Bounds().IntegerHeight()+1);
	fprintf(stderr,"   texture: %ld\n",(bitmap->Bounds().IntegerWidth()+1)*(bitmap->Bounds().IntegerHeight()+1)*4);
#endif

}

WarFont::~WarFont()
{
}
