#include "WarHeapf.h"
#include "Global.h"
#include <stdlib.h>
#include <OS.h>
#include <List.h>
#include <stdio.h>

_EXPORT WarHeapf::WarHeapf(uint32 size)
{
	heap_size = size;
	heap=new entry_data[heap_size];
	Empty();

#ifdef _MEMORY_STATISTICS_
	fprintf(stderr,"WarHeap\n");
	fprintf(stderr,"  heap: %ld\n",heap_size * sizeof(entry_data));
#endif

}

_EXPORT WarHeapf::~WarHeapf()
{
	delete []heap;
}

_EXPORT void WarHeapf::Empty()
{
	element_count=0;
//	for (int32 i=0;i<heap_size;i++) heap[i].level = -1;
	for (uint32 i=0;i<heap_size;i++) heap[i].wt = 99999999999.0;
}

_EXPORT void WarHeapf::Push(uint16 x,uint16 y,uint8 level,float wt)
{
	if (element_count<heap_size-1)
		element_count++;
	heap[element_count].wt = wt;
	heap[element_count].x = x;
	heap[element_count].y = y;
	heap[element_count].level = level;
	make_float(element_count);
}

_EXPORT bool WarHeapf::Pop(uint16 *x,uint16 *y,uint8 *level,float *weight)
{
//	printf("pop: %d\n",element_count);

	if (element_count==0) return false;

	*x = heap[1].x;
	*y = heap[1].y;
	*level = heap[1].level;
	*weight = heap[1].wt;

	element_count--;

	heap[1] = heap[element_count+1];
	heap[element_count+1].level = 255;
	heap[element_count+1].wt = 99999999999.0;
	make_sink(1);

	return true;
}
