#include "WarMatrix.h"

#include <TranslationUtils.h>
#include <List.h>
#include <stdlib.h>
#include <math.h>
#include <gl.h>
#include <glu.h>

_EXPORT WarMatrix::WarMatrix(WarVertex position, WarVertex direction, WarVertex scale):
	m_position(position),
	m_direction(direction),
	m_scale(scale),
	m_locked(false)
{
}

_EXPORT WarMatrix::~WarMatrix()
{
}

_EXPORT void WarMatrix::MoveTo(WarVertex pos)
{
	if (IsLocked()) return;
	m_position = pos;
}

_EXPORT void WarMatrix::RotateTo(float xa,float ya,float za)
{
	if (IsLocked()) return;
	RotateXTo(xa);
	RotateYTo(ya);
	RotateZTo(za);
}

_EXPORT WarVertex WarMatrix::Position()
{
	return m_position;
}

_EXPORT float WarMatrix::XPosition()
{
	return m_position.x;
}

_EXPORT float WarMatrix::YPosition()
{
	return m_position.y;
}

_EXPORT float WarMatrix::ZPosition()
{
	return m_position.z;
}

_EXPORT WarVertex WarMatrix::Direction()
{
	return m_direction;
}

_EXPORT float WarMatrix::XDirection()
{
	return m_direction.x;
}

_EXPORT float WarMatrix::YDirection()
{
	return m_direction.y;
}

_EXPORT float WarMatrix::ZDirection()
{
	return m_direction.z;
}

_EXPORT WarVertex WarMatrix::Scale()
{
	return m_scale;
}

_EXPORT float WarMatrix::XScale()
{
	return m_scale.x;
}

_EXPORT float WarMatrix::YScale()
{
	return m_scale.y;
}

_EXPORT float WarMatrix::ZScale()
{
	return m_scale.z;
}
