#include <TranslationUtils.h>
#include <Bitmap.h>
#include <stdlib.h>
#include <gl.h>
#include <glu.h>
#include <string.h>
#include <File.h>
#include <Application.h>

#include "WarMouseView.h"
#include "WarObject.h"

WarMouseView::WarMouseView(int32 left,int32 top,int32 width,int32 height):WarView(left,top,width,height)
{
	m_hidden_cursor = false;
	m_locked_cursor = false;
}

WarMouseView::~WarMouseView()
{
}

void WarMouseView::Update()
{
	if (!m_hidden_cursor)
	{
		glMatrixMode( GL_PROJECTION );
		glLoadIdentity();
		glOrtho(0.0,Width()+1,0.0,Height()+1,0.0,100.0);
		glMatrixMode( GL_MODELVIEW );
//		glEnable(GL_BLEND);
//		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_TEXTURE_2D);
		glShadeModel(GL_FLAT);

		glLoadIdentity();
	
		glColor3f(1.0,1.0,1.0);

		glBegin(GL_TRIANGLES);
		glVertex2fv(m_mouse_position);
		glVertex2fv(m_mouse_position + WarPoint(5.0,-10.0));
		glVertex2fv(m_mouse_position + WarPoint(10.0,-5.0));

//		printf("mouse_pos: (%f,%f)\n",m_mouse_position.x,m_mouse_position.y);
		
		glEnd();

		glEnable(GL_DEPTH_TEST);
//		glDisable(GL_BLEND);
	}
}

void WarMouseView::MouseMoved(WarPoint point)
{
	if (!IsCursorLocked())
		SetMousePosition(point);
}
