#include "WarPoint.h"

#include <stdio.h>
#include <math.h>

_EXPORT WarPoint::WarPoint()
{
	x=0.0;
	y=0.0;
}

_EXPORT WarPoint::WarPoint(float x_,float y_)
{
	x=x_;
	y=y_;
}

_EXPORT WarPoint::operator GLfloat*()
{
	return (GLfloat*)this;
}

_EXPORT WarPoint WarPoint::operator=(WarPoint vec)
{
	x=vec.x;
	y=vec.y;
	return vec;
}

_EXPORT WarPoint &WarPoint::operator=(BPoint point)
{
	x=point.x;
	y=point.y;
	return *this;
}

_EXPORT WarPoint &WarPoint::operator=(WarPoint *vec)
{
	x=vec->x;
	y=vec->y;
	return *this;
}

_EXPORT WarPoint &WarPoint::operator+=(WarPoint vec)
{
	x+=vec.x;
	y+=vec.y;
	return *this;
}

_EXPORT WarPoint &WarPoint::operator+=(WarPoint *vec)
{
	x+=vec->x;
	y+=vec->y;
	return *this;
}

_EXPORT WarPoint WarPoint::operator+(WarPoint vec)
{
	return WarPoint(x+vec.x,y+vec.y);
}

_EXPORT WarPoint WarPoint::operator-(WarPoint vec)
{
	return WarPoint(x-vec.x,y-vec.y);
}

_EXPORT WarPoint WarPoint::operator*(int32 val)
{
	return WarPoint(x*val,y*val);
}

_EXPORT WarPoint WarPoint::operator*(float val)
{
	return WarPoint(x*val,y*val);
}

_EXPORT void WarPoint::operator*=(float val)
{
	x*=val;
	y*=val;
}

_EXPORT bool WarPoint::operator==(WarPoint vec)
{
	return x == vec.x && y == vec.y;
}

_EXPORT bool WarPoint::operator!=(WarPoint vec)
{
	return x!=vec.x || y!=vec.y;
}

_EXPORT WarPoint &WarPoint::operator/=(int32 val)
{
	x/=val;
	y/=val;
	return *this;
}

_EXPORT WarPoint WarPoint::operator-()
{
	return WarPoint(-x,-y);
}

_EXPORT WarPoint WarPoint::operator/(int32 val)
{
	return WarPoint(x/val,y/val);
}

_EXPORT float WarPoint::Angle(WarPoint point)
{
	return acos(x * point.x + y * point.y);
}

_EXPORT void WarPoint::SetTo(float nx,float ny)
{
	x=nx;
	y=ny;
}
