#include <TranslationUtils.h>
#include <Bitmap.h>
#include <stdlib.h>
#include <gl.h>
#include <glu.h>
#include <string.h>
#include <File.h>
#include <Application.h>
#include <String.h>

#include "WarGLView.h"
#include "WarSkydome.h"

WarSkydome::WarSkydome(WarWeather *weather,float detail_level)
{
	m_weather = weather;
	m_time = 0;
	
	m_display_list = generate_dome(detail_level);
}

WarSkydome::~WarSkydome()
{
	glDeleteLists(m_display_list,1);
}

GLuint WarSkydome::generate_dome(float detail_level)
{
	GLUquadricObj *quadric = gluNewQuadric();
	gluQuadricNormals(quadric,GLU_NONE);
	gluQuadricDrawStyle(quadric,GLU_FILL);
	gluQuadricOrientation(quadric,GLU_INSIDE);
	gluQuadricTexture(quadric,GL_TRUE);
	
	GLuint display_list = glGenLists(1);
	glNewList(display_list,GL_COMPILE);
	
	gluSphere(quadric,10.0,20,10);

	glEndList();

	gluDeleteQuadric(quadric);
	return display_list;
}