#include <TranslationUtils.h>
#include <Bitmap.h>
#include <stdlib.h>
#include <gl.h>
#include <glu.h>
#include <string.h>
#include <File.h>
#include <Application.h>

#include "WarStatView.h"
#include "WarObject.h"

WarStatView::WarStatView(int32 left,int32 top,int32 width,int32 height,WarFont *font):WarView(left,top,width,height)
{
	war_font = font;
}

WarStatView::~WarStatView()
{
}

void WarStatView::Update()
{
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glOrtho(0.0,Width()+1,0.0,Height()+1,0.0,100.0);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glDisable( GL_DEPTH_TEST );
	
	glColor3f(1.0,1.0,1.0);

	sprintf(tmp_string,"fps: %f",fps_counter);
	DrawString(0.0,0.0,war_font,tmp_string);

	sprintf(tmp_string,"poly: %ld",polygon_counter);
	DrawString(0.0,war_font->Height()+1,war_font,tmp_string);

	sprintf(tmp_string,"fans: %ld",fan_counter);
	DrawString(0.0,2*(war_font->Height()+1),war_font,tmp_string);

	if (fan_counter > 0)
	{
		sprintf(tmp_string,"polys/fan: %f",(float)polygon_counter/(float)fan_counter);
		DrawString(0.0,3*(war_font->Height()+1),war_font,tmp_string);
	}

	glEnable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
}
