#include <TranslationUtils.h>
#include <Bitmap.h>
#include <stdlib.h>
#include <gl.h>
#include <glu.h>
#include <string.h>
#include <File.h>
#include <Application.h>

#include "defs.h"
#include "WarStringInput.h"
#include "WarObject.h"
#include "WarGLView.h"

WarStringInput::WarStringInput(int32 left,int32 top,int32 width,int32 height,WarFont *font,WarList<char*> *command_list):
	WarInputView(left,top,width,height,font,command_list)
{
	m_command_line.SetTo("");
	SetPrompt(": ");
}

WarStringInput::~WarStringInput()
{
}

void WarStringInput::KeyDown(char key)
{
	if (key == B_RETURN)
	{
		LeaveFocus();
		Hide(true);

		int32 len = max(CommandLineLength() + 3, m_command_line.CountChars());
		char *command_line = new char[len + 1];

		command_line[0]='"';
		command_line[1]=' ';
		GetCommandLine(command_line + 2,len - 1);
		command_line[strlen(command_line)+1] = '\0';
		command_line[strlen(command_line)] = '"';

		Reset();
		m_gl_view->Parse(command_line);
		
		m_command_line.MoveInto(command_line,0,len);
		m_command_line.SetTo("");

		m_gl_view->Parse(command_line);
		delete []command_line;
	}
	else WarInputView::KeyDown(key);
}
