#include "WarView.h"
#include "WarPoint.h"
#include "WarGLView.h"

#include <gl.h>
#include <glu.h>
#include <List.h>
#include <Locker.h>
#include <stdlib.h>

WarView::WarView(int32 left,int32 top,int32 width,int32 height)
{
	WarView::Move(left,top);
	WarView::Resize(width,height);
	m_hidden = false;
}

WarView::~WarView()
{
}

// the coordinate given points at the bottom left corner of
// the first character in the string
void WarView::DrawString(float x,float y,WarFont *font,const char *string,WarVertex color)
{
	if (string == NULL) return;
	if (font == NULL) return;

	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glShadeModel(GL_FLAT);
	glBindTexture(GL_TEXTURE_2D,font->Texture());

	glColor3fv(color);

	while (*string)
	{
		char ch=*string-' ';
		float top=(ch&15)/16.0;
		float left=(ch>>4)/8.0;

		glBegin(GL_QUADS);

		glTexCoord2f(left,top + 1.0/16.0);
		glVertex2f(x,y);

		glTexCoord2f(left + 1.0/8.0,top + 1.0/16.0);
		glVertex2f(x+font->Width(),y);

		glTexCoord2f(left + 1.0/8.0,top);
		glVertex2f(x+font->Width(),y+font->Height());

		glTexCoord2f(left,top);
		glVertex2f(x,y+font->Height());

		glEnd();
		x+=font->Width();
		string++;
	}
}

void WarView::LostFocus()
{
}

void WarView::GotFocus()
{
}

void WarView::Resize(int32 width,int32 height)
{
	if( height < 1 ) m_view_height = 1;	// prevent divide-by-zero
	else m_view_height=height;
	m_view_width=width;
}

void WarView::Quit()
{
	m_gl_view->Quit(this);
}

void WarView::SetMousePosition(WarPoint position)
{
	m_gl_view->SetMousePosition(position + WarPoint(Left(),Top()));
}

void WarView::MouseDown(WarPoint point,uint8 buttons)
{
}

void WarView::MouseUp(WarPoint point,uint8 buttons)
{
}

void WarView::MouseMoved(WarPoint point)
{
}

void WarView::KeyDown(char key)
{
}

void WarView::KeyUp(char key)
{
}

void WarView::Invalidate()
{
	if (IsHidden()) return;
	glViewport( m_view_left, m_view_top, m_view_width + 1, m_view_height + 1);
	Update();
}

void WarView::LeaveFocus()
{
	m_gl_view->LeaveFocus(this);
}

void WarView::Update()
{
}

// **************************************************************************
