#include "WarWeather.h"
#include "Global.h"

#include <stdio.h>
#include <gl.h>
#include <glu.h>
#include <List.h>
#include <stdlib.h>
#include <Bitmap.h>
#include <TranslationUtils.h>

WarWeather::WarWeather(char *sky,WarColor color)
{
	BBitmap *bitmap = BTranslationUtils::GetBitmapFile(sky);

// convert to big-endian if needed
#ifdef __INTEL__
	int32 j=0;
	uint8 *buffer = (uint8*)bitmap->Bits();
	while (j<bitmap->BitsLength())
	{
		uint8 tmp = buffer[j];
		buffer[j] = buffer[j+2];
		buffer[j+2] = tmp;
		j+=4;
	}
#endif

// bind the graphics to every texture
	glGenTextures(1,&texture_id);
	glBindTexture(GL_TEXTURE_2D, texture_id);

// all the nice parameters
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

// and finally, load the graphics
	glTexImage2D(GL_TEXTURE_2D, 0, 4, bitmap->Bounds().IntegerWidth() + 1, bitmap->Bounds().IntegerHeight() + 1, 0, GL_RGBA, GL_UNSIGNED_BYTE, bitmap->Bits());

	fog_color[0] = (float)color.red/255.0;
	fog_color[1] = (float)color.green/255.0;
	fog_color[2] = (float)color.blue/255.0;
	fog_color[3] = (float)color.alpha/255.0;

#ifdef _MEMORY_STATISTICS_
	fprintf(stderr,"WarWeather\n");
	fprintf(stderr,"   texture: %ld\n",(bitmap->Bounds().IntegerWidth() + 1) * (bitmap->Bounds().IntegerHeight() + 1) * 4);
#endif
}

WarWeather::~WarWeather()
{
}
