#include "WarWindow.h"
#include "WarGLView.h"

WarWindow::WarWindow (BRect frame,char *name,bool fullscreen)
:BDirectWindow(frame,name,B_TITLED_WINDOW_LOOK,B_NORMAL_WINDOW_FEEL,B_ASYNCHRONOUS_CONTROLS)
{
	if (fullscreen || !SupportsWindowMode()) SetFullScreen(true);
	gl_view=new WarGLView(Bounds(),"OpenGL view",B_FOLLOW_ALL_SIDES/*B_FOLLOW_TOP|B_FOLLOW_LEFT*/,B_WILL_DRAW | B_FRAME_EVENTS);
	AddChild(gl_view);
	gl_view->MakeFocus();
}

WarWindow::~WarWindow()
{
}

void WarWindow::WindowActivated(bool active)
{
	gl_view->WindowActivated(active);
}

bool WarWindow::QuitRequested()
{
	gl_view->EnableDirectMode(false);
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

void WarWindow::DirectConnected(direct_buffer_info *info)
{
	gl_view->DirectConnected(info);
	gl_view->EnableDirectMode(true);
}
