#ifndef _WAR_DISPLAY_H
#define _WAR_DISPLAY_H

#include "WarMap.h"

#include <Bitmap.h>
#include <View.h>
#include <Point.h>

class WarDisplay : public BView
{
public:
	WarDisplay(BRect frame,WarMap *map);
	~WarDisplay();
	virtual void Draw(BRect);
	virtual void AttachedToWindow();
	virtual void FrameResized(float width, float height);
	virtual void KeyDown(const char *key,int32 NumBytes);
	virtual void MouseDown(BPoint point);
	virtual void MouseUp(BPoint point);
	virtual void MouseMoved(BPoint point,uint32 transit,const BMessage *message);
	void Paint(BPoint point,uint8 terrain);
	void FillMap(uint8 terrain);

	BBitmap *BitmapForTile(uint16 id);

	void CurrentBlock(uint16 id);

	int16 current_terrain;
private:

	void DrawRect(BRect rect);
	void SetBlock(uint16 x,uint16 y,uint16 block);

	int32 last_offs;
	bool drawing; // is true when the user holds the right mousebutton down
	BBitmap **gfx;
	WarTileset *tiles;

	void FixupScrollbars();
	WarMap *war_map;
};

inline void WarDisplay::CurrentBlock(uint16 id)
{
	current_terrain=id;
}

inline BBitmap *WarDisplay::BitmapForTile(uint16 id)
{
	return gfx[id%tiles->TileCount()];
}

#endif // _WAR_DISPLAY_H