#ifndef WAR_TILESET_H
#define WAR_TILESET_H

#include "WarColor.h"
#include "Global.h"

#include <File.h>

class WarTileset
{
public:
	WarTileset(BDirectory *dir,char *filename);
	~WarTileset();

	WarColor *Tile(uint16 index);
	uint8 TileType(uint16 index);
	WarColor TileColor(uint16 index);
	uint16 TileCount();
	char *Name();
private:	
	WarColor *buffer;
	uint8 *type;
	WarColor *color;
	uint16 num_blocks;
	char name[21];
	
	WarColor temp_block[BLOCK_WIDTH*BLOCK_WIDTH]; // a block used temporary for flipping and rotating blocks
};

// inline definitions

inline char *WarTileset::Name()
{
	return name;
}

#endif // #ifndef WAR_TILESET_H