#ifndef _WAR_WINDOW_H
#define _WAR_WINDOW_H

#include "WarMap.h"
#include "WarPaletteWindow.h"
#include "WarDisplay.h"

#include <Window.h>
#include <Path.h>
#include <MenuBar.h>
#include <Bitmap.h>

class WarDisplay;

class WarWindow : public BWindow
{
public:
	WarWindow(BRect frame, const char *filename=NULL);
	~WarWindow();
	// virtual void FrameMoved(BPoint scrPt);
	// virtual void FrameResized(float w, float h);
	// virtual void MenusBeginning(void);
	// virtual void MenusEnding(void);
	// virtual void Minimize(bool min);
	virtual void ScreenChanged(BRect frame, color_space mode);
	virtual void WindowActivated(bool active);
	// virtual void WorkspaceActivated(int32 workspc, bool active);
	// virtual void WorkspaceChanged(int32 oldworkspc, int32 newworkspc);
	// virtual void Zoom(BPoint lefttop, float wide, float high);
	virtual void MessageReceived(BMessage *message);
	WarTileset *Tileset();
	BBitmap *BitmapForTile(uint16 id);

	void CurrentBlock(uint16 id);

	void RedoSizes(void);
	void CurrentFile(char *filename);
private:
	BFilePanel *save; // the save-panel

	char file_name[B_FILE_NAME_LENGTH]; // the current filename
	BDirectory *file_dir; // the directory where the current file lies

	BMenuBar *menu; // the menu
	WarDisplay *war_display; // the display
	WarMap *war_map; // the map object
	BMenuItem *save_item;
};

inline void WarWindow::CurrentBlock(uint16 id)
{
	war_display->CurrentBlock(id);
}

inline WarTileset *WarWindow::Tileset()
{
	return war_map->Tileset();
}

inline BBitmap *WarWindow::BitmapForTile(uint16 id)
{
	return war_display->BitmapForTile(id);
}

#endif // _WAR_WINDOW_H
