#ifndef _MAIN_H
#define _MAIN_H

#define APP_NAME "WarEditor"
#define APP_SIG "application/x-vnd.Arvid Norberg-WarEditor"

#include "WarPaletteWindow.h"

#include <Application.h>
#include <FilePanel.h>

#define NUM_INIT_BLOCKS 8
#define NUM_BLOCKS_PER_TERRAIN 142

#define WAR_NEW_FILE  'newf'
#define WAR_OPEN_FILE 'open'
#define WAR_SAVE_FILE 'save'
#define WAR_SAVE_AS   'svas'
#define WAR_FILL_MAP  'fill'

// This is the amount of space on the screen that needs to be accounted for by title bars and borders
#define CRUFT_SIZE_X 12
#define CRUFT_SIZE_Y 32

class WarApp:public BApplication
{
public:
	WarApp();
	virtual ~WarApp();
	virtual void AboutRequested();
	virtual void ArgvReceived(int32 argc, char **argv);
	virtual void ReadyToRun();
	virtual void Pulse();
	virtual bool QuitRequested();
	virtual void RefsReceived(BMessage *message);
	virtual void MessageReceived(BMessage *message);

	WarPaletteWindow *palette;
private:
	BFilePanel *load;
};

#endif // _MAIN_H
