#include <stdio.h>
#include <string.h>

#include <Screen.h>
#include <MenuItem.h>
#include <NodeInfo.h>
#include <TextView.h>
#include <ScrollView.h>
#include <TranslationUtils.h>
#include <Message.h>

#include "WarBlockButton.h"
#include "main.h"
#include "WarPaletteWindow.h"
#include "WarDisplay.h"
#include "Global.h"

WarPaletteWindow::WarPaletteWindow(BRect frame) : BWindow(frame, APP_NAME, B_FLOATING_WINDOW_LOOK,B_FLOATING_APP_WINDOW_FEEL, B_WILL_ACCEPT_FIRST_CLICK + B_CURRENT_WORKSPACE)
{
}

WarPaletteWindow::~WarPaletteWindow()
{
}

void WarPaletteWindow::NewTarget(WarWindow *target)
{
	if (target == window) return;
	window=target;
	tiles=window->Tileset();
	BView *view;
	while (view=ChildAt(0)) RemoveChild(view);
	
	BMessage *message;
	uint16 i=0;
	for (float y=0.0;y<tiles->TileCount()*BLOCK_WIDTH/8;y+=BLOCK_WIDTH)
	{
		for (float x=0.0;x<8*BLOCK_WIDTH;x+=BLOCK_WIDTH)
		{
			message=new BMessage('nblk');
			message->AddInt16("block_id",i);
			AddChild((BView*)new WarBlockButton(BPoint(x,y),window->BitmapForTile(i),i,message));
			i++;
		}
	}
}

void WarPaletteWindow::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	case 'nblk':
	{
		int16 id;
		message->FindInt16("block_id",&id);
		window->CurrentBlock(id);
	}break;
	case WAR_NEW_TARGET:
	{
		printf("NEW_TARGET\n");
		WarWindow *target;
		message->FindPointer((char*)"target",(void**)&target);
		NewTarget(target);
	}break;
	default:
		BWindow::MessageReceived(message);
	}
}

bool WarPaletteWindow::QuitRequested()
{
	Hide();
	return false;
}