#ifndef _WAR_CLI_
#define _WAR_CLI_
#include <gl.h>

#include "WarList.h"
#include "WarView.h"
#include "WarObject.h"
#include "WarFont.h"

class WarCli: public WarView
{
public:
	WarCli(int32 left,int32 top,int32 width,int32 height,WarFont *font,WarList *command_list);
	virtual ~WarCli();

	void GetCommandLine(char *buffer,uint32 size);
	void GetPrompt(char *buffer,uint32 size);

	void SetPrompt(char *string);
	void Reset();

	virtual void Resize(int32 width,int32 height);
	virtual void KeyDown(char key);

	void SetCursorType(uint8 type);
	uint8 CursorType();

protected:
	virtual void Update();
private:
	WarFont *war_font;

	char *command_line;	// the line the user is typing to.
	uint16 command_len; // the length of the command_line, is zero before the user has typed anything
	uint16 scroll_offset; // the number of caracters that has been scrolled out on the left side

	char prompt[30];
	uint16 prompt_len;
	
	WarList *word_list;

	char *history[256]; // the history list works as a ringbuffer
	uint8 history_position; //the position in the history buffer
	uint8 history_end; // the end of the list, every command line is appended into the buffer
	
	uint16 cursor_position; // the position of the cursor in the string

	uint32 speed; // the blink speed, a ,low number gives a faster blinking.
	
	uint8 cursor_type; // 0: BLOCK 1: PIPE 2: UNDERSCORE
};

inline void WarCli::SetCursorType(uint8 type)
{
	if (type < 3) cursor_type = type;
	else cursor_type = 0;
}

inline uint8 WarCli::CursorType()
{
	return cursor_type;
}

#endif // WAR_CLI_