#ifndef _WAR_SPLINE_
#define _WAR_SPLINE_

#include "WarList.h"

class WarSpline
{
public:
	WarSpline();
	virtual ~WarSpline();

	void Loop(bool l);

	// add and delete is at end of array
	// and time is not deltatime, but has to be 
	// a time larger than the time that the
	// key before the added one has.
	void AddKey(float val, float time);

	// deletes the last key
	void DelKey();

	virtual float Value(float time);

protected:

	float LoopedTime(float time);

	WarList *key_list;

	struct Key
	{
		float val;
		float time;
	};
	bool loop;

	float start,end;
};

#endif // _WAR_SPLINE_

