#ifndef _WAR_VIEW_
#define _WAR_VIEW_

#include <GraphicsCard.h>
#include <List.h>

class WarView
{
friend class WarGLView;
public:
	WarView(int32 left,int32 top,int32 width,int32 height);
	virtual ~WarView();

	virtual void Resize(int32 width,int32 height);
	void Move(int32 x,int32 y);

	void Invalidate();

	void Hide(bool hidden);
	bool IsHidden();

	int32 Left();
	int32 Top();
	int32 Right();
	int32 Bottom();
	int32 Width();
	int32 Height();

	virtual void SetMousePosition(BPoint position);

	virtual void MouseDown(BPoint point,uint8 button);
	virtual void MouseUp(BPoint point,uint8 button);
	virtual void MouseMoved(BPoint point);
	
	virtual void KeyDown(char key);
	virtual void KeyUp(char key);

protected:
	virtual void Update();
	WarGLView *gl_view;
private:
	bool hidden;

	int32 view_left,view_top,view_width,view_height;
};

// inline definitions
inline int32 WarView::Left()
{
	return view_left;
}

inline int32 WarView::Top()
{
	return view_top;
}

inline int32 WarView::Right()
{
	return view_left+view_width-1;
}

inline int32 WarView::Bottom()
{
	return view_top+view_height-1;
}

inline int32 WarView::Width()
{
	return view_width;
}

inline int32 WarView::Height()
{
	return view_height;
}

inline void WarView::Move(int32 x,int32 y)
{
	view_left=x;
	view_top=y;
}

inline void WarView::Hide(bool hide)
{
	hidden=hide;
}

inline bool WarView::IsHidden()
{
	return hidden;
}

#endif // #ifndef _WAR_VIEW_