#include "WarBody.h"
#include "WarMap.h"
#include "WarColor.h"
#include "WarEntityList.h"
#include "WarBuffer.h"

_EXPORT WarBody::WarBody(float x,float y,float z,uint16 direction,uint8 team_id,WarColor color,WarMap *map,uint16 id,WarObject *model):WarObject(model)
{
	team=team_id;
	unit_id=id;
	color=color;

	MoveTo(x,y,z);
}

_EXPORT WarBody::WarBody(WarBuffer *buffer,WarObject *model):WarObject(model)
{
	float x,y,z;
	team=buffer->PopUint8();
	unit_id=buffer->PopUint16();
// position
	x=buffer->PopFloat();
	y=buffer->PopFloat();
	z=buffer->PopFloat();
	MoveTo(x,y,z);
// rotation
	x=buffer->PopFloat();
	y=buffer->PopFloat();
	z=buffer->PopFloat();
	RotateTo(WarVertex(x,y,z));
// scale
	x=buffer->PopFloat();
	y=buffer->PopFloat();
	z=buffer->PopFloat();
	ScaleTo(WarVertex(x,y,z));
}

_EXPORT WarBody::~WarBody()
{
}

_EXPORT void WarBody::MoveTo(float x,float y,float z)
{
	WarObject::MoveTo(WarVertex(x,y,z));
	block_x=(int)x/BLOCK_WIDTH;
	block_y=(int)y/BLOCK_WIDTH;
}

_EXPORT void WarBody::Vision(uint16 x,uint16 y,WarMap *map,uint8 flag)
{
}

_EXPORT void WarBody::Flatten(WarBuffer *buffer)
{
	buffer->PushUint8(team);
	buffer->PushUint16(unit_id);
// position
	buffer->PushFloat(XPosition());
	buffer->PushFloat(YPosition());
	buffer->PushFloat(ZPosition());
// rotation
	buffer->PushFloat(XDirection());
	buffer->PushFloat(YDirection());
	buffer->PushFloat(ZDirection());
// scale
	buffer->PushFloat(XScale());
	buffer->PushFloat(YScale());
	buffer->PushFloat(ZScale());
}

// ------------------------------------------
_EXPORT void WarBody::MessageReceived(WarBuffer *message)
{
}

_EXPORT void WarBody::Cycle(void **data,float frame_time)
{
}

// ------------------------------------------

_EXPORT uint16 WarBody::MaxValue(uint8 index)
{
	return 0;
}

_EXPORT uint16 WarBody::Value(uint8 index)
{
	return 0;
}

// ------------------------------------------

_EXPORT void WarBody::Select(bool is)
{
}

_EXPORT bool WarBody::IsSelected()
{
	return false;
}

// ------------------------------------------

uint8 WarBody::JoinedToGroup()
{
	return -1;
}

void WarBody::LeaveGroup()
{
}

void WarBody::JoinGroup(uint8 group)
{
}
