#include <stdlib.h>
#include <Message.h>
#include <List.h>

#include "WarBrain.h"
//#include "NetDefs.h"
#include "WarMap.h"
#include "WarEntityList.h"
#include "WarPathfinder.h"
//#include "Client2Server.h"
#include "WarMessage.h"

bool free_mission(void *data_ptr);

bool free_mission(void *data_ptr)
{
	delete ((WarMessage*)data_ptr);
	return false;
}

_EXPORT WarBrain::WarBrain(WarMap *m,WarEntityList *ul,uint8 unit_team,uint16 unit_id,int32 x,int32 y,WarBody *your_body,WarServer *server)
{
	id=unit_id;
	ulist=ul;
	team=unit_team;
	map=m;
	war_server=server;
	map->Lock();
	map->Unlock();
	mission_list=new BList(1);
	unit_x=x>>BLOCK_SHIFT;
	unit_y=y>>BLOCK_SHIFT;
}

_EXPORT WarBrain::~WarBrain()
{
	mission_list->DoForEach(free_mission);
	if (mission_list) delete mission_list;
}

// ------------------------------------------

uint16 WarBrain::LoadUnit(char *filename)
{
//	return war_messenger->LoadUnit(filename);
}

uint16 WarBrain::AddUnit(int32 x,int32 y,uint16 type,uint8 team,uint8 angle)
{
//	return war_messenger->AddUnit(x,y,type,team,angle);
}

uint16 WarBrain::AddUnit(int32 x,int32 y,uint16 type,uint8 team)
{
//	return war_messenger->AddUnit(x,y,type,team);
}

uint16 WarBrain::AddUnit(int32 x,int32 y,uint16 type)
{
//	return war_messenger->AddUnit(x,y,type);
}

_EXPORT void WarBrain::ExecuteFunction(uint8 index,uint32 param1,uint32 param2)
{
//	war_messenger->ExecuteFunction(id,index,param1,param2);
}

_EXPORT void WarBrain::MoveUnit(int32 x,int32 y,uint16 speed)
{
//	war_messenger->Move(id,x,y,speed);
}

_EXPORT void WarBrain::Rotate(uint8 index,uint16 direction,uint16 speed)
{
//	war_messenger->Rotate(id,index,direction,speed);
}

_EXPORT void WarBrain::SetMaxValue(uint8 index,uint16 amount)
{
//	war_messenger->SetMaxValue(id,index,amount);
}

_EXPORT void WarBrain::SetValue(uint8 index,uint16 amount)
{
//	war_messenger->SetValue(id,index,amount);
}

_EXPORT bool WarBrain::OccupyBlock(uint16 x,uint16 y)
{
//	return war_messenger->OccupyBlock(id,x,y);
}

_EXPORT void WarBrain::RemoveOccupation(uint16 x,uint16 y)
{
//	war_messenger->RemoveOccupation(id,x,y);
}

_EXPORT void WarBrain::DisplayMessage(char *message)
{
//	war_messenger->DisplayMessage(Team(),message);
}

_EXPORT WarPathfinder *WarBrain::NewPathfinder()
{
//	return war_messenger->NewPathfinder(team,unit_x,unit_y);
}

_EXPORT uint16 WarBrain::LoadSound(char *filename)
{
//	return war_messenger->LoadSound(filename);
}

_EXPORT void WarBrain::PlaySound(uint16 sound_id)
{
//	war_messenger->PlaySound(id,sound_id);
}

_EXPORT void WarBrain::PostMessage(uint16 x,uint16 y,WarMessage *message,bigtime_t timestamp)
{
	message->sender=id;
//	war_messenger->PostMessage(x,y,message,timestamp);
}

_EXPORT void WarBrain::PostMessage(uint16 dest_id,WarMessage *message,bigtime_t timestamp)
{
	message->sender=id;
//	war_messenger->PostMessage(dest_id,message,timestamp);
}

_EXPORT void WarBrain::Damage(uint16 x,uint16 y,uint16 damage,damage_type type)
{
//	war_messenger->Damage(id,x,y,damage,type);
}

_EXPORT void WarBrain::Damage(uint16 dest_id,uint16 damage,damage_type type)
{
//	war_messenger->Damage(id,dest_id,damage,type);
}

_EXPORT bool WarBrain::Cycle(void *data,float frame_time)
{
	return false;
}

_EXPORT void WarBrain::MessageReceived(WarMessage *message)
{
}

_EXPORT bool WarBrain::Land()
{
//	war_messenger->Land(id);
	return true;
}

_EXPORT void WarBrain::TakeOff()
{
//	war_messenger->TakeOff(id);
}

_EXPORT void WarBrain::GetPosition(uint16 *x,uint16 *y)
{
	// !!!
}

// **************** NON-VIRTUAL FUNCTIONS ******************

_EXPORT uint8 WarBrain::ATan(int8 x,int8 y)
{
	if (x>0)
	{
		if (y==0) return 4;
		else if (y>0) return 3;
		else if (y<0) return 5;
	}
	else if (x<0)
	{
		if (y==0) return 0;
		else if (y>0) return 1;
		else if (y<0) return 7;
	}
	else if (x==0)
	{
		if (y<0) return 6;
		else if (y>0) return 2;
	}
	return 0;
}

_EXPORT void WarBrain::AddMission(WarMessage *mission,bool add)
{
	if (!add)
	{
		mission_list->DoForEach(free_mission);
		mission_list->MakeEmpty();
	}
	mission_list->AddItem(mission);
}

_EXPORT bool WarBrain::GetMission(uint16 index,WarMessage **mission)
{
	WarMessage *message;
	if ((message=(WarMessage*)mission_list->ItemAt(index)))
	{
		*mission=message;
		return true;
	}
	return false;
}
