#include <TranslationUtils.h>
#include <Bitmap.h>
#include <stdlib.h>
#include <gl.h>
#include <glu.h>
#include <string.h>
#include <File.h>
#include <Application.h>
#include <Path.h>

#include "WarFont.h"

WarFont::WarFont(BDirectory *dir,char *filename)
{
	BPath font_path(dir,filename);
	BBitmap *bitmap=BTranslationUtils::GetBitmapFile(font_path.Path());
	glGenTextures(1,&font_texture);

	uint32 *buffer=(uint32*)bitmap->Bits();
	for (int32 i=0;i<bitmap->BitsLength()>>2;i++)
	{
		if (buffer[i] != 0xff00) buffer[i]|=0xff000000;
		else buffer[i] =0;
	}

	glBindTexture(GL_TEXTURE_2D, font_texture);

	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

// no nice filers here yet. Just to gain some speed
//	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
//	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

// and finally, load the graphics
//	glTexImage2D(GL_TEXTURE_2D, 0, 3, 64, 96, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
	glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, bitmap->Bits());
//	glTexImage2D(GL_TEXTURE_2D, 0, 3, bitmap->Bounds().IntegerWidth(),bitmap->Bounds().IntegerHeight(), 0, GL_RGBA, GL_UNSIGNED_BYTE, bitmap->Bits());

	char_width = bitmap->Bounds().IntegerWidth()/8;
	char_height = bitmap->Bounds().IntegerHeight()/12;
}

WarFont::~WarFont()
{
}

void WarFont::DrawString(float x,float y,char *string)
{
	if (string == NULL) return;
//	glColor3f(1.0,0.5,0.2);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glShadeModel(GL_FLAT);
	glBindTexture(GL_TEXTURE_2D,font_texture);

	while (*string)
	{
		char ch=*string-' ';
		float top=(ch&15)/16.0;
		float left=(ch>>4)/8.0;

		glBegin(GL_QUADS);

		glTexCoord2f(left,top + 1.0/16.0);
		glVertex2f(x,y);

		glTexCoord2f(left,top);
		glVertex2f(x,y+char_height);

		glTexCoord2f(left + 1.0/8.0,top);
		glVertex2f(x+char_width,y+char_height);

		glTexCoord2f(left + 1.0/8.0,top + 1.0/16.0);
		glVertex2f(x+char_width,y);

		glEnd();
		x+=char_width;
		string++;
	}
}
