#include "WarHeap.h"
#include "Global.h"
#include <stdlib.h>
#include <OS.h>
#include <List.h>
#include <stdio.h>

_EXPORT WarHeap::WarHeap(uint16 size)
{
	heap_size=size;
	heap=new entry_data[heap_size];
	EmptyQueue();
}

_EXPORT WarHeap::~WarHeap()
{
	delete [] heap;
}

_EXPORT void WarHeap::EmptyQueue()
{
	element_count=0;
	uint16 i;
	for (i=0;i<heap_size;i++)
		heap[i].wt=WAR_INFINITE_TIMEOUT;
}

_EXPORT void WarHeap::Push(void *ptr,bigtime_t wt)
{
	if (element_count<heap_size-1)
		element_count++;
	heap[element_count].wt=wt;
	heap[element_count].ptr=ptr;
	make_float(element_count);
}

_EXPORT void WarHeap::Push(uint16 x,uint16 y,bigtime_t wt)
{
	if (element_count<heap_size-1)
		element_count++;
	heap[element_count].wt=wt;
//	fprintf(stderr,"WarHeap: pushed weight[%d]\n",heap[element_count].wt<<32);
	heap[element_count].ptr=(void*)((uint32)(y<<16)+x);
	make_float(element_count);
}

_EXPORT bool WarHeap::Pop(void **ptr)
{
	if (element_count==0) return false;

	*ptr=heap[1].ptr;

	if (element_count!=1)
	{
		heap[1].ptr=heap[element_count].ptr;
		heap[1].wt=heap[element_count].wt;
		heap[element_count].wt=WAR_INFINITE_TIMEOUT;
		make_sink(1);
	}
	else
	{
		heap[1].wt=WAR_INFINITE_TIMEOUT;
	}
	element_count--;

	return true;
}

_EXPORT bool WarHeap::Pop(uint16 *x,uint16 *y)
{
	if (element_count==0) return false;

//	fprintf(stderr,"WarHeap: Pop(%x)\n",(uint32)heap[1].ptr);

	*x=((uint32)heap[1].ptr)&0xffff;
	*y=((uint32)heap[1].ptr)>>16;

	if (element_count!=1)
	{
		heap[1].ptr=heap[element_count].ptr;
		heap[1].wt=heap[element_count].wt;
		heap[element_count].wt=WAR_INFINITE_TIMEOUT;
		make_sink(1);
	}
	else
	{
		heap[1].wt=WAR_INFINITE_TIMEOUT;
	}
	element_count--;

	return true;
}
