#include "WarMatrix.h"
#include "WarGLView.h"
#include "WarMap.h"
#include "defs.h"

#include <TranslationUtils.h>
#include <List.h>
#include <stdlib.h>
#include <math.h>
#include <gl.h>
#include <glu.h>

_EXPORT WarMatrix::WarMatrix()
{
	direction.SetTo(0.0,0.0,0.0);
	position.SetTo(0.0,0.0,0.0);
	scale.SetTo(0.0,0.0,0.0);
}

_EXPORT WarMatrix::WarMatrix(WarVertex pos)
{
	direction.SetTo(0.0,0.0,0.0);
	position = pos;
	scale.SetTo(0.0,0.0,0.0);
}

_EXPORT WarMatrix::~WarMatrix()
{
}

_EXPORT void WarMatrix::MoveTo(WarVertex pos)
{
	if (IsLocked()) return;
	position=pos;
}

_EXPORT void WarMatrix::RotateTo(float xa,float ya,float za)
{
	if (IsLocked()) return;
	RotateXTo(xa);
	RotateYTo(ya);
	RotateZTo(za);
}
