#include "app.h"
#include <stdio.h>

// APPLICATION

App::App(const char *sig):BApplication(sig)
{
}

void App::ReadyToRun()
{
	window=new Win(BRect (100,100,500,500),"miniprojekt: Mandelbrot");
	view=new View(BRect(0,0,400,400),"mandelview");
	window->AddChild(view);
	window->Show();
}

// VIEW

View::View(BRect bounds,const char *name):BView(bounds,name,B_FOLLOW_ALL_SIDES,B_WILL_DRAW|B_FRAME_EVENTS)
{
	bitmap=new BBitmap(BRect(0,0,400,400),B_RGB32);
	uint16 x,y;
	uint16 tmp;
	rgb_color color;
	rgb_color *bits=(rgb_color*)bitmap->Bits();
	for (y=0;y<400;y++)
		for (x=0;x<bitmap->BytesPerRow()>>2;x++)
		{
//			tmp=(uint8)Iterate(complex((double)(x-1600)/1500,(double)(y-650)/1500));
			tmp=Iterate(complex((double)(x-300)/180,(double)(y-200)/180));
			color.red=tmp;
			color.green=tmp;
			color.blue=tmp;
			color.alpha=0;
			bits[y*(bitmap->BytesPerRow()>>2)+x]=color;
		}
}

View::~View()
{
	delete bitmap;
}

void View::FrameResized(float width,float height)
{
	printf("FrameResized\n");
}

void View::Draw(BRect bounds)
{
	DrawBitmap(bitmap,BPoint(0,0));
}

uint8 Iterate(complex c)
{
	complex z(0,0); // initzialize z to (0,0)
	uint16 n; // the iteration counter

	const float R=2; // the abs threshold
	const uint16 N=256; // the number of iterations

	for (n=0;n<N;n++) // iterate N times
	{
		z=z*z+c;
		if (z.abs()>R) return 255-n;
	}
	return 0; // black
}

// WINDOW

Win::Win(BRect bounds,const char *title):BWindow(bounds,title,B_TITLED_WINDOW_LOOK,B_NORMAL_WINDOW_FEEL,B_NOT_RESIZABLE)
{
}

bool Win::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

