#include "complex.h"
#include <stdio.h>

complex::complex()
{
	x=y=0;
}

complex::complex(double j,double k)
{
	x=j;
	y=k;
}

complex::complex(complex &value)
{
	x=value.x;
	y=value.y;
}

float complex::abs()
{
	return sqrt(x*x+y*y);
}

void complex::PrintToStream()
{
	printf("complex: (%f,%f)\n",x,y);
}

complex &complex::operator=(const complex &value)
{
	x=value.x;
	y=value.y;
	return *this;
}

complex &complex::operator*(const complex &value)
{
	complex result(value.x*x-value.y*y,x*y+value.x*value.y);
	return result;
}

complex &complex::operator/(const complex &value)
{
	complex result(x/value.x,y/value.y);
	return result;
}

complex &complex::operator+(const complex &value)
{
	complex result(value.x+x,value.y+y);
	return result;
}

complex &complex::operator-(const complex &value)
{
	complex result(x-value.x,y-value.y);
	return result;
}

complex &complex::operator+=(const complex &value)
{
	x+=value.x;
	y+=value.y;
	return *this;
}

complex &complex::operator-=(const complex &value)
{
	x-=value.x;
	y-=value.y;
	return *this;
}
