#ifndef _WAR_BITMAP_
#define _WAR_BITMAP_

#include <GraphicsCard.h>

#include "WarColor.h"

#ifndef min
	#define min(a,b) ((a)<(b)?(a):(b))
#endif
#ifndef max
	#define max(a,b) ((a)>(b)?(a):(b))
#endif


class WarBitmap
{
public:
	WarBitmap(uint16 width,uint16 height);
	WarBitmap(const char *filename);
	virtual ~WarBitmap();

	uint16 Width();
	uint16 Height();

	void Empty();

	void DrawBitmap(int16 left,int16 top,WarBitmap *bitmap);

	WarColor *Bits();

protected:
	WarColor *frame_buffer;

	int16 clp_left,clp_top,clp_right,clp_bottom;

private:
	uint16 frame_width,frame_height;
};

// inline definitions
inline uint16 WarBitmap::Width()
{
	return frame_width;
}

inline uint16 WarBitmap::Height()
{
	return frame_height;
}

inline WarColor *WarBitmap::Bits()
{
	return frame_buffer;
}

#endif // #ifndef _WAR_BITMAP_
