#ifndef _WAR_MATERIAL_H_
#define _WAR_MATERIAL_H_

#include "WarColor.h"

#include <OS.h>

enum material_flags
{
	MATERIAL_NO_SHADE=0, //--
	MATERIAL_FLATSHADE=1,
	MATERIAL_GOURAUD=2,

	MATERIAL_TEXTURED				= 4 + MATERIAL_NO_SHADE, //--
	MATERIAL_TEXTURED_FLATSHADE= 4 + MATERIAL_FLATSHADE,
	MATERIAL_TEXTURED_GOURAUD	= 4 + MATERIAL_GOURAUD,

	MATERIAL_ENVMAPPED				= 8 + MATERIAL_NO_SHADE, //--
	MATERIAL_ENVMAPPED_FLATSHADE	= 8 + MATERIAL_FLATSHADE,
	MATERIAL_ENVMAPPED_GOURAUD		= 8 + MATERIAL_GOURAUD,

	MATERIAL_ADD_NO_SHADE	= 16 + MATERIAL_NO_SHADE, //--
	MATERIAL_ADD_FLATSHADE	= 16 + MATERIAL_FLATSHADE,
	MATERIAL_ADD_GOURAUD		= 16 + MATERIAL_GOURAUD,

	MATERIAL_ADD_TEXTURED				= 16 + MATERIAL_TEXTURED, //--
	MATERIAL_ADD_TEXTURED_FLATSHADE	= 16 + MATERIAL_TEXTURED_FLATSHADE,
	MATERIAL_ADD_TEXTURED_GOURAUD		= 16 + MATERIAL_TEXTURED_GOURAUD,

	MATERIAL_ADD_ENVMAPPED				= 16 + MATERIAL_ENVMAPPED, //--
	MATERIAL_ADD_ENVMAPPED_FLATSHADE	= 16 + MATERIAL_ENVMAPPED_FLATSHADE,
	MATERIAL_ADD_ENVMAPPED_GOURAUD	= 16 + MATERIAL_ENVMAPPED_GOURAUD,
};

class WarMaterial
{
public:
	WarMaterial();

	material_flags type;

	WarColor color;
	WarColor *texture;
};

#endif // _WAR_MATERIAL_H_
