#ifndef _WAR_REGION_
#define _WAR_REGION_

#include <stdio.h>

class WarRect
{
public:
	WarRect();
	WarRect(int32 top,int32 left,int32 right,int32 bottom);
	WarRect(WarRect *region);
	~WarRect();

	int32 Left();
	int32 Top();
	int32 Right();
	int32 Bottom();
	
	void PrintToStream();

	void SetTo(int32 top,int32 left,int32 right,int32 bottom);

	void OffsetBy(int32 x,int32 y);

	int32 left,top,right,bottom;
};

// inline definitions

inline WarRect::WarRect()
{
	left=top=right=bottom=0;
}

inline WarRect::WarRect(int32 left_,int32 top_,int32 right_,int32 bottom_)
{
	SetTo(left_,top_,right_,bottom_);
}

inline WarRect::WarRect(WarRect *region)
{
	left=region->Left();
	top=region->Top();
	right=region->Right();
	bottom=region->Bottom();
}

inline void WarRect::SetTo(int32 left_,int32 top_,int32 right_,int32 bottom_)
{
	left=left_;
	top=top_;
	right=right_;
	bottom=bottom_;
}

inline WarRect::~WarRect()
{
}

inline int32 WarRect::Left()
{
	return left;
}

inline int32 WarRect::Top()
{
	return top;
}

inline int32 WarRect::Right()
{
	return right;
}

inline int32 WarRect::Bottom()
{
	return bottom;
}

inline void WarRect::OffsetBy(int32 x,int32 y)
{
	left+=x;
	right+=x;
	top+=y;
	bottom+=y;
}

inline void WarRect::PrintToStream()
{
	printf("WarRect (%ld,%ld)(%ld,%ld)\n",left,top,right,bottom);
}

#endif // #ifndef _WAR_REGION_