#ifndef _WAR_VERTEX_H_
#define _WAR_VERTEX_H_

#include <OS.h>

class WarDisplay;

class WarVertex
{
public:
	WarVertex();
	WarVertex(float x,float y,float z);

	void Project();
	void Rotate(float *t,WarVertex *vec);	// only 4x4
	void RotateSimple(float *t,WarVertex *vec);	// only 4x4, but uses only the rotation part (3x3)
	void Rotate3x3(float *t,WarVertex *vec);
	void SetTo(float x,float y,float z);

	float Angle(WarVertex vertex);

	float x,y,z;	// the coordinates

	static uint16 CalcZoom(uint8 fov,uint16 screen_x,uint16 screen_y,float *vert_angle,float *horiz_angle);

	WarVertex &operator=(WarVertex &vec);
	WarVertex &operator+=(WarVertex &vec);
	WarVertex &operator/=(int32 val);
	WarVertex operator/(int32 val);
	WarVertex operator*(int32 val);
	WarVertex operator*(float val);
	WarVertex operator+(WarVertex &vec);
	WarVertex operator-(WarVertex &vec);
	bool operator==(WarVertex &vec);

	static uint16 scr_x,scr_y,zoom;
};

#endif // _WAR_VERTEX_H_
