#include "DemoScreen.h"
#include "WarBitmap.h"
#include "WarObject.h"
#include "stsp.h"

#include <stdio.h>
#include <stdlib.h>

#include <GameSoundDefs.h>
#include <MediaDefs.h>
#include <View.h>

DemoScreen::DemoScreen() :
	GameWindow(BRect(50,50,49+640,49+320),"Midwinter 00 Umeå/Sweden",false)
{
	BRect frame=Frame();
	frame.OffsetTo(0,0);
	BView *view=new BView(frame,"background view",B_FOLLOW_ALL_SIDES,0);
	AddChild(view);
	view->SetViewColor(0,0,0);

	thread_id main_thread = spawn_thread(DemoScreen::main_thread,"main_thread",B_DISPLAY_PRIORITY,(void*)this);
	resume_thread(main_thread);
}

DemoScreen::~DemoScreen()
{
}

long DemoScreen::main_thread(void *data)
{
	uint32 frames=0;
	DemoScreen *screen = (DemoScreen*)data;
	bigtime_t t=system_time()+16000;

	float frame_time = 0;
	float time = 0;

	WarBitmap main_buffer(screen->FrameWidth(),screen->FrameHeight());
	WarBitmap bg("bg.jpg");

	bigtime_t total_time=system_time();
	
	while(screen->DrawBuffer((void*)main_buffer.Bits()))
	{
		frames++;

		frame_time = (system_time()-t)/1000000.0;
		time += frame_time;
		t=system_time();

		main_buffer.Empty();
		main_buffer.DrawBitmap(sin(time)*40,cos(time)*40,&bg);
	}
	total_time=system_time() - total_time;
	float bigtime=total_time/1000000.0;
	printf("drew %ld frames in %f seconds. That's %f FPS\n",frames,bigtime,frames/bigtime);
	return 0;
}
