#ifndef _ST_INSTRUMENT_WINDOW_H_
#define _ST_INSTRUMENT_WINDOW_H_

#include "stTrackerControl.h"
#include "stCurveView.h"
#include "stChannelView.h"
#include "stMainWindow.h"
#include "song.h"

#include "MWindow.h"
#include "MSlider.h"
#include "MTextControl.h"

enum action
{
	ST_ADD_AMP_KNOB=0,
	ST_DELETE_AMP_KNOB,
	ST_MOVE_AMP_KNOB,

	ST_ADD_FILTER_KNOB,
	ST_DELETE_FILTER_KNOB,
	ST_MOVE_FILTER_KNOB
};

class stTrackerView;

class stInstrumentWindow: public MWindow
{
public:
	stInstrumentWindow(uint8 index, stMainWindow *main_win,BPoint point,Ins *instrument);
	~stInstrumentWindow();
	virtual bool QuitRequested();
	virtual void MessageReceived(BMessage *message);
private:
	void UpdateTitle();
		
	uint8 m_index;
	stCurveView *m_amplitude_envelope;
	stCurveView *m_filter_envelope;

	stTrackerControl *m_tracker_control;
	float m_zoom;
	Ins *m_instrument;
	stMainWindow *m_main_win;

	MTextControl *m_loop;
	
	MSlider *m_resonance;
	MSlider *m_vibrato_speed;
	MSlider *m_vibrato_depth;
	MSlider *m_pwm_speed;
	MSlider *m_pwm_depth;
};

#endif // _ST_INSTRUMENT_WINDOW_H_
