#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <string.h>
#include <time.h>
#include "board.h"

char *color_table[]={"#FFFFFF"};/*,"#AAAAAA","#888888","#666666"};*/
int color_table_and=0;

struct file_entry
{
	struct file_entry *next;
	char path[MAXPATHLEN];
	time_t time;
};

void init();
void end();
char find(char *search_string,char *text);
void arrow(char state,char *string,char *path);
void new_sign();
void draw_content(char *string,char *path,int depth);
void get_name(char *path,char *name);
void print_path(char *string,char *path,char open);
char print_file(char *file_name);
struct file_entry *find_best(struct file_entry *first_file);

int main()
{
	char string[STRING_MAX_LEN];
	int counter=0;
	char buffer;

	buffer=getc(stdin);
	while ((!feof(stdin))&&(buffer!='='))
	{
		buffer=getc(stdin);
	}

	string[counter]=getc(stdin);
	while ((!feof(stdin))&&(string[counter]!='ÿ')&&(string[counter]!=10))
	{
		counter++;
		string[counter]=getc(stdin);
	}
	string[counter]=0;

	init();
	if (!print_file(POSTINGS)) printf(POSTINGS_DEFAULT);
	printf("<p>");
	draw_content(string,"./postings",0);
	printf("</p>");
	if (!print_file(NEWS)) printf(NEWS_DEFAULT);
	printf("<p>");
	draw_content(string,"./news",0);
	printf("</p>");
	end();

}

void init()
{
	FILE *file;
	char buffer;
	printf("Content-Type: text/html\n\n");
	if (!print_file(PAGE_BEGIN)) printf(PAGE_BEGIN_DEFAULT);
}

void end()
{
	printf("<p align=center><font size=-4>This messageboard is used with permission from the author, Arvid Norberg <a href=\"mailto:arvid@iname.com\">arvid@iname.com</a></font></p>");
	if (!print_file(PAGE_END)) printf(PAGE_END_DEFAULT);
}

char print_file(char *file_name)
{
	FILE *file;
	char buffer;
	if (file=fopen(file_name,"r"))
	{
		buffer=getc(file);
		while (!feof(file))
		{
			printf("%c",buffer);
			buffer=getc(file);
		}
		fclose(file);
		return 1;
	}
	else
		return 0;
}
/*
void print_date(time_t time)
{
	const float year=
}
*/
void arrow(char state,char *string,char *path)
{
	printf("<a href=\"?data=");
	print_path(string,path,state);
	printf("\">");
	if (state)
	{
		if (!print_file(OPEN_ARROW)) printf(OPEN_ARROW_DEFAULT);
	}
	else
	{
		if (!print_file(CLOSED_ARROW)) printf(CLOSED_ARROW_DEFAULT);
	}
	printf("</a>");
}

void new_sign()
{
	print_file(NEW_SIGN);
}

char find(char *search_string,char *text)
{
	char tmp[STRING_MAX_LEN];
	int offs,offs2;

	offs=0;
	offs2=0;
	
	do
	{
		tmp[offs2]=text[offs];
		if ((text[offs]==0)||(text[offs]==';'))
		{
			tmp[offs2]=0;
			if (!strcmp(tmp,search_string))
			{
				return 1;
			}
			offs2=0;
		}
		else
			offs2+=1;
		offs+=1;
	} while (text[offs-1]!=0);
	return 0;
}

void get_name(char *path,char *output)
{
	char *name;
	int offset=0;
	char buffer;
	int out_offs=0;

	output[0]=0;
	while (path[offset]!=0)
		offset+=1;
	while ((path[offset]!='/')&&(offset>0))
		offset-=1;
	name=path+offset+1;

	offset=0;
	while (name[offset]!=0)
	{
		if (name[offset]!='%')
		{
			output[out_offs]=name[offset];
			out_offs++;
		}
		else
			if (name[offset+1]=='2')
			{
				if (name[offset+2]=='0')
				{
					output[out_offs]=' ';
					out_offs++;
					offset+=2;
				}
			}
			else
			{
				output[out_offs]=name[offset];
				out_offs++;
			}
		offset++;
	}
	output[out_offs]=0;
}

void print_path(char *string,char *path,char open)
{
	if (open)
	{
		char tmp[STRING_MAX_LEN],first=1;
		int offs,offs2;

		offs=0;
		offs2=0;

		do
		{
			tmp[offs2]=string[offs];
			if ((string[offs]==0)||(string[offs]==';'))
			{
				tmp[offs2]=0;
				if (strcmp(tmp,path))
				{
					if (!first) printf(";");
					first=0;
					printf("%s",tmp);
				}
				offs2=0;
			}
			else
				offs2+=1;
			offs+=1;
		} while (string[offs-1]!=0);
	}
	else
	{
		if (string[0]!=0)
			printf("%s;",string);
		printf("%s",path);
	}
}

void draw_content(char *string,char *path,int depth)
{
	int counter=0;
	struct dirent *entry;
	DIR *directory;
	char open;
	struct stat file_stat;
	char name[MAXPATHLEN];

	directory=opendir(path);
	if (directory)
	{
		struct file_entry *first_file=0;
		struct file_entry *file=0;
		struct file_entry *prev_file=0;

/* --- Reading directory and building directory listing ----- */

		entry=readdir(directory);
		while (entry)
		{
			if ((strcmp(entry->d_name,".")&strcmp(entry->d_name,"..")))
			{
/* Adding entry in list */
				if (!first_file)
				{
					first_file=(struct file_entry *)malloc(sizeof(struct file_entry));
					file=first_file;
					file->next=0;
				}
				else
				{
					file=(struct file_entry *)malloc(sizeof(struct file_entry));
					file->next=first_file;
					first_file=file;
				}
				strcpy(file->path,path);
				strcat(file->path,"/");
				strcat(file->path,entry->d_name);
				stat(file->path,&file_stat);
				file->time=file_stat.st_ctime;
			}
			entry=readdir(directory);
		}
		closedir(directory);
		
/* ----------- DO THE PRINTING AND THE SORTING --------*/
			
		while (first_file)
		{
			file=find_best(first_file);
			open=find(file->path,string);

			printf("<br>");

	/* ARROW */
			arrow(open,string,file->path);

	/* NAME ENTRY */
			if (!print_file(ENTRY_BEGIN)) printf(ENTRY_BEGIN_DEFAULT,color_table[depth&color_table_and]);
			get_name(file->path,name);
			printf("%s",name);
			if (!print_file(ENTRY_END)) printf(ENTRY_END_DEFAULT);
	/* DATESTAMP */
			if (!print_file(DATE_BEGIN)) printf(DATE_BEGIN_DEFAULT);
			printf("%s",ctime(&file->time));
			if (!print_file(DATE_END)) printf(DATE_END_DEFAULT);
	/* CONTENT */
			if (open)
			{
				if (!print_file(SUBDIR_BEGIN)) printf(SUBDIR_BEGIN_DEFAULT);
				draw_content(string,file->path,depth+1);
				if (!print_file(SUBDIR_END)) printf(SUBDIR_END_DEFAULT);;
			}

/* REMOVE ENTRY FROM LIST*/
			if (file==first_file)
			{
				if (first_file->next)
					first_file=file->next;
				else
					first_file=0;
				free(file);
			}
			else
			{
				prev_file=first_file;
				while (prev_file->next!=file)
					prev_file=prev_file->next;
				prev_file->next=file->next;
				free(file);
			}
		}
	}
	else
	{
/* PRINT THE FILE CONTENTS */
		if (!print_file(MESSAGE_BEGIN)) printf(MESSAGE_BEGIN_DEFAULT);
		print_file(path);
		if (!print_file(MESSAGE_END)) printf(MESSAGE_END_DEFAULT);
	}
}

struct file_entry *find_best(struct file_entry *first_file)
{
	time_t best=2147483647;
	struct file_entry *ret_file,*file;

	file=first_file;
	while (file)
	{
		if (file->time<best)
		{
			best=file->time;
			ret_file=file;
		}
		file=file->next;
	}
	if (ret_file==0) ret_file=first_file;
	return ret_file;
}
