#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <string.h>
#include <time.h>
#include "board.h"

int color_table_and=0;

struct file_entry
{
	struct file_entry *next;
	char path[MAXPATHLEN];
	time_t time;
};

void init();
void end();
char find(char *search_string,char *text);
void draw_content(char *path,int depth);
void get_name(char *path,char *name);
void get_email(char *file_name,char *string);
void get_web(char *filename,char *string);
void print_message(char *filename);
char print_file(char *file_name);
struct file_entry *find_best(struct file_entry *first_file);

int main()
{
/*
	char string[STRING_MAX_LEN];
	int counter=0;
	char buffer;

	buffer=getc(stdin);
	while ((!feof(stdin))&&(buffer!='='))
	{
		buffer=getc(stdin);
	}

	string[counter]=getc(stdin);
	while ((!feof(stdin))&&(string[counter]!='ÿ')&&(string[counter]!=10))
	{
		counter++;
		string[counter]=getc(stdin);
	}
	string[counter]=0;
*/
	init();
	draw_content("./postings",0);
	printf("</p>");
	end();
}

void init()
{
	if (!print_file(PAGE_BEGIN)) printf(PAGE_BEGIN_DEFAULT);
}

void end()
{
	printf("<p align=center><font size=-4>This messageboard is used with permission from the author, Arvid Norberg <a href=\"mailto:arvid@iname.com\">arvid@iname.com</a></font></p>");
	if (!print_file(PAGE_END)) printf(PAGE_END_DEFAULT);
}

char print_file(char *file_name)
{
	FILE *file;
	char buffer;
	if (file=fopen(file_name,"r"))
	{
		buffer=getc(file);
		while (!feof(file))
		{
			printf("%c",buffer);
			buffer=getc(file);
		}
		fclose(file);
		return 1;
	}
	else
		return 0;
}

void get_name(char *path,char *output)
{
	char *name;
	int offset=0;
	char buffer;
	int out_offs=0;

	output[0]=0;
	while (path[offset]!=0)
		offset+=1;
	while ((path[offset]!='/')&&(offset>0))
		offset-=1;
	name=path+offset+1;

	offset=0;
	while (name[offset]!=0)
	{
		if (name[offset]!='%')
		{
			output[out_offs]=name[offset];
			out_offs++;
		}
		else
			if (name[offset+1]=='2')
			{
				if (name[offset+2]=='0')
				{
					output[out_offs]=' ';
					out_offs++;
					offset+=2;
				}
			}
			else
			{
				output[out_offs]=name[offset];
				out_offs++;
			}
		offset++;
	}
	output[out_offs]=0;
}

void get_email(char *filename,char *string)
{
	FILE *file;
	char buffer;

	string[0]=0;
	if (file=fopen(filename,"r"))
	{
		int i=0;
		buffer=getc(file);
		while (!feof(file)&&buffer!='\n')
		{
			string[i++]=buffer;
			buffer=getc(file);
		}
		string[i]=0;
		fclose(file);
	}
}

void get_web(char *filename,char *string)
{
	FILE *file;
	char buffer;

	string[0]=0;
	if (file=fopen(filename,"r"))
	{
		int i=0;
		buffer=getc(file);
		while (!feof(file)&&buffer!='\n')
			buffer=getc(file);

		buffer=getc(file);
		while (!feof(file)&&buffer!='\n')
		{
			string[i++]=buffer;
			buffer=getc(file);
		}
		string[i]=0;
		fclose(file);
	}
}

void print_message(char *filename)
{
	FILE *file;
	char buffer;
	if (file=fopen(filename,"r"))
	{
		int i;
		for (i=0;i<2;i++)
		{
			buffer=getc(file);
			while (!feof(file)&&buffer!='\n')
				buffer=getc(file);
		}

		buffer=getc(file);
		while (!feof(file))
		{
			printf("%c",buffer);
			buffer=getc(file);
		}
		fclose(file);
	}
}

void draw_content(char *path,int depth)
{
	int counter=0;
	struct dirent *entry;
	DIR *directory;
	struct stat file_stat;
	char name[MAXPATHLEN];
	char string[512];

	directory=opendir(path);
	if (directory)
	{
		struct file_entry *first_file=0;
		struct file_entry *file=0;
		struct file_entry *prev_file=0;

/* --- Reading directory and building directory listing ----- */

		entry=readdir(directory);
		while (entry)
		{
			if ((strcmp(entry->d_name,".")&strcmp(entry->d_name,"..")))
			{
/* Adding entry in list */
				if (!first_file)
				{
					first_file=(struct file_entry *)malloc(sizeof(struct file_entry));
					file=first_file;
					file->next=0;
				}
				else
				{
					file=(struct file_entry *)malloc(sizeof(struct file_entry));
					file->next=first_file;
					first_file=file;
				}
				strcpy(file->path,path);
				strcat(file->path,"/");
				strcat(file->path,entry->d_name);
				stat(file->path,&file_stat);
				file->time=file_stat.st_ctime;
			}
			entry=readdir(directory);
		}
		closedir(directory);
		
/* ----------- DO THE PRINTING AND THE SORTING --------*/
			
		while (first_file)
		{
			file=find_best(first_file);

	/* NAME ENTRY */
	/*background=\"127.0.0.1/gfx/bar.gif\"*/
			printf("<table width=100% bgcolor=#113388><tr><td width=100%>");
			if (!print_file(TITLE_BEGIN)) printf(TITLE_BEGIN_DEFAULT);
			get_name(file->path,name);
			printf("%s",name);
			if (!print_file(TITLE_END)) printf(TITLE_END_DEFAULT);
	/* DATESTAMP */
			if (!print_file(DATE_BEGIN)) printf(DATE_BEGIN_DEFAULT);
			printf("%s",ctime(&file->time));
			if (!print_file(DATE_END)) printf(DATE_END_DEFAULT);
	/* CONTENT */
			get_email(file->path,string);
			printf("</td><td width=\"1\"><a href=\"mailto:%s\">",string);
			if (!print_file(EMAIL_ADDRESS)) printf(EMAIL_ADDRESS_DEFAULT);
			get_web(file->path,string);
			printf("</a></td><td width=\"1\"><a href=\"%s\">",string);
			if (!print_file(WEB_SOURCE)) printf(WEB_SOURCE_DEFAULT);
			printf("</a></td></tr></table>");
	/* PRINT THE FILE CONTENTS */
			if (!print_file(MESSAGE_BEGIN)) printf(MESSAGE_BEGIN_DEFAULT);
			print_message(file->path);
			if (!print_file(MESSAGE_END)) printf(MESSAGE_END_DEFAULT);
/* REMOVE ENTRY FROM LIST*/
			if (file==first_file)
			{
				if (first_file->next)
					first_file=file->next;
				else
					first_file=0;
				free(file);
			}
			else
			{
				prev_file=first_file;
				while (prev_file->next!=file)
					prev_file=prev_file->next;
				prev_file->next=file->next;
				free(file);
			}
		}
	}
}

// finds the oldest file
/*
struct file_entry *find_best(struct file_entry *first_file)
{
	time_t best=2147483647;
	struct file_entry *ret_file,*file;

	file=first_file;
	while (file)
	{
		if (file->time<best)
		{
			best=file->time;
			ret_file=file;
		}
		file=file->next;
	}
	if (ret_file==0) ret_file=first_file;
	return ret_file;
}
*/

// finds the newest file
struct file_entry *find_best(struct file_entry *first_file)
{
	time_t best=0;
	struct file_entry *ret_file,*file;

	file=first_file;
	while (file)
	{
		if (file->time>best)
		{
			best=file->time;
			ret_file=file;
		}
		file=file->next;
	}
	if (ret_file==0) ret_file=first_file;
	return ret_file;
}
