#include <InterfaceKit.h>

#ifndef _ST_CURVE_KNOB_H_
#define _ST_CURVE_KNOB_H_

class stCurveKnob:public BView
{
public:
	stCurveKnob(BPoint point,BRect movable_rect);
	~stCurveKnob();
	
	virtual void Draw(BRect rect);
	void SetMovableRect(BRect rect);
	virtual void MouseDown(BPoint point);
	BRect MoveArea();
	void SetMoveArea(BRect rect);
	BPoint Position();
	float XPosition();
	void MoveTo(BPoint point);
	void MoveBy(float x,float y);
	virtual void MakeFocus(bool focused=true);
	virtual void KeyDown(const char *bytes, int32 numByte);
private:
	BRect moving_rect; // the rectangle the knob can move within
	BRect draw_frame;
};

// inline definitions

inline BRect stCurveKnob::MoveArea()
{
	return moving_rect;
}

inline void stCurveKnob::SetMoveArea(BRect rect)
{
	rect.OffsetBy(-2,-2);
	moving_rect=rect;
}

inline BPoint stCurveKnob::Position()
{
	return Frame().LeftTop()+BPoint(2,2);
}

inline float stCurveKnob::XPosition()
{
	return Frame().left+2;
}

inline void stCurveKnob::MoveBy(float x,float y)
{
	MoveTo(Position()+BPoint(x,y));
}

#endif // _ST_CURVE_KNOB_H_
