#include "stInstrumentWindow.h"
#include "stCurveControl.h"
#include "stTrackerView.h"
#include "stTrackerEntry.h"

#include <stdio.h>
#include <Application.h>
#include <Message.h>

stInstrumentWindow::stInstrumentWindow(BPoint point):BWindow(BRect(point,point+BPoint(510,300)),"Sawteeth: Instrument editor",B_TITLED_WINDOW_LOOK,B_NORMAL_WINDOW_FEEL,B_NOT_RESIZABLE)
{
	amplitude_curve=new stCurveControl(BRect(10,60,310,190),4,new BMessage(42));
	amplitude_curve->SetKnobPosition(BPoint(10,20),3);
	
	field_type type_list[]={ST_TYPE_INDEX, ST_TYPE_SEPARATOR,ST_TYPE_NOTE, ST_TYPE_SEPARATOR,ST_TYPE_BOOL,ST_TYPE_SEPARATOR, ST_TYPE_NIBBLE};
	tracker_control=new stTrackerControl(BRect(320,20,440,220),20,type_list,sizeof(type_list)>>2,new BMessage(42),B_NOT_RESIZABLE);
/*	uint8 i;
	for (i=0;)
*/
	AddChild(tracker_control);
//	AddChild(new stTrackerView(BRect(320,10,440,210),10,type_list,10,new BMessage(42)));

	AddChild(amplitude_curve);

	zoom = 1;
/*	cv = new stChannelView(BRect(0,0,300,11));
	cv2 = new stChannelView(BRect(0,12,300,24));
	AddChild(cv);
	AddChild(cv2);
*/}

stInstrumentWindow::~stInstrumentWindow()
{
}

bool stInstrumentWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

void stInstrumentWindow::MessageReceived(BMessage *message)
{
	if (message->what==42)
	{
		uint8 action;
		message->FindInt8("action",(int8*)&action);
		switch (action)
		{
		case ST_ADD_KNOB:
			{
zoom += 0.05;
cv->SetZoom(zoom);
printf("%f\n",zoom);
//cv2->SetZoom(zoom);
			stCurveControl *control;
			message->FindPointer("control",(void**)&control);
			control->AddKnob();
			}break;
		case ST_DELETE_KNOB:
			{
zoom -= 0.05;
if (zoom < 0.1) zoom = 0.1;
cv->SetZoom(zoom);
printf("%f\n",zoom);
//cv2->SetZoom(zoom);
			stCurveControl *control;
			message->FindPointer("control",(void**)&control);
			control->DeleteKnob();
			}break;
		case ST_SET_LENGTH:
			{
			stTrackerControl *control;
			BTextControl *text;
			message->FindPointer("control",(void**)&control);
			message->FindPointer("source",(void**)&text);
			control->SetLength(atoi(text->Text()));
			}break;
		}
	}
}
