#include <stdio.h>
#include "insply.h"
#include "player.h"


Player::Player(Song *s, uint8 chno)
{
	amp = freq = freqstep = cutoff = cutoffstep = 1.0;	
	ampstep = 0.0;

	ip=new InsPly(s);
	song=s;
	step = song->chan[chno].steps;
	ch = song->chan + chno;		
	JumpPos(0,0,0);	
}

// skall ändras på
void Player::JumpPos(uint8 seqpos, uint8 steppos, uint8 pal)
{
	stepc = steppos;
	seqcount = seqpos;
	nexts = 0;

	currpart = &(song->parts[step[seqcount].part]);
	currstep =& (currpart->steps[stepc]);

	if (pal > 0){
		// increase counters;
		stepc++;
		if (stepc >= currpart->len){
			stepc=0;
			seqcount++;
			if (seqcount >= ch->len) seqcount=0;	// limit
			currpart=&(song->parts[step[seqcount].part]);
		}

		nexts = currpart->sps - pal;
		currstep =& (currpart->steps[stepc]);
	}
	
}

void Player::PAL()
{
	if (nexts < 1){
		nexts=currpart->sps;
		
		currstep=&(currpart->steps[stepc]);
		if (currstep->ins){
			ip->TrigADSR(currstep->ins);
			amp = 1.0;
			ampstep = 0;
			cutoff = 1.0;
			cutoffstep = 1.0;
		}

		if (currstep->note){
			freq = song->N2F[currstep->note+ch->steps[seqcount].transp];
			freqstep = 1.0;
		}
		
		
		// EFFEKTER //////////////////////////////////////////////////////////////////////////////
		if (currstep->eff){
			switch (currstep->eff & 0xf0){
/*			case 0x30 : if (N2F[currstep->note] > )
						freq=(((currstep->eff & 0xf) + 1 )/(4.0 * 1000.0)); break;
*/
			case 0x10 :	freqstep = 1.0+((currstep->eff & 0xf)+1)/1024.0; break;
			case 0x20 :	freqstep = 1.0-((currstep->eff & 0xf)+1)/1024.0; break;

			case 0x70 :	cutoffstep = 1.0+((currstep->eff & 0xf)+1)/96.0;break;
			case 0x80 :	cutoffstep = 1.0-((currstep->eff & 0xf)+1)/96.0;break;
			case 0x90 : cutoffstep=1.0; cutoff = ((currstep->eff & 0xf)+1)/16.0;cutoff *= cutoff;break;

			case 0xa0 :	ampstep = -((currstep->eff & 0xf)+1)/128.0; break;
			case 0xb0 :	ampstep = ((currstep->eff & 0xf)+1)/128.0; break;
			case 0xc0 : ampstep=0; amp = (currstep->eff & 0xf)/15.0; break;
			}
		}

		// increase counters;
		stepc++;
		if (stepc >= currpart->len){
			stepc=0;
			seqcount++;
			if (seqcount >= ch->len) seqcount=0;	// limit
			currpart=&(song->parts[step[seqcount].part]);
		}
	}
	nexts--;

	cutoff *= cutoffstep;
	if (cutoff<0){
		cutoff=0;
		cutoffstep = 1.0;
	}else{
		if (cutoff>1){
		cutoff = 1;
		cutoffstep = 1.0;		
		}
	}

	freq *= freqstep;
	if (freq<0){
		freq=0;
		freqstep=1;
	}/*else{
		if (freq>MAX_FREQ){
		freq=MAX_FREQ;
		freqstep=1;		
		}
	}*/

	amp += ampstep;
	if (amp<0){
		amp=0;
		ampstep=0;
	}else{
		if (amp>1){
		amp=1;
		ampstep=0;		
		}
	}
	
	ip->SetAmp(amp);
	ip->SetFreq(freq);
	ip->SetCutOff(cutoff);
	ip->PAL();
}	


float Player::Next()
{
/*	float tmp = ip->Next();
printf("ip:%f\n",tmp);
	return tmp;
*/	return ip->Next();
}



/*
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
*/
void Player::DumpPart(uint8 part)
{
	fprintf(stderr,"\n -- Part %x --\nstp ins note\n",part);
	Part *p=&(song->parts[part]);
	for (int c=0;c<p->len;c++)
		fprintf(stderr,"%02x - %02x %02x\n",c,p->steps[c].ins,p->steps[c].note);
}

void Player::DumpIns(uint8 ins)
{
	fprintf(stderr,"\n -- Ins %x --\n",ins);
	Ins *i=&(song->ins[ins]);

//	fprintf(stderr,"ADSR amp T [%02x %02x %02x %02x]\n",i->adsr[0],i->adsr[1],i->adsr[2],i->adsr[3]);
//	fprintf(stderr,"         L [%02x %02x %02x %02x]\n\n",i->adsrlev[0],i->adsrlev[1],i->adsrlev[2],i->adsrlev[3]);

//	fprintf(stderr,"ADSR flt T [%02x %02x %02x %02x]\n",i->fadsr[0],i->fadsr[1],i->fadsr[2],i->fadsr[3]);
//	fprintf(stderr,"         L [%02x %02x %02x %02x]\n\n",i->fadsrlev[0],i->fadsrlev[1],i->fadsrlev[2],i->fadsrlev[3]);

	fprintf(stderr,"Sps %d\n",i->sps);
	fprintf(stderr,"len %02x\n",i->len);

	for (int c=0;c<i->len;c++)
		fprintf(stderr,"%02x- %d\n",c,i->steps[c].note);
}

