#include <stdlib.h>
#include <string.h>

#include "txt.h"

txt::txt(char *filename, bool create)
{
	r_zero_mode = false;
	w_zero_mode = false;
	rle = false;
	bin = false;
	error=JNG_OK;
	if (create)
		f=fopen(filename,"wb");
	else
		f=fopen(filename,"rb");

	if (f==0){
		fprintf(stderr,"%s: no such file\n",filename);
		error=JNG_ERROR;
	}
}

txt::~txt()
{
	if (w_zero_mode){
		fputc(w_zero_count,f);
	}
	fclose(f);
}

status_t txt::InitCheck()
{
	return error;
}

void txt::IsBin(bool b)
{
	bin = b;
}

void txt::IsRLE(bool r)
{
	rle = r;
}

void txt::jntok(char *b, char *m)
{
	bool cont=true;
	int mc=strlen(m);
	int c;
	while (*b!=0 && cont){
		for (c=0;c<mc;c++)
			if (*b == m[c]){
				*b=0;
				cont=false;
				break;
			}
		b++;
	}	
}

void txt::String(char *txt)
{
	if (w_zero_mode){
		fputc(w_zero_count,f);
		w_zero_mode = false;
		w_zero_count=0;
	}
	fputs(txt,f);
	fputc(0,f);
	if (!bin) fputc('\n',f);
}

void txt::Comment(int val)
{
	if (!bin) fprintf(f,"%x",val);
}

void txt::Comment(char *txt)
{
	if (!bin) fputs(txt,f);
}

void txt::AtomWrite(int val)
{
	if (rle){
		// start of real function-------------------------------
		if (w_zero_mode){
			if (0 == val){
				w_zero_count++;
				//skydd för överflow
				if (w_zero_count > 254){
					fputc(w_zero_count,f);
					w_zero_mode = false;
					w_zero_count = 0;
				}
			}else{
//				printf("zero_mode_off, %d zeroes written\n",w_zero_count);
				fputc(w_zero_count,f);
				w_zero_mode = false;
				w_zero_count = 0;
				fputc(val,f);
			}
		}else{
			if (0 == val){
				w_zero_mode = true;
				fputc(0,f);
			}else{
				fputc(val,f);
			}
		}
	}else{
		fputc(val,f);
	}
	// ends.------------------------------------------------
}

void txt::Val(int val, int numbytes)
{
	if (bin){
		if (numbytes == 1)
			AtomWrite(val);
		else
			for (int c=numbytes; c>0; c--)
				AtomWrite((val >> ((c-1) << 3)) & 255);
	}else{
		fprintf(f,"%d\n",val);
	}
}


int txt::AtomRead()
{
// start of real function-------------------------------
	if (rle){
		if (r_zero_mode){
			if (r_zero_count>0){
				r_zero_count--;
	//			printf("zero_mode_on, %d zeroes to go\n",r_zero_count);
				return 0;
			}else{
				r_zero_mode = false;
				return AtomRead();
			}
		}else{
			int val = fgetc(f);
			if (0==val){
				r_zero_count = fgetc(f);
				r_zero_mode = true;
	//			printf("zero_mode_on, %d zeroes\n",r_zero_count);
				return 0;
			}else{
	//			printf("read %d\n",val);
				return val;
			}
		}
	}else{
		return fgetc(f);
	}
// ends.------------------------------------------------
}

int txt::NextVal(int numbytes)
{	
	if (bin){
		// binary file
		if (numbytes == 1){
			return AtomRead();
		}
		int32 tmp=0;
		for (int c=numbytes;c>0;c--)
			tmp |= AtomRead() << (c-1 << 3);
		return tmp;

	}else{
		// text file
		bool ok=true;
		do {
			if (0==fgets(buf,BUFSIZE,f)) ok=false;
			if (ok) jntok(buf,"/\n");		
		} while ( ok && ((*buf)==0));
		return atoi(buf);	
	}
}

float txt::NextFloat()
{
	int n = NextVal(4);
	float *f = (float *)&n;
	return (*f);	
}

char *txt::NextString()
{
	if (bin){
		r_zero_mode = false;

		int tmp,c;
		for ( c = 0 ; (0 < (tmp =fgetc(f))) && (c < BUFSIZE-1) ; c++ ) buf[c]=tmp;
		if (c >= BUFSIZE-1) return NULL;
	}else{
		if (NULL == fgets(buf,BUFSIZE,f)) return NULL;
		jntok(buf,"\n");
	}
	
	//fprintf(stderr,"txt::NextString()\t%s\n",buf);
	//return strdup(buf);
	return buf;
}

