#include <stdio.h>
#include <StorageKit.h>
#include <SupportKit.h>

static BMessage *mess;

static char path[B_PATH_NAME_LENGTH] = { 0 };

void PushDir(char *name)
{
	strcat(path,"/");
	strcat(path,name);
//	printf("\nPushed path = {%s}\n",path);
}


void PopDir()
{
	char *p = path + strlen(path) - 1;
	while ((*p != '/') && (p > path)) p--;
	*p = 0;
//	printf("\nPopped path = {%s}\n",path);
}


void AddToMess(BEntry &ent)
{
	char name[B_FILE_NAME_LENGTH]; 
	ent.GetName(name);

	BFile file(&ent, B_READ_ONLY);
	off_t size;
	file.GetSize(&size);
	char *buff = new char[size];
	file.Read(buff,size);
		
	PushDir(name);
	mess->AddData(1+path,B_RAW_TYPE,buff,size);
	PopDir();
	delete buff;
}


void RecurseDir(BDirectory &dir)
{

	BEntry ent;
	while (B_OK == dir.GetNextEntry(&ent,true)){
		if (ent.IsDirectory()){
			
			char name[B_FILE_NAME_LENGTH]; 
			ent.GetName(name);
			PushDir(name);
			
			BDirectory dir2(&ent);
			RecurseDir(dir2);
			
			PopDir();
		}else
			AddToMess(ent);
	}
}

int main(int argc, char *argv[])
{
	if (argc != 2){
		perror("Usage:\npakgen dirname\n");
		return -1;
	}
	
	BDirectory dir(argv[1]);
	if (B_OK != dir.InitCheck()){
		perror("Dir error:");
		return -1;
	}

	char name[B_FILE_NAME_LENGTH]; 
	strcpy(name,argv[1]);
	if (name[strlen(name) -1] == '/') name[strlen(name) -1] = 0;
	strcat(name,".flat");
	BFile file(name,B_WRITE_ONLY | B_CREATE_FILE | B_ERASE_FILE);
	if (B_OK != file.InitCheck()){
		perror("File Error:");
		return -1;
	}

	mess = new BMessage();
	RecurseDir(dir);
	// skriv ut
	mess->Flatten(&file);
	delete mess;	
}
