#ifndef _dBITMAP_
#define _dBITMAP_

#include "dGraphic.h"
#include "dColor.h"
#include "dFace.h"
#include "dObject.h"
#include "dClut2.h"

#include <Debug.h>
#include <Directory.h>
#include <stdlib.h>

class dBitmap : public dGraphic
{
public:
	dBitmap(int32 width,int32 height,int32 num_polys = 0);
	dBitmap(BPositionIO *file,int32 num_polys = 0);
	virtual ~dBitmap();

	void AddObject(dObject *obj,bool backface_culling = true);
	void Render();	

	int32 max_u,max_v;
	int32 min_u,min_v;

private:
// the number of polygons the sort-list can contain
	int32 m_list_size;
// used for sorting the faces
	int m_sort_count0, m_sort_count1, m_sort_count2, m_sort_count3;
	dPolygon **m_sort_list0;
	dPolygon **m_sort_list1;
	dPolygon **m_sort_list2;
	dPolygon **m_sort_list3;
};

#endif // _dBITMAP_
