#ifndef _dFONT_
#define _dFONT_

#include "dColor.h"
#include "dFace.h"
#include "dObject.h"
#include "dClut2.h"
#include "dVertex.h"
#include "dGraphic.h"

#include <Debug.h>
#include <Directory.h>
#include <stdlib.h>

// font state struct
struct text_state
{
	bool strong;
	bool bold;
	bool italic;
};

class dFont
{
public:
	dFont(BPositionIO *file);
	virtual ~dFont();

	dVertex Printf(const dVertex& pos, dGraphic *bitmap, text_state *state, const char *format, ...) const;
	dVertex DrawString(const dVertex &position, dGraphic *bitmap, text_state *state, const char *string) const;

	int32 StringWidth(const char *string) const;
	
	int32 CharHeight() const;
	int32 CharWidth() const;
	int32 CharWidth(char character) const;
private:
	dVertex Draw(const dVertex &position, dGraphic *bitmap, bool italic, dColor text_color, const char *string) const;
	void Blit(int32 src_x, int32 src_y, int32 src_width, int32 src_height, dGraphic *dest, int32 dest_x, int32 dest_y, dColor text_color) const;
	void BlitItalic(int32 src_x, int32 src_y, int32 src_width, int32 src_height, dGraphic *dest, int32 dest_x, int32 dest_y, dColor text_color) const;

	dColor m_normal_color;
	dColor m_strong_color;

// the width and the height of the bitmap
	int32 m_width,m_height;
// the actual bitmap
	dColor *m_buffer;
// the width list
	int8 m_char_width[256];
};

inline int32 dFont::CharHeight() const
{
	return 8;
}

// returns the maximum char width
inline int32 dFont::CharWidth() const
{
	return 8;
}

inline int32 dFont::CharWidth(char character) const
{
	return m_char_width[character];
}

#endif // _dFONT_
