#ifndef _dGuideReader_
#define _dGuideReader_

#include "dColor.h"
#include "dFace.h"
#include "dObject.h"
#include "dClut2.h"
#include "dGraphic.h"
#include "dFont.h"

#include <Debug.h>
#include <Directory.h>
#include <stdlib.h>

class dGuideReader : public dGraphic
{
public:
	dGuideReader(int32 width,int32 height, const dFont *font, BPositionIO *file);
	virtual ~dGuideReader();

	int32 Page(); // the current page
	
	bool LastPage(); // returns true if this is the last page
	void Next(); // generates the next page
	void Prev(); // generates the previous page

private:
	void Generate();

	int32 m_page_number; // the current page number
	bool m_last_page; // is set to true when the last page is generated, and set to true when any other page is generated

	char *m_lines[8000]; // 800 is the maximum number of lines
	int32 m_num_lines;
	
	int32 m_page_start[200]; // the line each page start on
	text_state m_page_state[200]; // the text state at the start of each page
	
	const dFont *m_font;

	char temp[8000];
};

inline int32 dGuideReader::Page()
{
	return m_page_number;
}

inline bool dGuideReader::LastPage()
{
	return m_last_page;
}

#endif // _dGuideReader_
