#include "dBitmap.h"
#include "dGraphic.h"

#include <stdlib.h>
#include <Directory.h>
#include <File.h>

dBitmap::dBitmap(BPositionIO *file,int32 num_polys):
	dGraphic(file),
	min_u(150),
	min_v(150),
	max_u(150),
	max_v(150),
// the lists
	m_list_size(num_polys),
	m_sort_count0(0),
	m_sort_count1(0),
	m_sort_count2(0),
	m_sort_count3(0),
	m_sort_list0(new dPolygon*[m_list_size]),
	m_sort_list1(new dPolygon*[m_list_size]),
	m_sort_list2(new dPolygon*[m_list_size]),
	m_sort_list3(new dPolygon*[m_list_size])
{
}

dBitmap::dBitmap(int32 w,int32 h,int32 num_polys):
	dGraphic(w,h),
	min_u(150),
	min_v(150),
	max_u(150),
	max_v(150),
// the lists
	m_list_size(num_polys),
	m_sort_count0(0),
	m_sort_count1(0),
	m_sort_count2(0),
	m_sort_count3(0),
	m_sort_list0(new dPolygon*[m_list_size]),
	m_sort_list1(new dPolygon*[m_list_size]),
	m_sort_list2(new dPolygon*[m_list_size]),
	m_sort_list3(new dPolygon*[m_list_size])
{
}

dBitmap::~dBitmap()
{
	delete []m_sort_list0;
	delete []m_sort_list1;
	delete []m_sort_list2;
	delete []m_sort_list3;
}

void dBitmap::Render()
{
//	printf("Render()\n");

	dPolygon **point0;
	dPolygon **point1;
	dPolygon **point2;
	dPolygon **point3;
	dPolygon **stop;
	
	m_sort_count1=0;

	int testbit=1;
	for (int c = 31 ; c != 0 ; c-- ){

		// list0
		m_sort_count2 = 0;
		m_sort_count3 = 0;
		point0 = m_sort_list0;
		point1 = m_sort_list1;
		point2 = m_sort_list2;
		point3 = m_sort_list3;

		stop = point0 + m_sort_count0;
		for (;point0 < stop ; point0++)
		{
			float z = (*point0)->Z();
			if ( (*((int*) &(z)) & testbit) !=0)
			{
				*point3 = *point0;
				point3++;
				m_sort_count3++;
			}else{
				*point2 = *point0;
				point2++;
				m_sort_count2++;
			}
		}

		// list1
		stop = point1 + m_sort_count1;
		for (;point1 < stop ; point1++)
		{
			float z = (*point1)->Z();
			if ( (*((int*)&(z)) & testbit) !=0)
			{
				*point3 = *point1;
				point3++;
				m_sort_count3++;
			}else{
				*point2 = *point1;
				point2++;
				m_sort_count2++;
			}
		}

		testbit<<=1;

		// list2
		m_sort_count0 = 0;
		m_sort_count1 = 0;
		point0 = m_sort_list0;
		point1 = m_sort_list1;
		point2 = m_sort_list2;
		point3 = m_sort_list3;

		stop = point2 + m_sort_count2;
		for (;point2 < stop ; point2++)
		{
			float z = (*point2)->Z();
			if ( (*((int*)&(z)) & testbit) !=0){
				*point1 = *point2;
				point1++;
				m_sort_count1++;
			}else{
				*point0 = *point2;
				point0++;
				m_sort_count0++;
			}
		}

		// list3
		stop = point3 + m_sort_count3;
		for (;point3 < stop ; point3++)
		{
			float z = (*point3)->Z();
			if (( *((int*)&(z)) & testbit) !=0){
				*point1 = *point3;
				point1++;
				m_sort_count1++;
			}else{
				*point0 = *point3;
				point0++;
				m_sort_count0++;
			}
		}
		
		testbit<<=1;
	}
	
	for (int i=m_sort_count1-1;i>=0;i--)
	{
		dPolygon *polygon = m_sort_list1[i];
		polygon->Draw(this);
	}

	for (int i=m_sort_count0-1;i>=0;i--)
	{
		dPolygon *polygon = m_sort_list0[i];
		polygon->Draw(this);
	}

	m_sort_count0 = 0;
	m_sort_count1 = 0;
	m_sort_count2 = 0;
	m_sort_count3 = 0;
}

void dBitmap::AddObject(dObject *obj,bool backface_culling)
{
// if the list is full, return
	if (m_sort_count0 == m_list_size) return;
	for (int i=0;i<obj->PolygonCount();i++)
	{
		if (!backface_culling || obj->Polygon(i)->IsFront())
		{
			dPolygon *polygon=obj->Polygon(i);
			if (polygon->material->type & MATERIAL_ENVMAPPED)
			{
				dVertex normal;
				normal=*obj->RotatedNormal(polygon->vex[0] - obj->ProjectedVertex(0));
				polygon->u[0]=(255.5+normal.x*255.0)*65500.0;
				polygon->v[0]=(255.5+normal.y*255.0)*65500.0;

				if (polygon->VertexCount() > 1)
				{
					normal=*obj->RotatedNormal(polygon->vex[1] - obj->ProjectedVertex(0));
					polygon->u[1]=(255.5+normal.x*255.0)*65500.0;
					polygon->v[1]=(255.5+normal.y*255.0)*65500.0;

					if (polygon->VertexCount() > 2)
					{
						normal=*obj->RotatedNormal(polygon->vex[2] - obj->ProjectedVertex(0));
						polygon->u[2]=(255.5+normal.x*255.0)*65500.0;
						polygon->v[2]=(255.5+normal.y*255.0)*65500.0;
					}
				}
			}
			polygon->CalcZ();
//			printf("adding poly to sort list\n");
			m_sort_list0[m_sort_count0] = polygon;
			m_sort_count0++;
			if (m_sort_count0 == m_list_size) return;
		}
	}
//	printf("num_polys_added %d\n",sort_count0);
}
