/*
	Written by Arvid Norberg 1999 <arvid@iname.com>
*/

#ifndef _MULTI_REQUESTER_WINDOW_H
#define _MULTI_REQUESTER_WINDOW_H

#include "layout.h"
#include "MWindow.h"

class MPopup;
class MButton;
class MTextControl;
class MCheckBox;

const uint32 PATTERN_CHECK='ptck';
const uint32 YEAR_CHECK='yrck';
const uint32 TITLE_CHECK='tlck';
const uint32 ALBUM_CHECK='alck';
const uint32 ARTIST_CHECK='atck';
const uint32 GENRE_CHECK='gnck';
const uint32 COMMENT_CHECK='cchk';
const uint32 RATING_CHECK='rtck';
const uint32 TRACK_CHECK='trck';

class MultiRequesterWindow : public MWindow
{
public:
	MultiRequesterWindow(char *pattern,uint32 size,char *genre,char *title,char *artist,char *album,char *comment,int32 *year_val,int32 *rating_val,int32 *track_val, bool * action);
	virtual void MessageReceived(BMessage *);
	virtual bool QuitRequested();
private:
	bool * do_it;

	MTextControl *pattern_gadget;
	MButton *ok_button;
	
	MCheckBox *year_check;
	MCheckBox *title_check;
	MCheckBox *album_check;
	MCheckBox *artist_check;
	MCheckBox *genre_check;
	MCheckBox *pattern_check;
	MCheckBox *comment_check;
	MCheckBox *track_check;
	MCheckBox *rating_check;

	MTextControl *year_gadget;
	MTextControl *title_gadget;
	MTextControl *album_gadget;
	MTextControl *artist_gadget;
	MTextControl *comment_gadget;
	MTextControl *genre_gadget;
	MTextControl *rating_gadget;
	MTextControl *track_gadget;

	MView *topview;

	char	*pattern_string,
				*title_string,
				*artist_string,
				*album_string,
				*comment_string,
				*genre_string;
	int32 *year,*rating,*track;
	int8 tmp_genre;
	uint32 len;

	enum
	{
		OK_BUTTON='okbt',
		CANCEL_BUTTON='clbt'
	};
};

#endif // _MULTI_REQUESTER_WINDOW_H