/*
	Written by Arvid Norberg 1999 <arvid@iname.com>
*/

#include "VGroup.h"
#include "HGroup.h"
#include "MButton.h"
#include "MBorder.h"
#include "MCheckBox.h"
#include "MStringView.h"
#include "MTextControl.h"
#include "MPopup.h"
#include "MWindow.h"
#include "layout.h"

#include "RequesterWindow.h"

#include <string.h>
#include <stdio.h>

RequesterWindow::RequesterWindow(char *filename,char *genre,char *title,char *artist,char *album,char *comment,int32 *year_val,int32 *track_val,int32 *rating_val, bool * action)
	: MWindow(BRect(100,100,101,101),"mp3-attribute editor",B_TITLED_WINDOW,B_NOT_RESIZABLE)
{
	year=year_val;
	track=track_val;
	rating=rating_val;
	
	char year_string[B_FILE_NAME_LENGTH];
	char track_string[B_FILE_NAME_LENGTH];
	char rating_string[B_FILE_NAME_LENGTH];

	*year_string=0;
	*rating_string=0;
	*track_string=0;

	if (*year!=-1) sprintf(year_string,"%ld",*year);
	if (*track!=-1) sprintf(track_string,"%ld",*track);
	if (*rating!=-1) sprintf(rating_string,"%ld",*rating);

	title_string=title;
	artist_string=artist;
	album_string=album;
	comment_string=comment;
	genre_string=genre;

	topview=
	new VGroup
	(
		new HGroup
		(
			new VGroup
			(
				minimax(-1,-1,-1,-1),
				new MStringView("filename:",B_ALIGN_RIGHT),
				new MStringView("title:",B_ALIGN_RIGHT),
				new MStringView("artist:",B_ALIGN_RIGHT),
				new MStringView("album:",B_ALIGN_RIGHT),
				new MStringView("comment:",B_ALIGN_RIGHT),
				new MStringView("genre:",B_ALIGN_RIGHT),
				new MStringView("year:",B_ALIGN_RIGHT),
				new MStringView("rating:",B_ALIGN_RIGHT),
				new MStringView("track:",B_ALIGN_RIGHT),
				0
			),
			new VGroup
			(
				minimax(200,-1,-1,-1),
				new MStringView(filename),
				title_gadget=new MTextControl("",title),
				artist_gadget=new MTextControl("",artist),
				album_gadget=new MTextControl("",album),
				comment_gadget=new MTextControl("",comment),
				genre_gadget=new MTextControl("",genre),
				year_gadget=new MTextControl("",year_string),
				rating_gadget=new MTextControl("",rating_string),
				track_gadget=new MTextControl("",track_string),
				0
			),
			0
		),
		new HGroup
		(
			new MButton("Cancel",new BMessage(CANCEL_BUTTON)),
			ok_button=new MButton("Save",new BMessage(OK_BUTTON)),
			0
		),
		0
	);
	AddChild(dynamic_cast<BView*>(topview));
	SetDefaultButton(dynamic_cast<BButton*>(ok_button));

	do_it = action;
}

bool RequesterWindow::QuitRequested()
{

	return true;
}

void RequesterWindow::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case OK_BUTTON:
			*do_it = true;
			// copy the data
			strncpy(title_string,title_gadget->Text(),B_FILE_NAME_LENGTH);
			strncpy(artist_string,artist_gadget->Text(),B_FILE_NAME_LENGTH);
			strncpy(album_string,album_gadget->Text(),B_FILE_NAME_LENGTH);
			strncpy(comment_string,comment_gadget->Text(),B_FILE_NAME_LENGTH);
			strncpy(genre_string,genre_gadget->Text(),B_FILE_NAME_LENGTH);
			*year=atoi(year_gadget->Text());
			*track=atoi(track_gadget->Text());
			*rating=atoi(rating_gadget->Text());
			Quit();
			break;
		case CANCEL_BUTTON:
			Quit();
			break;
		default:
			MWindow::MessageReceived(message);
	}
}