/*
	Written by Arvid Norberg 1999 <arvid@iname.com>
*/

#include "VGroup.h"
#include "HGroup.h"
#include "MButton.h"
#include "MBorder.h"
#include "MCheckBox.h"
#include "MStringView.h"
#include "MTextControl.h"
#include "MWindow.h"
#include "layout.h"
#include "MPopup.h"

#include "RequesterWindow.h"

#include <string.h>
#include <stdio.h>

RequesterWindow::RequesterWindow(char *pattern, uint32 size, bool * action)
	: MWindow(BRect(100,100,180,150),"mp3 renamer",B_TITLED_WINDOW,B_NOT_RESIZABLE)
{
	pattern_string=pattern;

	len = size;

	topview=
	new VGroup
	(
		new MBorder(M_LABELED_BORDER,10,"pattern",
			new VGroup
			(
				new MStringView("Enter the patter by which your mp3 files should be named."),
				new MStringView("/a = Artist name"),
				new MStringView("/t = song Title"),
				new MStringView("/n = album Name"),
				new MStringView("/c = comment"),
				new MStringView("/y = year"),
				new MStringView("/r = rating"),
				new MStringView("/k = track"),
				new MStringView("/g = genre"),
				pattern_gadget=new MTextControl("pattern:","/a - /n - /k - /t - /y - /c.mp3"),
				0
			)
		),
		new HGroup
		(
			new MButton("Cancel",new BMessage(CANCEL_BUTTON)),
			ok_button=new MButton("Run",new BMessage(OK_BUTTON)),
			0
		),
		0
	);
	AddChild(dynamic_cast<BView*>(topview));
	SetDefaultButton(ok_button);
	
	do_it = action;
}

bool RequesterWindow::QuitRequested()
{
	return true;
}

void RequesterWindow::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case OK_BUTTON:
			*do_it = true;
			// copy the data
			strncpy(pattern_string,pattern_gadget->Text(),len);
			Quit();
			break;
		case CANCEL_BUTTON:
			Quit();
			break;
		default:
			MWindow::MessageReceived(message);
	}
}
