// strktpek.cpp -- funktioner med strukturpekare som argument
#include <iostream.h>
#include <math.h>

// strukturmallar
struct polar
{
	double distance;	// avstnd frn nollpunkt
	double angle;		// vinkel frn nollpunkten
};
struct rect
{
	double x;	// horisontellt avstnd frn nollpunkten
	double y;	// vertikalt avstnd frn nollpunkten
};

// prototyper
void rect_to_polar(rect *xypos, polar *pda);
void show_polar(const polar *pda);

int main(void)
{
	rect rplace;
	polar pplace;

	cout << "Ange x- och y-vrden: ";
	while (cin >> rplace.x >> rplace.y)	// smart anvndning av cin
	{
		rect_to_polar(&rplace, &pplace);	// skicka adress
		show_polar(&pplace);					// skicka adress
		cout << "Nsta tv tal (a avslutar): ";
	}
	return 0;
}

// konvertera rektangulra koordinater till polra
void rect_to_polar(rect *pxy, polar *pda)
{
	pda->distance =
			sqrt(pxy->x * pxy->x + pxy->y * pxy->y);
	pda->angle = atan2(pxy->y, pxy->x);
}

// visa polra koordinater, konvertera vinkeln till grader
void show_polar(const polar *pda)
{
	const double Rad_to_deg = 57.29577951;

	cout << "avstnd = " << pda->distance;
	cout << ", vinkel = " << pda->angle * Rad_to_deg;
	cout << " grader\n";
}
