// vektor1.cpp -- metoder fr klassen Vector
#include <iostream.h>
#include <math.h>
#include "vektor1.h"
const double Rad_to_deg = 57.2957795130823;

// privata metoder
// berknar magnituden frn x och y
void Vector::set_mag(void)
{
	mag = sqrt(x * x + y * y);
}

// berknar vinkel frn x och y
void Vector::set_ang(void)
{
	if (x == 0.0 && y == 0.0)
			ang = 0.0;
	else
			ang = atan2(y, x);
}

// publika metoder
Vector::Vector(void) // frvald konstruerare
{
	x = y = mag = ang = 0.0;
}

// konstruerar en Vector frn rektangulra koordinater
Vector::Vector(double h, double v)
{
	x = h;
	y = v;
	set_mag();
	set_ang();
}

Vector::~Vector(void) // destruerare
{
}

// bestmmer Vector-medlemmar frn polra koordinater
void Vector::set_by_polar(double m, double a)
{
	mag = m;
	ang = a / Rad_to_deg;
	x = m * cos(ang);
	y = m * sin(ang);
}

// visar magnituden och riktningen fr Vector
void Vector::show_polar(void)
{
	cout << "(" << mag << ", ";
	cout << ang * Rad_to_deg << ")\n";
}

// visar x- och y-komponenter fr Vector
void Vector::show_Vector(void)
{
	cout << "(" << x << ", " << y << ")\n";
}
// operatorverlagring
// lgg till tv Vector-objekt
Vector Vector::operator+(const Vector &b)
{
	double sx, sy;
	sx = x + b.x;
	sy = y + b.y;
	Vector sum = Vector(sx, sy);
	return sum;
}

// subtraherar Vector b frn a
Vector Vector::operator-(const Vector &b) const
{
	double dx, dy;
	dx = x - b.x;
	dy = y - b.y;
	Vector diff = Vector(dx, dy);
	return diff;
}

// inverterar tecknet p Vector
Vector Vector::operator-() const
{
	double nx, ny;
	nx = -x;
	ny = -y;
	Vector neg = Vector(nx, ny);
	return neg;
}

// multiplicerar Vector med n
Vector Vector::operator*(double n) const
{
	double mx, my;
	mx = n * x;
	my = n * y;
	Vector mult = Vector(mx, my);
	return mult;
}

// friend-metod
// multiplicerar n med Vector a
Vector operator*(double n, const Vector &a)
{
	return a * n;
};