// vektor_2.cpp -- metoder fr klassen Vector
#include <iostream.h>
#include <math.h>
#include "vektor2.h"
const double Rad_to_deg = 57.2957795130823;

// privata metoder
// berknar magnituden frn x och y
void Vector::set_mag(void)
{
	mag = sqrt(x * x + y * y);
}

void Vector::set_ang(void)
{
	if (x == 0.0 && y == 0.0)
			ang = 0.0;
	else
			ang = atan2(y, x);
}

// ger x vrde frn polra koordinater
void Vector::set_x(void)
{
	x = mag * cos(ang);
}

// ger y vrde frn polra koordinater
void Vector::set_y(void)
{
	y = mag * sin(ang);
}

// publika metoder
Vector::Vector(void)
{
	x = y = mag = ang = 0.0;
	mode = 'r';
}

// konstruerar Vector frn rektangulra koordinater
// om formen r r. Om formen r p anvnds polra
// koordinater
Vector::Vector(double n1, double n2, char form)
{
	mode = form;
	if (form == 'r')
	{
		x = n1;
		y = n2;
		set_mag();
		set_ang();
	}
	else if (form == 'p')
	{
		mag = n1;
		ang = n2 / Rad_to_deg;
		set_x();
		set_y();
	}
	else
	{
		cout << "Felaktigt tredje argument till Vector()";
		cout << " -- vektorn stts till 0\n";
		x = y = mag = ang = 0.0;
		mode = 'r';
	}
}

// ger Vector vrden frn rektangulra koordinater om
// formen r r. Om formen r p anvnds polra
// koordinater
void Vector:: set(double n1, double n2, char form)
{
	mode = form;
	if (form == 'r')
	{
		x = n1;
		y = n2;
		set_mag();
		set_ang();
	}
	else if (form == 'p')
	{
		mag = n1;
		ang = n2 / Rad_till_deg;
		set_x();
		set_y();
	}
	else
	{
		cout << " Felaktigt tredje argument till Vector()";
		cout << " -- vektorn stts till 0\n ";
		x = y = mag = ang = 0.0;
		mode = 'r';
	}
}

Vector::~Vector(void) // destruerare
{
}

void Vector::polar_mode() // stller in polrt lge
{
	mode = 'p';
}

void Vector::rect_mode() // stller in rektangulrt lge
{
	mode = 'r';
}

// operatorverlagring
// lgger till tv vektorer
Vector Vector::operator+(const Vector &b) const
{
	double sx, sy;
	sx = x + b.x;
	sy = y + b.y;
	Vector sum = Vector(sx, sy);
	return sum;
}

// subtraherar tv vektorer
Vector Vector::operator-(const Vector &b) const
{
	double dx, dy;
	dx = x - b.x;
	dy = y - b.y;
	Vector diff = Vector(dx, dy);
	return diff;
}

// ndrar tecken fr Vector
Vector Vector::operator-() const
{
	double nx, ny;
	nx = -x;
	ny = -y;
	Vector neg = Vector(nx, ny);
	return neg;
}

// multiplicerar Vector med tv
Vector Vector::operator*(double n) const
{
	double mx, my;
	mx = n * x;
	my = n * y;
	Vector mult = Vector(mx, my);
	return mult;
}

// friend-metoder
// multiplicerar n med Vector a
Vector operator*(double n, const Vector &a)
{
	return a * n;
}

// visar rektangulra koordinater om lget r r
// om lge r p visas polra koordinater
ostream &operator<<(ostream &os, const Vector &v)
{
	if (v.mode == 'r')
		os << "(x, y) = (" << v.x << ", " << v.y << ")";
	else if (v.mode == 'p')
	{
		os << "(m, a) = (" << v.mag << ", "
				<< v.ang * Rad_to_deg << ")";
	}
	else
		os << "Ogiltigt arbetslge fr vektorobjekt";
	return os;
}
