// vektor2.h -- vektorklass med << och arbetslge
#ifndef _VECTOR2_H_
#define _VECTOR2_H_
class Vector
{
private:
	double x;		// horisontellt vrde
	double y;		// vertikalt vrde
	double mag;	// vektorns lngd
	double ang;	// vektorns riktning
	char mode;	// 'r' = rektangulr, 'p' = polr
	void set_mag(void);
	void set_ang(void);
	void set_x(void);
	void set_y(void);
public:
	Vector(void);
	Vector(double n1, double n2, char form = 'r');
	void set(double n1, double n2, char form = 'r');
	~Vector(void);
	double xval() const {return x;}	// x-vrde
	double yval() const {return y;}	// y-vrde
	double magval() const {return mag;}	// magnitud
	double angval() const {return ang;}	// vinkel
	void polar_mode();
	void rect_mode();
	// operatorverlagring
	Vector operator+(const Vector &b) const;
	Vector operator-(const Vector &b) const;
	Vector operator-() const;
	Vector operator*(double n) const;
	// friend-funktioner
	friend Vector operator*(double n, Vector &a);
	friend ostream &operator<<(ostream &os, const Vector 		&v);
};
#endif
