// queue.cpp  Queue- och Customer-metoder
#include "queue.h"
#include <stdlib.h> 		// fr rand()

// Queue methods
Queue::Queue(int qs) : qsize(qs)
{
	front = rear = NULL;
	items = 0;
}

Queue::~Queue()
{
	Node * temp;
	while (front != NULL)		// om queue inte r helt tom
	{
		temp = front;		// spara adressen till det frsta objektet
		front = front->next;	// stt pekare till nsta objekt
		delete temp;		// radera tidigare frsta objekt
	}
}

Bool Queue::isempty() const
{
	return items == 0 ? True : False;
}

Bool Queue::isfull() const
{
	return items == qsize ? True : False;
}

int Queue::queuecount() const
{
	return items;
}

// Lgg till objekt till kn
Bool Queue::enqueue(const Item & item)
{
	if (isfull())
		return False;
	Node * add = new Node;	// skapa nod
	if (add == NULL)
		return False;	// avsluta om ingen nod finns // tillgnglig
	add->item = item;		// stt nodpekare
	add->next = NULL;
	items++;
	if (front == NULL)		// om kn r tom,
		front = add;		// placera objekt i brjan
	else
		rear->next = add;		// annars placeras den sist
	rear = add; 			// lt rear peka till den nya noden
	return True;
}

// Placera frmre objekt i objektvariabeln och avlgsna frn kn
Bool Queue::dequeue(Item & item)
{
	if (front == NULL)
		return False;
	item = front->item;		// stt objekt till frsta objekt i kn
	items--;
	Node * temp = front;		// spara lget fr frsta objektet
	front = front->next;		// stt front till nsta objekt
	delete temp;			// radera tidigare frsta objekt
	if (items == 0)
		rear = NULL;
	return True;
}

// customer-metod

// when r tidpunkten d kunden anlnder
// ankomsttiden stts till when och transaktionstiden
// stts till ett slumptal i intervallet 1 - 3
void Customer::set(long when)
{
	processtime = rand() % 3 + 1;
	arrive = when;
}