// queue.h  grnssnitt fr en k
#ifndef _QUEUE_H_
#define _QUEUE_H_
#include "booly.h" // vra definitioner av Bool, False och True
// Kn kommer att innehlla Customer-objekt
class Customer
{
private:
	long arrive;		// kundens ankomsttid
	int processtime;		// tid kundens besk tar
public:
	Customer() { arrive = processtime = 0; }
	void set(long when);
	long when() const { return arrive; }
	int ptime() const { return processtime; }
};

typedef Customer Item;

class Queue
{
// definition av klassens rckvidd
	// Nod r en nstlad strukturdefinition som r lokal 
	// fr den hr klassen
	struct Node { Item item; struct Node * next;};
	enum {Q_SIZE = 10};
private:
	Node * front;		// pekare till brjan av Queue
	Node * rear;		// pekare till brjan av Queue
	int items;		// aktuellt antal objekt i Queue
	const int qsize;	// maximalt antal objekt i Queue
	Queue(const Queue & q) : qsize(0) { }	// frdefinition
	Queue & operator=(const Queue & q) { return *this;}
public:
	Queue(int qs = Q_SIZE);	// skapa Queue med grnsen qs
	~Queue();
	Bool isempty() const;
	Bool isfull() const;
	int queuecount() const;
	Bool enqueue(const Item &item);	// lgg till objekt i slutet
	Bool dequeue(Item &item);		// avlgsna objekt frn brjan
};
#endif