// strng2.cpp  String-klassmetoder
#include <iostream.h>
#include <string.h>
#include "strng2.h"

// klassmetoder

String::String(const char * s)	// skapa String frn C string
{
	len = strlen(s);
	str = new char[len + 1];	// skapa utrymme
	strcpy(str, s);			// initiera pekare
}

String::String()				// frvald konstruerare
{
	len = 0;
	str = new char[1];
	str[0] = '\0';			// frvald strng
}

String::String(const String & st)	// kopieringskonstruerare
{
	len = st.len;
	str = new char[len + 1];
	strcpy(str, st.str);
}

String::~String()				// destruerare
{
	delete [] str;			// krvs
}

// tilldela en String till en String
String & String::operator=(const String & st)
{
	if (this == &st)
		return *this;
	delete [] str;
	len = st.len;
	str = new char[len + 1];
	strcpy(str, st.str);
	return *this;
}

// tilldela en C-strng till en String
String & String::operator=(const char * s)
{
	delete [] str;
	len = strlen(s);
	str = new char[len + 1];
	strcpy(str, s);
	return *this;
}

// sant om st1 kommer efter st2 i sorteringsordning
Bool operator>(const String &st1, const String &st2)
{
	if (strcmp(st1.str, st2.str) > 0)
		return True;
	else
		return False;
}

// sant om st1 fregr st2 i sorteringsordning
Bool operator<(const String &st1, const String &st2)
{
	if (strcmp(st1.str, st2.str) < 0)
		return True;
	else
		return False;
}

// sant om st1 r identisk med st2
Bool operator==(const String &st1, const String &st2)
{
	if (strcmp(st1.str, st2.str) == 0)
		return True;
	else
		return False;
}

// visa strng
ostream & operator<<(ostream & os, const String & st)
{
	os << st.str;
	return os;
}

// snabb och ful String-inmatning
istream & operator>>(istream & is, String & st)
{
	char temp[80];
	is.getline(temp, 80);
	if (is)
		st = temp;
	return is;
}