// aritharr.cpp -- ArithArr klassmetoder
#include <iostream.h>
#include <stdlib.h>				// exit()-prototyp
#include "aritharr.h"

// new methods
double ArithArr::sum() const
{
	unsigned int size = arsize();		// bastkomst via metod
	double total = 0.0;
	for (int i = 0; i < size; i++)
		total += arr[i];			// direkt bastkomst
	return total;
}


double ArithArr::average() const
{
	unsigned int size = arsize();
	if (size < 1)
	{
		cerr << "Nr man berknar ett medelvrde behvs minst ett vektor element  hej d.\n";
		exit(1);
	}
	return sum() / size;
}


// verlagrade operatorer
ArithArr ArithArr::operator+(const ArithArr & a) const
{
	unsigned int size = arsize();
	unsigned int asize = a.arsize();
	if (size != asize)
	{
		cerr << "+ ej definierad fr olika stora " << "vektorer \n";
		exit(1);
	}
	ArithArr total(size);
	for (int i = 0; i < size; i++)
		total[i] = arr[i] + a.arr[i];
	return total;
}
ArithArr ArithArr::operator-(const ArithArr & a) const
{
	unsigned int size = arsize();
	unsigned int asize = a.arsize();
	if (size != asize)
	{
		cerr << "+ ej definierad fr olika stora " << "vektorer \n";
		exit(1);
	}
	ArithArr diff(size);
	for (int i = 0; i < size; i++)
		diff[i] = arr[i] - a.arr[i];
	return diff;
}


ArithArr ArithArr::operator-() const
{
	unsigned int size = arsize();
	ArithArr neg(size);
	for (int i = 0; i < size; i++)
		neg[i] = -arr[i];
	return neg;
}


ArithArr ArithArr::operator*(const ArithArr & a) const
{
	unsigned int size = arsize();
	unsigned int asize = a.arsize();
	if (size != asize)
	{
		cout << "Fel vid vektormultiplikation: vektorerna mste vara lika stora. Hej d.\n";
		exit(1);
	}
	ArithArr product(size);
	for (int i = 0; i < size; i++)
		product[i] = arr[i] * a.arr[i];
	return product;
}


ArithArr ArithArr::operator*(double d) const
{
	unsigned int size = arsize();
	ArithArr temp(size);
	for (int i = 0; i < size; i++)
		temp[i] = arr[i]*d;
	return temp;
}


ArithArr operator*(double d, const ArithArr & a)
{
	return a*d;
}