// ArrayDb.cpp -- metoder fr klassen ArrayDb
#include <iostream.h>
#include <stdlib.h>	// prototypen till exit()
#include "ArrayDb.h"

// frvald konstruerare -- inga argument
ArrayDb::ArrayDb()
{
	arr = NULL;
	size = 0;
}

// konstruerar en vektor med n element,
// alla satta till val
ArrayDb::ArrayDb(unsigned int n, double val)
{
	arr = new double[n];
	size = n;
	for (int i = 0; i < size; i++)
		arr[i] = val;
}

// initiera ArrayDb-objekt till en icke-klassvektor
ArrayDb::ArrayDb(const double *pn, unsigned int n)
{
	arr = new double[n];
	size = n;
	for (int i = 0; i < size; i++)
		arr[i] = pn[i];
}

// initiera ArrayDb-objekt till ett annat
// ArrayDb-objekt
ArrayDb::ArrayDb(const ArrayDb &a)
{
	size = a.size;
	arr = new double[size];
	for (int i = 0; i < size; i++)
		arr[i] = a.arr[i];
}

ArrayDb::~ArrayDb()
{
	delete [] arr;
}

// lter anvndaren n elementen via index (tilldelning
// r tilltet)
double & ArrayDb::operator[](int i)
{
	// kontrollera index innan programmet fortstter
	if (i < 0 || i >= size)
	{
		cerr << "Fel i vektorbegrnsningen: " << i << " r ett felaktigt index\n";
		exit(1);
	}
	return arr[i];
}

// lter anvndaren n elementen via index (tilldelning
// r ej tilltet)
const double & ArrayDb::operator[](int i)
{
	// kontrollera index innan programmet fortstter
	if (i < 0 || i >= size)
	{
		cerr << "Fel i vektorbegrnsningen: " << i << " r ett felaktigt index\n";
		exit(1);
	}
	return arr[i];
}

// definiera klasstilldelning
ArrayDb &ArrayDb::operator=(const ArrayDb &a)
{
	if (this == &a)		// ndra inget om tilldelning
		return *this;	// till sig sjlv
	delete [] arr;
	size = a.size;
	arr = new double[size];
	for (int i = 0; i < size; i++)
		arr[i] = a.arr[i];
	return *this;
}

// snabbutmatning, 5 vrden per rad
ostream &operator<<(ostream &os, const ArrayDb &a)
{
	for (int i = 0; i < a.size; i++)
	{
		os << a.arr[i] << "	";
		if (i % 5 == 4)
			os << "\n";
	}
	if (i % 5 != 0)
		os << "\n";
	return os;
}