// arraydb.h -- definierar en vektorklass
#ifndef _ARRAYDB_H_
#define _ARRAYDB_H_
#include <iostream.h>

class ArrayDb
{
private:
	unsigned int size;		// antal vektorelement
protected:
	double *arr;	// adressen till det frsta elementet
public:
	ArrayDb();			// frvald konstruerare
	// skapa en ArrayDb med n element, tilldelade val
	ArrayDb(unsigned int n, double val = 0.0);
	// skapa en ArrayDb med n element, initiera till vektor pn
	ArrayDb(const double *pn, unsigned int n);
	ArrayDb(const ArrayDb &a);	// kopieringskonstruerare
	~ArrayDb();				// destruerare
	unsigned int arsize() const {return size}; // returnerar vektorns storlek
// verlagrade operatorer
	double &operator[](int i);	// vektorindexering
	
	const double &operator[](int i) const;
	// vektorindexering (no =)
	ArrayDb &operator=(const ArrayDb &a);
	friend ostream &operator<<(ostream &os,
																	const ArrayDb &a);
};
#endif