// arbetare.h  -- arbetarklasser
#include "strng2.h"

class Worker
{
private:
	String fullname;
	long id;
protected:
	virtual void data() const;
public:
	Worker() : fullname("ingen"), id(0L) {}
	Worker(const String & s, long n)
			: fullname(s), id(n) {}
	virtual void set();
	virtual void show() const;
};

class Waiter : public Worker
{
private:
	int panache;
protected:
	void data() const;
public:
	Waiter() : Worker(), panache(0) {}
	Waiter(const String & s, long n, int p = 0)
			: Worker(s, n), panache(p) {}
	Waiter(const Worker & wk, int p = 0)
			: Worker(wk), panache(p) {}
	void set();
	void show() const;
};

class SingingWaiter : public Waiter
{
protected:
	enum {annan, alt, mezzosopran, sopran,
					bas, baryton, tenor};
	enum {Vtypes = 7};
	void data() const;
private:
	static char *pv[Vtypes];	// strng bestende av rsttyper
	int voice;
public:
	SingingWaiter() : Waiter(), voice(annan) {}
	SingingWaiter(const String & s, long n, int p = 0, int v = annan)
			: Waiter(s, n, p), voice(v) {}
	SingingWaiter(const Worker & wk, int p = 0, int v = annan)
			: Waiter(wk,p), voice(v) {}
	SingingWaiter(const Waiter & wt, int v = annan)
			: Waiter(wt), voice(v) {}
	void set();
	void show() const;
};