// arbetmi.h  -- arbetarklasser
#include "strng2.h"

class Worker
{
private:
	String fullname;
	long id;
protected:
	virtual void data() const;
	virtual void get();
public:
	Worker() : fullname("inget"), id(0L) {}
	Worker(const String & s, long n)
			: fullname(s), id(n) {}
	virtual void set();
	virtual void show() const;
};

class Waiter : virtual public Worker
{
private:
	int panache;
protected:
	void data() const;
	void get();
public:
	Waiter() : Worker(), panache(0) {}
	Waiter(const String & s, long n, int p = 0)
			: Worker(s, n), panache(p) {}
	Waiter(const Worker & wk, int p = 0)
			: Worker(wk), panache(p) {}
	void set();
	void show() const;
};

class Singer : virtual public Worker
{
protected:
	enum {annan, alt, mezzosopran, sopran, bas, baryton, tenor};
	enum {Vtypes = 7};
	void data() const;
	void get();
private:
	static char *pv[Vtypes];	// strng bestende av rsttyper
	int voice;
public:
	Singer() : Worker(), voice(other) {}
	Singer(const String & s, long n, int v = other)
			: Worker(s, n), voice(v) {}
	Singer(const Worker & wk, int v = other)
			: Worker(wk), voice(v) {}
	void set();
	void show() const;
};

class SingingWaiter : public Singer, public Waiter
{ 
protected:
	void data() const;
	void get();
public:
	SingingWaiter()  {}
	SingingWaiter(const String & s, long n, int p = 0, int v = Singer::other)
			: Worker(s,n), Waiter(s, n, p), Singer(s, n, v) {}
	SingingWaiter(const Worker & wk, int p = 0, int v = Singer::other)
			: Worker(wk), Waiter(wk,p), Singer(wk,v) {}
	SingingWaiter(const Waiter & wt, int v = other)
			: Worker(wt),Waiter(wt), Singer(wt,v) {}
	SingingWaiter(const Singer & wt, int p = 0)
			: Worker(wt),Waiter(wt,p), Singer(wt) {}
	void set();
	void show() const;
};