// queuetp.h -- queue-mall med en nstlad klass
#include "booly.h"

template <class Item>
class QueueTP
{
private:
	enum {Q_SIZE = 10};
	// Node r en nstlad klassdeklaration
	class Node
	{
	public:
		Item item;
		Node * next;
		Node(const Item & i):item(i), next(0){ }
	};
	Node * front;		// pekare till brjan av Queue
	Node * rear;		// pekare till slutet av Queue
	int items;			// aktuellt antal objekt i Queue
	const int qsize;	// max antal objekt i Queue
	QueueTP(const QueueTP & q) : qsize(0) {}
	QueueTP & operator=(const QueueTP & q) { return *this; }
public:
	QueueTP(int qs = Q_SIZE);
	~QueueTP();
	Bool isempty() const
	{
		return items == 0 ? True : False;
	}
	Bool isfull() const
	{
		return items == qsize ? True : False;
	}
	int queuecount() const
	{
		return items;
	}
	Bool enqueue(const Item &item);	// lgg till objekt till slutet
	Bool dequeue(Item &item);	// ta bort objekt frn brjan
};

// QueueTP-metoder
template <class Item>
QueueTP<Item>::QueueTP(int qs) : qsize(qs)
{
	front = rear = NULL;
	items = 0;
}

template <class Item>
QueueTP<Item>::~QueueTP()
{
	Node * temp;
	while (front != NULL)		// om queue inte r tom n
	{
		temp = front;		// spara adressen till frsta objektet
		front = front->next;	// stt pekaren till nsta objekt
		delete temp;		// radera tidigare frsta objekt
	}
}

// Lgg till objekt till queue
template <class Item>
Bool QueueTP<Item>::enqueue(const Item & item)
{
	if (isfull())
		return False;
	Node * add = new Node(item);	// skapa nod
	if (add == NULL)
		return False;		// avsluta om ingen nod finns tillgnglig
	items++;
	if (front == NULL)		// om queue r tom
		front = add;		// placera objekt i brjan
	else
		rear->next = add;		// annars, placera objekt i slutet
	rear = add; 			// lt rear peka till en ny nod
	return True;
}

// Placera frmre objekt i item-variabeln och ta bort 
// det frn queue
template <class Item>
Bool QueueTP<Item>::dequeue(Item & item)
{
	if (front == NULL)
		return False;
	item = front->item;		// stt item frsta objektet i queue
	items--;
	Node * temp = front;		// spara plats fr frsta objektet
	front = front->next;		// stt front till nsta objekt
	delete temp;			// radera tidigare frsta objekt
	if (items == 0)
		rear = NULL;
	return True;
}