// tvfm.h -- Tv- och Remote-klasser som anvnder friend-
// medlemmar
#ifndef _TVFM_H_
#define _TVFM_H_

enum Bool {False, True};

class Tv; 	// frdeklaration

class Remote
{
public:
	enum State{Off, On};
	enum {MinVal,MaxVal = 20};
	enum {Antenna, Cable};
	enum {TV, VCR};
private:
	int mode;
public:
	Remote(int m = TV) : mode(m) {}
	Bool volup(Tv & t);			// endast prototyp
	Bool voldown(Tv & t);
	void onoff(Tv & t) ;
	void chanup(Tv & t) ;
	void chandown(Tv & t) ;
	void set_mode(Tv & t) ;
	void set_input(Tv & t);
	void set_chan(Tv & t, int c);

};

class Tv
{
public:
	friend void Remote::set_chan(Tv & t, int c);
	enum State{Off, On};
	enum {MinVal,MaxVal = 20};
	enum {Antenna, Cable};
	enum {TV, VCR};

	Tv(State s = Off, int mc = 100) : state(s), volume(5),
		maxchannel(mc), channel(2), mode(Cable), input(TV) {}
	void onoff() {state = (state == On)? Off : On;}
	Bool ison() {return state == On ? True : False;}
	Bool volup();
	Bool voldown();
	void chanup();
	void chandown();
	void set_mode() {mode = (mode == Antenna)? Cable : Antenna;}
	void set_input() {input = (input == TV)? VCR : TV;}
	void settings();
private:
	State state;
	int volume;
	int maxchannel;
	int channel;
	int mode;
	int input;
};

// Remote-metoder som inline-funktioner
inline Bool Remote::volup(Tv & t) { return t.volup();}
inline Bool Remote::voldown(Tv & t) { return t.voldown();}
inline void Remote::onoff(Tv & t) { t.onoff(); }
inline void Remote::chanup(Tv & t) {t.chanup();}
inline void Remote::chandown(Tv & t) {t.chandown();}
inline void Remote::set_mode(Tv & t) {t.set_mode();}
inline void Remote::set_input(Tv & t) {t.set_input();}
inline void Remote::set_chan(Tv & t, int c) {t.channel = c;}
#endif