// binary.cpp -- lgger till information i en binrfil
#include <iostream.h>	// behvs inte fr de flesta system
#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>		// fr exit()

struct planet
{
	char name[20];		// planetens namn
	double population;	// dess population
	double g;			// dess gravitation
};

const char *file = "planets.dat";

int main(void)
{
	planet pl;
	cout.setf(ios::fixed, ios::floatfield);

	// skriv ut ursprungligt innehll
	ifstream fin;
	fin.open(file, ios::in | ios::binary);		// binrfil
	// OBS: somliga system accepterar inte lget ios::binary
	if (fin.good())
	{
		cout << "Hr r det aktuella innehllet i filen "
			<< file << ":\n";
		while (fin.read((char *) &pl, sizeof pl))
		{
			cout << setw(20) << pl.name << ": "
				<< setprecision(0) << setw(12) << pl.population
				<< setprecision(2) << setw(6) << pl.g << "\n";
		}
	}
	fin.close();

	// lgg till nya data
	ofstream fout(file, ios::app | ios::binary);
	// OBS: somliga system accepterar inte lget ios::binary
	if (fout.fail())
	{
		cerr << "Kan inte ppna filen " << file
			<< " fr utmatning:\n";
		exit(1);
	}

	
	cout << "Skriv planetens namn (tom rad avslutar):\n";
	cin.getline(pl.name, 20);
	while (pl.name[0] != '\0')
	{
		cout << "Ange planetens population: ";
		cin >> pl.population;
		cout << "Ange planetens gravitation: ";
		cin >> pl.g;
		
		while (cin.get() != '\n'
			continue;
		fout.write((char *) &pl, sizeof pl);
		cout << "Skriv planetens namn "
			<< "(tom rad avslutar):\n";
		cin.getline(pl.name, 20);
	}
	fout.close();

	// skriv ut reviderad fil
	fin.clear();	// behvs inte fr de flesta system
	fin.open(file, ios::in | ios::binary);
	if (fin.good())
	{
		cout << "Hr r det nya innehllet i filen "
			<< file << ":\n";
		while (fin.read((char *) &pl, sizeof pl))
		{
			cout << setw(20) << pl.name << ": "
				<< setprecision(0) << setw(12) << pl.population
				<< setprecision(2) << setw(6) << pl.g << "\n";
		}
	}
	fin.close();

	return 0;
}