// direktdus.cpp -- utkaststandard direkttkomst till
// en binrfil
#include <iostream.h>	// krvs ej av de flesta system
#include <fstream.h>
#include <stdlib.h>		// fr exit()

struct planet
{
	char name[20];      	// planetens namn
	double population;	// dess populationen
	double g;			// dess gravitation
};

const char * file = "planets.dat";

int main(void)
{
	planet pl;
	cout.setf(ios::fixed, ios::floatfield);
	cout.setf(ios::right, ios::adjustfield);

// show initial contents
	ios::openmode fmode = ios::in | ios::out | ios::ate | ios::binary;
	ifstream fin(file,fmode);	// koppla inmatningsstrm med en fil
	ostream fout(fin.rdbuf());	// koppla utmatningsstrm med samma fil
	streampos end;
	streampos now;
	int ct = 0;
	if (fin.good())
	{	
		end = fin.rdbuf()->pubseekoff(0,ios::end, fmode);	
						// lokalisera filens slut
		now = fin.rdbuf()->pubseekoff(0,ios::beg, fmode);
						// g till brjan
		cout << "Hr r det aktuella innehllet i "
			<< file << "-filen:\n";
		while (now != end)
		{
			fin.read((char *) &pl, sizeof pl); // ls ett block
			now = fin.rdbuf()->pubseekoff(0,ios::cur, fmode);
			// now r en ny position
			cout << ct++ << ": " ;
			cout.width(20); 
			cout << pl.name << ": ";
			cout.precision(0);
			cout.width(12);
			cout << pl.population;
			cout.precision(2);
			cout.width(6);
			cout << pl.g << "\n";
		}
		if (fin.eof())
			fin.clear();		// nollstll eof-flaggan
	}
	else
	{
		cerr << file << " kunde inte ppnas -- adj.\n";
		exit(2);
	}

// ndra en post
	cout << " Ange numret p den post du vill ndra: ";
	long rec;
	cin >> rec;                
	while (cin.get() != '\n')
		continue;     		// f bort ett radslutstecken
	if (rec < 0 || rec >= ct)
	{
		cerr << "Ogiltigt postnummer -- adj\n";
		exit(3);
	}
	streamoff offset = rec * sizeof pl;
	now = fin.rdbuf()->pubseekoff(offset,ios::beg, fmode);
	if (fin.fail())
	{
		cerr << "Fel vid frsk till skning\n";
		exit(4);
	}

	fin.read((char *) &pl, sizeof pl);
	cout << "Ditt val:\n";
	cout << rec << ": ";
	cout.width(20); 
	cout << pl.name << ": ";
	cout.precision(0);
	cout.width(12);
	cout << pl.population;
	cout.precision(2);
	cout.width(6);
	cout << pl.g << "\n";
	if (fin.eof())
		fin.clear();			// nollstll eof-flaggan

	cout << "Skriv planetens namn: ";
	cin.getline(pl.name, 20);
	cout << "Ange planetens population: ";
	cin >> pl.population;
	cout << "Ange planetens gravitation: ";
	cin >> pl.g;
	fout.rdbuf()->pubseekoff(offset, ios::beg, fmode);	
		// g tillbaka
	fout.write((char *) &pl, sizeof pl) << flush;
	if (fout.fail())
	{
		cerr << "Fel vid frsk till skrivning\n";
		exit(5);
	}

// visa reviderad fil
	ct = 0;
	now = fin.rdbuf()->pubseekoff(0,ios::beg,fmode);		
					// g till brjan
	cout << "Hr r det nya innehllet i filen " << file
		<< " :\n";
	while (now != end)
	{
		fin.read((char *) &pl, sizeof pl);
		now =fin.rdbuf()->pubseekoff(0, ios::cur, fmode);
		cout << ct++ << ": " ;
		cout.width(20); 
		cout << pl.name << ": ";
		cout.precision(0);
		cout.width(12);
		cout << pl.population;
		cout.precision(2);
		cout.width(6);
		cout << pl.g << "\n";
	}
	fin.close();

	return 0;
}