// direkt.cpp -- direkttkomst i en binrfil 
// (traditionell C++
#include <iostream.h>	// behvs inte fr de flesta system
#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>	// fr exit()

struct planet
{
	char name[20];		// planetens namn
	double population;	// dess population
	double g;			// dess gravitation
};

const char *file = "planet.dat";

int main(void)
{
	planet pl;
	cout.setf(ios::fixed, ios::floatfield);

	// skriv ut ursprungligt innehll
	fstream finout;				// ls och skriv strmmar
	finout.open(file, ios::in | ios::out | ios::ate | ios::binary);
	// OBS: somliga system krver att | ios::binary utelmnas
	int ct = 0;
	if (finout.good())
	{
		finout.seekg(0);			// g till brjan
		cout << "Hr r det aktuella innehllet i filen "
			<< file << ":\n";
		while (finout.read((char *) &pl, sizeof pl))
		{
			cout << ct++ << ": " << setw(20) << pl.name << ": "
				<< setprecision(0) << setw(12) << pl.population
				<< setprecision(2) << setw(6) << pl.g << "\n";
		}
		if (finout.eof())
			finout.clear();
		else
		{
			cerr << "Fel vid lsning av " << file << ".\n";
			exit(1);
		}
	}
	else
	{
		cerr << file << " kunde inte ppnas -- adj.\n";
		exit(2);
	}

	// ndra en post
	
	cout << "Ange numret p den post du vill ndra: ";
	long rec;
	cin >> rec;
	while (cin.get() != '\n')
		continue;		// bli av med radslutstecknet
	if (record < 0 || record >= ct)
	{
		cerr << "Ogiltigt postnummer -- adj.\n";
		exit(3);
	}
	streampos place = rec * sizeof pl; // konverterar till typen streampos
	finout.seekg(place);
	if (finout.fail())
	{
		cerr << "Fel vid frsk till skning.\n";
		exit(4);
	}

	finout.read((char *) &pl, sizeof pl);
	cout << "Ditt val:\n";
	cout << record << ": " << setw(20) << pl.name << ": "
		<< setprecision(0) << setw(12) << pl.population
		<< setprecision(2) << setw(6) << pl.g << "\n";
	if (finout.eof())
		finout.clear();	// nollstll eof-flaggan
	finout.seekp(place);	// g tillbaka

	cout << "Skriv planetens namn: ";
	cin.getline(pl.name, 20);
	cout << "Ange planetens population: ";
	cin >> pl.population;
	cout << "Ange planetens gravitation: ";
	cin >> pl.g;
	finout.write((char *) &pl, sizeof pl) << flush;
	if (finout.fail())
	{
		cerr << "Fel vid frsk till skrivning -- adj\n";
		exit(5);
	}

	// skriv ut reviderad fil
	ct = 0;
	finout.seekg(0);				// g till filens brjan
	cout << "Hr r det nya innehllet i filen "
		<< file << ":\n";
	while (finout.read((char *) &pl, sizeof pl))
	{
		cout << ct++ << ": " << setw(20) << pl.name << ": "
			<< setprecision(0) << setw(12) << pl.population
			<< setprecision(2) << setw(6) << pl.g << "\n";
	}
	finout.close();

	return 0;
}