#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <string.h>
#include <time.h>
#include "main.h"

int color_table_and = 0;

struct file_entry
{
	struct file_entry *next;
	char path[MAXPATHLEN];
	time_t time;
};

void init();
void end();
char find(char *search_string,char *text);
bool draw_content(char *path,int depth);
void print_message(char *filename);
char print_file(char *file_name);
struct file_entry *find_best(struct file_entry *first_file);

int main(int argc, char *argv[])
{

	if (argc != 2)
	{
		printf("usage: %s path",argv[0]);
		return 1;
	}

	init();
	draw_content(argv[1],0);

	printf("</p>");
	end();
}

void init()
{
	if (!print_file(PAGE_BEGIN)) printf(PAGE_BEGIN_DEFAULT);
}

void end()
{
	if (!print_file(PAGE_END)) printf(PAGE_END_DEFAULT);
}

char print_file(char *file_name)
{
	FILE *file;
	char buffer;
	if (file=fopen(file_name,"r"))
	{
		buffer=getc(file);
		while (!feof(file))
		{
			printf("%c",buffer);
			buffer=getc(file);
		}
		fclose(file);
		return 1;
	}
	else
		return 0;
}

bool draw_content(char *path,int depth)
{
	int counter=0;
	struct dirent *entry;
	DIR *directory;
	struct stat file_stat;
	char name[MAXPATHLEN];
	char string[512];

	directory=opendir(path);
	if (directory)
	{
		struct file_entry *first_file=0;
		struct file_entry *file=0;
		struct file_entry *prev_file=0;

/* --- Reading directory and building directory listing ----- */

		entry=readdir(directory);
		while (entry)
		{
			if (
				strcmp(entry->d_name,".") != 0
				&& strcmp(entry->d_name,"..") != 0
				&& strcmp(entry->d_name,"CVS") != 0
				&& strcmp(entry->d_name,"lib") != 0
				&& strncmp(entry->d_name,"(Objects.",9) != 0
				)
			{
/* Adding entry in list */
				if (!first_file)
				{
					first_file=(struct file_entry *)malloc(sizeof(struct file_entry));
					file=first_file;
					file->next=0;
				}
				else
				{
					file=(struct file_entry *)malloc(sizeof(struct file_entry));
					file->next=first_file;
					first_file=file;
				}
				strcpy(file->path,path);
				strcat(file->path,"/");
				strcat(file->path,entry->d_name);
				stat(file->path,&file_stat);
				file->time=file_stat.st_ctime;
			}
			entry=readdir(directory);
		}
		closedir(directory);
		
/* ----------- DO THE PRINTING AND THE SORTING --------*/

		printf("<h1>%s</h1><ul>",path);
		while (first_file)
		{
			file = find_best(first_file);

			if (!draw_content(file->path,depth+1))
			{

			// if the file isn't a source file, skip it
				int len = strlen(file->path);
				if (
					(file->path[len-2] == '.' && file->path[len-1] == 'h')
					|| (file->path[len-4] == '.' && file->path[len-3] == 'c' && file->path[len-2] == 'p' && file->path[len-1] == 'p')
					)
				{

	/* NAME ENTRY */
					if (!print_file(ENTRY_BEGIN)) printf(ENTRY_BEGIN_DEFAULT);

					if (file->path[len-2] == '.' && file->path[len-1] == 'h')
						printf("<ul>");

					printf("<li><a href = \"%s\">%s</a>",file->path,file->path);
					if (!print_file(ENTRY_END)) printf(ENTRY_END_DEFAULT);

					if (file->path[len-2] == '.' && file->path[len-1] == 'h')
						printf("</ul>");

	/* DATESTAMP */
//					if (!print_file(DATE_BEGIN)) printf(DATE_BEGIN_DEFAULT);
//					printf("%s",ctime(&file->time));
//					if (!print_file(DATE_END)) printf(DATE_END_DEFAULT);
	/* PRINT THE FILE CONTENTS */
//					if (!print_file(MESSAGE_BEGIN)) printf(MESSAGE_BEGIN_DEFAULT);
//					print_message(file->path);
//					if (!print_file(MESSAGE_END)) printf(MESSAGE_END_DEFAULT);
				}
			}
	/* REMOVE ENTRY FROM LIST*/
			if (file==first_file)
			{
				if (first_file->next)
					first_file=file->next;
				else
					first_file=0;
				free(file);
			}
			else
			{
				prev_file=first_file;
				while (prev_file->next!=file)
					prev_file=prev_file->next;
				prev_file->next=file->next;
				free(file);
			}
		}
		printf("</ul>");
	}
	else
		return false;
	return true;
}

// finds the newest file
struct file_entry *find_best(struct file_entry *first_file)
{
	char best_buffer[MAXPATHLEN];
	struct file_entry *ret_file,*file;
	file = first_file;

	strcpy(best_buffer, file->path);
	ret_file = file;

	file=file->next;

	while (file)
	{
		int a = 0;
		a = strlen(file->path) + strcmp(file->path, best_buffer);
		if ((a > 0 && file->path[a] < best_buffer[a]) || (a <= 0 && file->path[0] < best_buffer[0]))
		{
			strcpy(best_buffer, file->path);
			ret_file = file;
		}
		file=file->next;
	}
	if (ret_file==0) ret_file=first_file;
	return ret_file;
}
