/*
	Written by Arvid Norberg 1999 <arvid@iname.com>
*/

#include "VGroup.h"
#include "HGroup.h"
#include "MButton.h"
#include "MBorder.h"
#include "MCheckBox.h"
#include "MStringView.h"
#include "MTextControl.h"
#include "MWindow.h"
#include "layout.h"

#include "RequesterWindow.h"

#include <stdio.h>
#include <string.h>

RequesterWindow::RequesterWindow()
	: MWindow(BRect(100,100,180,150),"Requester window",B_TITLED_WINDOW,B_NOT_RESIZABLE)
{
	wait=create_sem(0,"lock sem");
	topview=
	new VGroup
	(
		minimax(-1,-1,-1,-1),
		new MBorder(M_LABELED_BORDER,5,"Remove",
			new HGroup
			(
				rem_prefix_string=new MTextControl("prefix to remove:",""),
				rem_suffix_string=new MTextControl("suffix to remove:",""),
				0
			)
		),
		new MBorder(M_LABELED_BORDER,5,"Add",
			new VGroup
			(
				new HGroup
				(
					change_all=new MCheckBox("Add only to those who match the above pattern",0,true),
					0
				),
				new HGroup
				(
					add_prefix_string=new MTextControl("prefix to add:",""),
					add_suffix_string=new MTextControl("suffix to add:",""),
					0
				),
				0
			)
		),
		new HGroup
		(
			new MButton("Cancel",new BMessage(CANCEL_BUTTON)),
			ok_button=new MButton("Ok",new BMessage(OK_BUTTON)),
			0
		),
		0
	);
	AddChild(dynamic_cast<BView*>(topview));
	SetDefaultButton(dynamic_cast<BButton*>(ok_button));
}

bool RequesterWindow::QuitRequested()
{
	value=false;
	release_sem(wait);
	return true;
}

bool RequesterWindow::Go(char *rp,char *rs,char *ap,char *as,bool *a)
{
	rem_prefix=rp;
	rem_suffix=rs;
	add_prefix=ap;
	add_suffix=as;
	all=a;

	// show the window
	Show();
	acquire_sem(wait);
	return value;
}

void RequesterWindow::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case OK_BUTTON:
			value=true;
			release_sem(wait); // let the Go() method return

			// copy the data
			strcpy(rem_prefix,rem_prefix_string->Text());
			strcpy(rem_suffix,rem_suffix_string->Text());
			strcpy(add_prefix,add_prefix_string->Text());
			strcpy(add_suffix,add_suffix_string->Text());
			*all=(dynamic_cast<BControl*>(change_all))->IsEnabled();

			Quit();
			break;
		case CANCEL_BUTTON:
			value=false;
			release_sem(wait); // let the Go() method return
			Quit();
    	break;
    default:
			MWindow::MessageReceived(message);
	}
}