/*
	Written by Arvid Norberg 1999 <arvid@iname.com>
*/

#ifndef _REQUESTER_WINDOW_H
#define _REQUESTER_WINDOW_H

#include "layout.h"
#include "MWindow.h"

class MButton;
class MTextControl;
class MCheckBox;

const uint32 OK_BUTTON='okbt';
const uint32 CANCEL_BUTTON='clbt';

class RequesterWindow : public MWindow
{
public:
	RequesterWindow();
	virtual void MessageReceived(BMessage *);
	virtual bool QuitRequested();
	bool Go(char *rem_prefix,char *rem_suffix,char *add_prefix,char *add_suffix,bool *all);
private:
	bool value;
	sem_id wait;
	MTextControl *rem_prefix_string;
	MTextControl *add_prefix_string;
	MTextControl *rem_suffix_string;
	MTextControl *add_suffix_string;
	MCheckBox *change_all;
	MButton *ok_button;

	char	*rem_prefix,
				*rem_suffix,
				*add_prefix,
				*add_suffix;
	bool	*all;

	MView *topview;
};

#endif // _REQUESTER_WINDOW_H