/*
	Written by Arvid Norberg 1999 <arvid@iname.com>
*/

#include "RequesterWindow.h"
#include <Path.h>
#include <Alert.h>

#include <string.h>
#include <stdio.h>

void process_refs(entry_ref ref,BMessage *msg,void *ptr);

_EXPORT void process_refs(entry_ref ref,BMessage *msg,void *ptr)
{
	BPath path;
	entry_ref file_ref;
	int32 cnt=0;
	char	rem_prefix[B_FILE_NAME_LENGTH],
				rem_suffix[B_FILE_NAME_LENGTH],
				add_prefix[B_FILE_NAME_LENGTH],
				add_suffix[B_FILE_NAME_LENGTH];
	bool all;

	RequesterWindow *window=new RequesterWindow();
	if (!window->Go(rem_prefix,rem_suffix,add_prefix,add_suffix,&all))
		return;

	char name[B_FILE_NAME_LENGTH];
	char tmp_name[B_FILE_NAME_LENGTH];
	bool match;
	while (msg->FindRef("refs",cnt++,&file_ref)==B_OK)
	{
// read the filename
		match=false;
		BEntry entry(&file_ref,false);
		entry.GetName(name);

// remove the prefix
		if (strlen(rem_prefix)>0)
		{
			// count the length of the prefix string
			uint8 len=strlen(rem_prefix);
			// check if the name can contain the prefix
			if (strlen(name)>=len)
			{
				// if the beginning of the strings is the same, then remo
				if (!strncasecmp(rem_prefix,name,len))
				{
					strcpy(tmp_name,name+len);
					strcpy(name,tmp_name);
					match=true;
				}
			}
		}

// remove the suffix
		if (strlen(rem_suffix)>0)
		{
			// count the length of the suffix string
			uint8 len=strlen(rem_suffix);
			// check if the name can contain the suffix
			if (strlen(name)>=len)
			{
				// if the beginning of the strings is the same, then remo
				if (!strncasecmp(rem_suffix,name+strlen(name)-len,len))
				{
					name[strlen(name)-len]=0;
					match=true;
				}
			}
		}

		if (all) match=true;

		if (match)
		{
	// add the prefix
			if (strlen(add_prefix)>0)
			{
				// count the length of the prefix string
				uint8 len=strlen(add_prefix);
				// check if the name can contain the prefix
				if (strlen(name)+len<=B_FILE_NAME_LENGTH)
				{
					strcpy(tmp_name,add_prefix);
					strcat(tmp_name,name);
					strcpy(name,tmp_name);
				}
			}

	// add the prefix
			if (strlen(add_suffix)>0)
			{
				// count the length of the prefix string
				uint8 len=strlen(add_suffix);
				// check if the name can contain the prefix
				if (strlen(name)+len<=B_FILE_NAME_LENGTH)
				{
					strcpy(tmp_name,name);
					strcat(tmp_name,add_suffix);
					strcpy(name,tmp_name);
				}
			}
		}

// renames the file
		if (match && strlen(name)>0 && entry.Rename(name,false)==B_FILE_EXISTS)
		{
			char body[B_FILE_NAME_LENGTH+110];
			sprintf(body,"An item named \"%s\" already exists in this folder.\nWould you like to replace it with the one you are\nrenaming?",name);
			BAlert *alert=new BAlert(NULL,body,"Cancel","Replace",NULL,B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_INFO_ALERT);
			alert->SetShortcut(0,B_ESCAPE);
			if (alert->Go()==1) entry.Rename(name,true);
		}
	}
}
