#include <NetKit.h>
#include <stdio.h>
#include <string.h>

#include "receiver.h"

/////////////////////////////////////

void Receiver::printip(long addr)
{	
	fprintf(stderr,"%d.%d.%d.%d",
	(addr >> 24) & 255,
	(addr >> 16) & 255,
	(addr >> 8) & 255,
	addr & 255);
}																
/////////////////////////////////////


/////////////////////////////////////
long Receiver::gethostaddr()
{
	struct hostent *host_ent;
	char host_name[MAXHOSTNAMELEN];

	if (gethostname(host_name,MAXHOSTNAMELEN)==0)
		return INADDR_ANY;

	if ((host_ent=gethostbyname(host_name))==NULL)
		return INADDR_ANY;

	return *(long*)host_ent->h_addr;
}
/////////////////////////////////////

#define IP(x,y,z,w) (x << 24)+(y << 16)+(z  << 8)+(w)

Receiver::Receiver(char *buffer ,int buffersize,int port, bool *ok)
{
	fprintf(stderr,"\n===== Creating Socket ================\n");
	buf=buffer;
	size=buffersize;
	
	// create a socket
	if (0>(s = socket(AF_INET, SOCK_DGRAM, 0))){ 
		perror("error creating socket");
		*ok=false;
		return;
		}
	
	// set the adress
	bzero((char*)&local,sizeof(local));

	local.sin_addr.s_addr=(ulong)gethostaddr();
	//printip(local.sin_addr.s_addr);
	local.sin_family=AF_INET;
	local.sin_port=htonl(port);
	fprintf(stderr,"port=%d\n",local.sin_port);
	
	
	// bind the socket
	fprintf(stderr,"bind...\n");
	if (0>bind(s, (struct sockaddr *)&local, sizeof(local))){
		perror("error binding socket");
		*ok=false;
		return;
	}

	// make non-blocking
	fprintf(stderr,"making non-blocking...\n");
	tmp=-1;
	if (0>setsockopt(s,SOL_SOCKET,SO_NONBLOCK,&tmp,1)){
		perror("error making socket non blocking");
		*ok=false;
		return;
	};
		
	*ok=true;
}

Receiver::~Receiver()
{
	puts("Receiver::~Receiver()");
	closesocket(s);
}

