#include <NetKit.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "tcp_listener.h"

/////////////////////////////////////

void tcp_listener::printip(long addr)
{	
	fprintf(stderr,"%d.%d.%d.%d",
	(addr >> 24) & 255,
	(addr >> 16) & 255,
	(addr >> 8) & 255,
	addr & 255);
}																
/////////////////////////////////////


/////////////////////////////////////
long tcp_listener::gethostaddr()
{
	struct hostent *host_ent;
	char host_name[MAXHOSTNAMELEN];

	if (gethostname(host_name,MAXHOSTNAMELEN)==0)
		return INADDR_ANY;

	if ((host_ent=gethostbyname(host_name))==NULL)
		return INADDR_ANY;

	return *(long*)host_ent->h_addr;
}
/////////////////////////////////////

#define IP(x,y,z,w) (x << 24)+(y << 16)+(z  << 8)+(w)

tcp_listener::tcp_listener(int port, bool *ok)
{
	struct sockaddr_in local; 
	
	// create a socket
	if (0>(s = socket(AF_INET, SOCK_STREAM, 0))){ 
		perror("error creating socket");
		*ok=false;
		return;
		}
	
	// set the adress
		bzero((char*)&local,sizeof(local));
	
		local.sin_addr.s_addr=(ulong)gethostaddr();
		//printip(local.sin_addr.s_addr);
		local.sin_family=AF_INET;
		local.sin_port=htonl(port);
	
	// bind the socket
	fprintf(stderr,"bind...\n");
	if (0>bind(s, (struct sockaddr *)&local, sizeof(local))){
		perror("error binding socket");
		*ok=false;
		return;
		}

	// listen
	if (0!=listen(s,1)){
		perror("error listening");
		*ok=false;
		return;
	};
		
	*ok=true;
}

tcp_sock *tcp_listener::Accept()
{
	struct sockaddr addr;
	int addrs=sizeof(sockaddr),ns;
	printf("(tcp_listener::Accept)\n");
	ns=accept(s, &addr, &addrs);
	if (ns<0) printf("s=%d ns=%d errno=%d\n",s,ns,errno);
	return new tcp_sock(ns);	
}

tcp_listener::~tcp_listener()
{
	closesocket(s);
}
