#include <socket.h>
#include <stdio.h>
#include <string.h>

#include "tcp_sock.h"

tcp_sock::tcp_sock(char *remotehost, int port, bool *ok)
{
// create a socket
	if (0>(s = socket(AF_INET, SOCK_STREAM, 0))){ 
		perror("error creating socket");
		*ok=false;
		return;
	}

// set the adress
	bzero((char*)&remote,sizeof(remote));
	remote.sin_addr.s_addr=inet_addr(remotehost);
	remote.sin_family=AF_INET;
	remote.sin_port=htonl(port);

// connect the socket
	if (0>connect(s, (struct sockaddr *)&remote, sizeof(remote))){
		perror("error connecting socket");
		*ok=false;
		return;
	}

	*ok=true;
}

bool tcp_sock::NonBlocking(bool b)
{
// make non-blocking
	fprintf(stderr,"making non-blocking...\n");
	char tmp=b?-1:0;
	if (0>setsockopt(s,SOL_SOCKET,SO_NONBLOCK,&tmp,1)){
		perror("error changing blocking state");
		return false;
	}
	return true;
}

tcp_sock::tcp_sock(int socket)
{
	s=socket;
}

tcp_sock::~tcp_sock()
{
	closesocket(s);
}
