/*___________________________________________
	B2K CLIENT
*/


#ifndef B2KCLIENT_H
#define B2KCLIENT_H

#include "ThingyBodyAddOn.h"
#include "ThingyBody.h"
#include "B2Kdefs.h"
#include "receiver.h"
#include "tcp_sock.h"

class B2KClient
{
public:
	B2KClient(tcp_sock *tcp, BDirectory *root,char* world, status_t *ok,
			uint32 *offscreen_buf, uint32 *vis_onscreen,
			uint32 words_per_row, sem_id sem);
	~B2KClient();

	bool Go();

private:
/*___________________________________________
	Laddar in en värld
*/
	#define BUFSIZE 512
	int	Load16x16(char *filename, uint8 *data, int loaded);

	bool LoadWorld(char *n);

/*___________________________________________
	Images (gfx)
*/
	uint ImageCount;
	uint32 *Images;
/*___________________________________________
	Blocks (gfx) ass
*/
	uint BgBlockCount;
	uint32 *BgBlocks;

	uint BlockCount;
	uint32 *Blocks;
	
/*___________________________________________
	Da getto' room
*/
	uint8	RoomCount;
	uint8	*blocks;
	uint8	*imgindex;
	
/*___________________________________________
	alla Enemy,bubble funktioner.
*/
	uint8	PlayerCount;
	ThingyBodyAddOn **Player;

	uint8	EnemyCount;
	ThingyBodyAddOn **Enemy;

	uint8	BubbleCount;
	ThingyBodyAddOn **Bubble;

	uint8	NoCollCount;
	ThingyBodyAddOn **NoColl;
	
/*___________________________________________
	NetWorking
*/
	Receiver *r;
	tcp_sock *sock; 
	void SendKeys();
	key_info ki;	// keys 'n stuff

/*___________________________________________
	DrawThingys
	THINGYSMAX defined in "B2Kdefs.h"
*/
	void DrawLoop();

	void bg2draw(uint32 x,uint32 y,uint32 w,uint32 h);
	void draw2vis(uint32 x,uint32 y,uint32 w,uint32 h);
	
	void PlayerDraw(DrawStruct *ds, EraseStruct *es);
	void EnemyDraw(DrawStruct *ds, EraseStruct *es);
	void BubbleDraw(DrawStruct *ds, EraseStruct *es);
	void NoCollDraw(DrawStruct *ds, EraseStruct *es);

	void NextFrame(const bigtime_t delta);
	void PutRoom(uint index, uint32 *buf);

	DrawStruct	draw_this[THINGYSMAX];
	EraseStruct	erase_this[THINGYSMAX];
	EraseStruct	blit_this[THINGYSMAX];
	uint tx,ty;
	
	uint32 *offscreen;
	uint32 *offscreen_bg;
	uint32 *vis;
	uint32 rowwords;

	sem_id sema;
	int total;

	
/*___________________________________________
	Thread
*/
	static int32 thread_func(void *arg);
	thread_id draw_thread;

/*___________________________________________
	Misc
*/
	BDirectory *b2kRoot;

/*___________________________________________
	for timing
*/
	void Start();
	void Stop();
	bigtime_t t1,t2;
	uint32 t3;
	
};


#endif
