/*___________________________________________
	B2K SERVER
*/


#ifndef B2KSERV_H
#define B2KSERV_H

#include "B2Kdefs.h"
#include "Room.h"
#include "B2KDrawStruct.h"
#include "sender.h"

struct Room;

class PlayerAddOn;
class Player;
class ThingyAddOn;
class Thingy;
class TerminatorAddOn;
class Terminator;

class tcp_listener;
class tcp_sock;

class B2KServer
{
public:
	
	B2KServer(char *root,char* world, bool *ok);
	~B2KServer();
	
	
/*___________________________________________
	returnerar ett index
	mot ett pathname
	(negativt fel)
*/
	virtual int		EnemyPath2Index(char *path);
	virtual int		BubblePath2Index(char *path);
	virtual int		NoCollPath2Index(char *path);
	
/*___________________________________________
	skapar ny thingy och lägger till i
	rätt lista 
*/
	virtual Thingy	*NewEnemy(uint32 index, Room *room, uint32 x, uint32 y, int32 xspeed, int32 yspeed, char *arg);
	virtual Thingy	*NewBubble(uint32 index, Room *room, uint32 x, uint32 y, int32 xspeed, int32 yspeed, char *arg);
	virtual Thingy	*NewNoColl(uint32 index, Room *room, uint32 x, uint32 y, int32 xspeed, int32 yspeed, char *arg);

/*___________________________________________
	skriver ut statistik 
*/
	void Stat();	
	



/*	::::::::::::::::::::::::::::::::::::::::::
	::::::::::::::::::::::::::::::::::::::::::
	::::  ATTENTION   NOT FOR PUBLIC USE  :::: 
	::::::::::::::::::::::::::::::::::::::::::
	:::::::::::::::::::::::::::::::::::::::::: */

	bool Go();
	void Listener();
		
private:

/*___________________________________________
	skapar ny player och lägger till i
	rätt lista 
*/
	virtual Player	*NewPlayer(Sender *s, tcp_sock *tcp, uint32 index, Room *room, uint32 x, uint32 y, int32 xspeed, int32 yspeed,char *arg);
/*___________________________________________
	Går igenom alla rum och kör cykle
	på allt som finns i dem
*/
	void CycleThread(); // skall flyttas
	void Cycle();

	void CreatePacket();
	DrawStruct	draw_this[THINGYSMAX];

/*___________________________________________
	Laddar in en värld
*/
	#define BUFSIZE 200
	uint8 Char2Val(char c);
	void jntok(char *b, char *m);
	bool Line2Data(uint8 *to, char *text);
	bool NextLine(FILE *stream,char *buf);
	bool LoadWorld(char *FileName);
	
/*___________________________________________
	array med alla rum
	med fiender mm. i,
	samma som alla objekt
	har (ett rum var)
*/
	uint8	RoomCount;
	Room	*Rooms;

/*___________________________________________
	players & clients
*/
//	PlayerAddOn **PlayerClass;
//	uint8	PlayerCreateCount;

	thread_id listen_thread;
	sem_id	room_sem;	// listener puts players
/*___________________________________________
	alla Enemy,bubble funktioner.
*/
	
//terminator
	TerminatorAddOn *TerminatorClass;
	Terminator	*MyTerminator;
	
//thingys
	uint8	PlayerCreateCount;
	PlayerAddOn **PlayerClass;

	uint8	EnemyCreateCount;
	ThingyAddOn **EnemyClass;

	uint8	BubbleCreateCount;
	ThingyAddOn **BubbleClass;

	uint8	NoCollCreateCount;
	ThingyAddOn **NoCollClass;
	
	char *b2kRoot;
	char *currworld;
	thread_id cyklethread;
};


#endif
