/*
 *	B2K Player
 *
 *	(c) Jonas Norberg 1990-03-14
 */

#ifndef PlayerBRAIN_H
#define PlayerBRAIN_H

#include "tcp_sock.h"
#include "sender.h"
#include "ThingyBrain.h"
#include "B2Kdefs.h"
#include "B2KDrawStruct.h"


struct Room;
class B2KServer;
class sender;

class Player: public Thingy{
public:
	
	Player( Sender *s, tcp_sock *r, B2KServer *serv,uint32 id, Room *room, uint32  x,
		uint32  y, int32 xspeed, int32 yspeed, bigtime_t timenow, char *arg);
	
	// server calls these on demand from client 
	virtual void Up(bool on);
	virtual void Right(bool on);
	virtual void Left(bool on);
	virtual void Down(bool on);

	virtual void Fire1(bool on);
	virtual void Fire2(bool on);

	virtual void PickUp1(); // enkeltryck, kasta vapnet man har
	virtual void PickUp2();

	inline int Send(char *buffer, int size);
	inline int Receive(char *buffer,int size);

protected:

	//Weapon *wep1;
	//Weapon *wep2;
	Sender *send;
	tcp_sock *recv;	
};

inline int Player::Send(char *buffer,int size)
{
	return send->Send(buffer,size);
}

inline int Player::Receive(char *buffer,int size)
{
	return recv->Receive(buffer, size);
}


#endif