/*
 *	B2K Thingy
 *
 *	(c) Jonas Norberg 1998-07-26
 */

#ifndef THINGYBRAIN_H
#define THINGYBRAIN_H

#include "Room.h"
#include "B2Kdefs.h"
#include "B2KDrawStruct.h"

struct Room;
class B2KServer;

class Thingy{
public:
	
	Thingy(B2KServer *serv,uint32 id, Room *room,uint32  x, uint32  y, int32 xspeed, int32 yspeed, bigtime_t timenow,uint8 kind, char *arg);
	
	// returnerar om enemyn skall fortsätta leva eller tas bort
	virtual bool	Cycle(bigtime_t timenow);
	
	virtual void	HitBy(int32 xspeed, int32 yspeed, int32 weight);
	virtual bool	Intersects(uint32  left, uint32  top, uint32  right, uint32  down);
	
	virtual	int32	GetDamage();
	virtual char	*Name();
	virtual	char	*CreatorName();
	

	//	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	//	following implemented by me
	 
	void GetPos(DrawStruct *ds);
	int32	Health();
	int32	Weight();
	

	//	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	//	these for list things.
	bool	IsLast();
	bool	IsFirst();
	Thingy	*Next();
	Thingy	*Prev();
	void	SetNext(Thingy *next);
	void	SetPrev(Thingy *prev);
	void	Add(Room *newroom);	// kollar Room->FirstEnemy
	void	Remove(); 			// kollar Room->FirstEnemy
	void	MoveTo(Room *room);	// kollar Room->FirstEnemy,
								// ändrar den privata room.
	
protected:

	//	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	//	help functions
	
	virtual void Room_ClearFloor();
	virtual void Room_ClearLeftWall();
	virtual void Room_ClearRightWall();
	virtual void Room_ClearCeiling();
	virtual void Room_LeftUpFree();
	virtual void Room_LeftDownFree();
	virtual void Room_RightUpFree();
	virtual void Room_RightDownFree();
	virtual void Room_LeftUpCorner();
	virtual void Room_LeftDownCorner();
	virtual void Room_RightUpCorner();
	virtual void Room_RightDownCorner();
	virtual void Room_Trapped();
	virtual void Room_Clear();
	virtual void Room_LeftUpDiagonal();
	virtual void Room_LeftDownDiagonal();
	
	void	RoomCollision();


	//	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	//	variables
	
	Thingy	*prev_Thingy;
	Thingy	*next_Thingy;
	
	uint32	x, y, state;
	int32	xspeed, yspeed, health, weight;
	
	uint32	width,height;
	uint8	mykind;
	uint32 index;
	
	B2KServer *server;
	bigtime_t time;
	Room	*room;
	
};

#endif