#ifndef _SCREEN_H_
#define _SCREEN_H_

#include <WindowScreen.h>
#include <OS.h>

#include "B2KClient.h"
#include "Server.h"

// temporary
#include "tcp_sock.h"

#define LINES 10
#define STRTCHR 32

class B2KScreen: public BWindowScreen
{
public:
	B2KScreen(BDirectory *root, const char *title,status_t *e);
	~B2KScreen();

	uint32 *Bits();
	void ScreenConnected(bool connected);

private:
	//temp.
	tcp_sock *sock;
	char sbuf[200];

	B2KClient *client;
	BDirectory *b2kroot;

	// en bild, o font
	uint32 *buf;//[3*640*480];
	uint8 font[(16*16)*(256-STRTCHR)];
	
	// läsa in servers
	#define SBUFSIZE 100
	#define MAXSERVERS 20
	Server *Servers[MAXSERVERS];
	char txtbuf1[SBUFSIZE];
	char txtbuf2[SBUFSIZE];
	char txtbuf3[SBUFSIZE];
	//--
		
	int LoadRead(const char*name, int no,int size, uint8 *buf);
	void PutChr(int x_,int y_,char v, uint8 r, uint8 g, uint8 b);
	void PutStr(int x_, int y_, const char *text);
	void Feed(const char *text);
	void FeedUpdate();
	
	bool first;
	
	uint32 *vis;
	uint32 offscreen[640*480*2];
	
	uint32 rowbytes;
	uint32 rowwords;
	sem_id screen_sem;
};

#endif // _SCREEN_H_