#include "TextFile.h"
#include <File.h>
TextFile::TextFile(BDirectory *dir, char *filename):BFile(dir,filename,(uint32)B_READ_ONLY)
{
};

TextFile::~TextFile()
{
};

/*	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*	C H A R 2 V A L
*
*/
uint8 TextFile::Char2Val(char c)
{
	switch(c){
		case '0': return 0;
		case '1': return 1;
		case '2': return 2;
		case '3': return 3;
		case '4': return 4;
		case '5': return 5;
		case '6': return 6;
		case '7': return 7;
		case '8': return 8;
		case '9': return 9;
		case 'A': return 10;
		case 'B': return 11;
		case 'C': return 12;
		case 'D': return 13;
		case 'E': return 14;
		case 'F': return 15;
		case 'a': return 10;
		case 'b': return 11;
		case 'c': return 12;
		case 'd': return 13;
		case 'e': return 14;
		case 'f': return 15;
		default : return 0;
	}	
}

/*	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*	L I N E 2 D A T A
*
*/
bool TextFile::Line2Data(uint8 *to, char *text)
{
	bool ok=true;
	if (strlen(text)!=80){
		fprintf(stderr,"wrong linelength was %d should be 40\n",strlen(text));
		return false;
	}
	
	while (*text != 0){
		*to=Char2Val(*text++)<<4;
		*to|=Char2Val(*text++);
		//printf("%02x",*to);
		to++;
	}
	//putchar('\n');		
	return ok;
}

/* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*	J N G T O K
*
*	replaces first occurance (of any character in the string m)
*	in string b with '0'
*/
void TextFile::jntok(char *b, char *m)
{
	bool cont=true;
	int mc=strlen(m);
	int c;
	while (*b!=0 && cont){
		for (c=0;c<mc;c++)
			if (*b == m[c]){
				*b=0;
				cont=false;
			}
		b++;
	}	
}
		
/*	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*	N E X T L I N E
*
*/
bool TextFile::NextLine(char *buf,int size)
{
	int c;
	do {
		// ------------ jngfgets starts
		c=-1;
		do {
			c++;
			if (1 != Read(buf+c,1)) return false;
		} while ('\n'!=buf[c] && size>c);

		buf[c]=0;//terminate
		// ------------ jngfgets
		
		jntok(buf,"#\n\t");		
	} while ( 0==(*buf));	//tills det finns nått att hämta.

	return true;	
}



