/*
*	B2K Thingy
*
*	(c) Jonas Norberg 1998-07-26
*/

#include "B2KDrawStruct.h"
#include "ThingyBody.h"

#define DBG(x) /*fputs(x,stderr)*/

__declspec(dllexport) ThingyBody::ThingyBody(uint32 *screen)
{
	base=screen;
}

__declspec(dllexport) ThingyBody::~ThingyBody()
{
}

__declspec(dllexport) void ThingyBody::PutBitmapxRGB(DrawStruct *ds, EraseStruct *es,uint32 *gfx, uint8 width,uint8 height)
{
	if ((ds->x>((639-width)<<22)) || (ds->y>((479-height)<<22))) {
		DBG("(ThingyBody::PutBitmapxRGB)	Skipped.\n");
//		fprintf(stderr,"x=%d y=%d s=%d\n",ds->x>>22,ds->y>>22,ds->state);
		es->width=0;
		es->height=0;
		return;
	}
	static uint32 *mbase;
	static int _x,_y;
	
	mbase=base+((ds->y >>22)*640+(ds->x >>22));
	for (_y=0;_y<height;_y++)
		for (_x=0;_x<width;_x++)
			if (gfx[_y*width+_x]!=0) mbase[_y*640+_x]=gfx[_y*width+_x];

	es->x=ds->x >>22;
	es->y=ds->y >>22;
	es->width=width;
	es->height=height;
}

__declspec(dllexport) void ThingyBody::PutBitmapAddRGB(DrawStruct *ds, EraseStruct *es,uint8 *gfx, uint8 width,uint8 height)
{
	if ((ds->x>((639-width)<<22)) || (ds->y>((479-height)<<22))) {
		DBG("(ThingyBody::PutBitmapAddRGB)	Skipped.\n");
//		fprintf(stderr,"x=%d y=%d s=%d\n",ds->x>>22,ds->y>>22,ds->state);
		es->width=0;
		es->height=0;
		return;
	}
	static uint8 *mbase;
	static int _x,_y;
	int add=4*(640-width);
	int res;

	mbase=(uint8 *)base+4*((ds->y >>22)*640+(ds->x >>22));

	for (_y=0;_y<height;_y++){
		for (_x=0;_x<width;_x++){
			mbase++; //skip 'alpha'

			res=*gfx + *mbase;
			if (res>255) res=255;
			*mbase=res;
			mbase++;
			gfx++;

			res=*gfx + *mbase;
			if (res>255) res=255;
			*mbase=res;
			mbase++;
			gfx++;

			res=*gfx + *mbase;
			if (res>255) res=255;
			*mbase=res;
			mbase++;
			gfx++;
		}
		mbase+=add;
	}

	es->x=ds->x >>22;
	es->y=ds->y >>22;
	es->width=width;
	es->height=height;
}

__declspec(dllexport) void ThingyBody::PutBitmapARGB(DrawStruct *ds, EraseStruct *es,uint8 *gfx, uint8 width,uint8 height)
{
	if ((ds->x>((639-width)<<22)) || (ds->y>((479-height)<<22))) {
		DBG("(ThingyBody::PutBitmapARGB)	Skipped.\n");
//		fprintf(stderr,"x=%d y=%d s=%d\n",ds->x>>22,ds->y>>22,ds->state);
		es->width=0;
		es->height=0;
		return;
	}
	static uint8 *mbase;
	static int _x,_y;
	int add=4*(640-width);
	uint8 a;

	mbase=(uint8 *)base+4*((ds->y >>22)*640+(ds->x >>22));

	for (_y=0;_y<height;_y++){
		for (_x=0;_x<width;_x++){
			mbase++; //skip 'alpha'
			a=*(gfx++);
			if (a){
				*mbase=((*gfx)*a + (*mbase)*(255-a)) >>8;
				mbase++;
				gfx++;
				*mbase=((*gfx)*a + (*mbase)*(255-a)) >>8;
				mbase++;
				gfx++;
				*mbase=((*gfx)*a + (*mbase)*(255-a)) >>8;
				mbase++;
				gfx++;
			}else{
				mbase++;
				mbase++;
				mbase++;
				gfx++;
				gfx++;
				gfx++;			
			}
		}
		mbase+=add;
	}

	es->x=ds->x >>22;
	es->y=ds->y >>22;
	es->width=width;
	es->height=height;
}


__declspec(dllexport) void ThingyBody::Draw(DrawStruct *ds, EraseStruct *es)
{
	base[(ds->y >>22)*640+(ds->x >>22)]=31;
	es->x=ds->x >>22;
	es->y=ds->y >>22;
	es->width=1;
	es->height=1;
}
