/*
*	B2K BadBubble
*
*/

#include "BadBubbleBrain.h"
#include "ThingyBrain.h"
#include "Room.h"
#include "B2KServer.h"

#define PERIOD 530000

BadBubble::BadBubble(B2KServer *serv,uint32 indexnr, Room *room, uint32 x, uint32 y, int32 xspeed, int32 yspeed,bigtime_t timenow,uint8 kind, char *arg):
Thingy(serv,indexnr, room, x, y, xspeed, yspeed, timenow,kind, arg)
{
	width=16<<22;
	height=16<<22;
	
	weight=100;
	health=1;
	lives=true;
	next=timenow+PERIOD;
	state=0;
	lifetime=10;
}


void BadBubble::Room_Trapped()
{
	lives=false;
}


// returnerar om bubble'en skall fortsätta leva eller tas bort
bool	BadBubble::Cycle(bigtime_t timenow)
{
	bigtime_t delta_t=timenow-time;

	if (next < timenow){
		next=timenow+PERIOD;
		state++;
		state=state & 3;
		if (0==lifetime--) lives=false;
	}


	// fall
	yspeed+=(weight*delta_t/300000);

	// röra sig
	y+=(yspeed*delta_t);
	x+=(xspeed*delta_t);

	RoomCollision();
			
	time=timenow;
	return lives;
}


void	BadBubble::HitBy(int32 xs, int32 ys, int32 weight)
{
//	xspeed+=xs;	
//	yspeed+=ys;	
	lives=false;
}


// returnerar hur mycket skada en krock ger dig
int32 BadBubble::GetDamage()
{
	return 60;
}


char	*BadBubble::Name()
{
	return "BadBubble";
}

char	*BadBubble::CreatorName()
{
	return "Jonas Norberg (c)1998";
}
