/*
*	B2K Spark
*
*/

#include "Spark.h"
#include "ThingyBrain.h"
#include "Room.h"
#include "B2KServer.h"

#define LIFETIME 1000000

Spark::Spark(B2KServer *serv,uint32 indexnr, Room *room, uint32 x, uint32 y, int32 xspeed, int32 yspeed,bigtime_t timenow,uint8 kind, char *arg):
Thingy(serv,indexnr, room, x, y, xspeed, yspeed, timenow,kind, arg)
{
	width=4<<22;
	height=4<<22;

	xdir=-xspeed*3/7;
	ydir=-yspeed*2/5;
	weight=100;
	next=timenow+LIFETIME+(rand()<<5);
	state=rand() & 7;
}


// returnerar om bubble'en skall fortsätta leva eller tas bort

bool	Spark::Cycle(bigtime_t timenow)
{
//fprintf(stderr,"%d",id);
	
	bigtime_t delta_t=timenow-time;

	if (next < timenow) return false;

	// fall
		xspeed+=(xdir*delta_t/300000);
		yspeed+=(ydir*delta_t/300000);



	// röra sig
	y+=(yspeed*delta_t);
	x+=(xspeed*delta_t);
	
	if ((x>((639-8)<<22)) || (y>((479-8)<<22))) return false;
	
//	printf("%d %d\n",x>>22, y>>22);

	time=timenow;
	return true;
}

char	*Spark::Name()
{
	return "Spark";
}

char	*Spark::CreatorName()
{
	return "Jonas Norberg (c)1999";
}
