#ifndef INSPLY_H
#define INSPLY_H

#include "wave.h"
#include "song.h"

class InsPly
{
public:
	InsPly(Ins *s);
	float Next();

	void TrigADSR(uint8 i);
	void SetFilt(float f);
	void SetFreq(float f);
	void SetAmp(float a);
private:

	Wave *w;
	Ins *ins;
	InsStep *currstep;
	uint8 stepc;		//instrument step
	uint32 nexts;	//next ins

	Ins *currins;
	InsStep *steps;

	// Amp ADSR 
	float curramp;
	float ampstep;
	int8 adsr;
	uint32 nextadsr;	

	// Filter ADSR 
	float currf;
	float fstep;
	int8 fadsr;
	uint32 nextfadsr;	

	// from inspattern
	float inspwm;
	float inspwmstep;
	float insfreq;
	float insfreqstep;
	float insamp;
	float insampstep;
	float insf;
	float insfstep;
	
	// from player
	float currpartamp;
	float currpartfilt;
	float currpartfreq;
};


#endif
