#include "insply.h"
#include "player.h"

const float N2F[]={
#include "freq-table.h"	
};

Player::Player(Song *s, uint8 *sequence, int8 *transp)
{
	ip=new InsPly((Ins *)s->ins);
//	fprintf(stderr,"song = %p\nseq  = %p\n",s,sequence);
	song=s;
	seq=sequence;
	t=transp;
		
	JumpPos(0,0);	
}

void Player::JumpPos(uint8 seqpos, uint8 steppos)
{
	seqcount=seqpos;
	if (seqcount >= song->songlen) seqcount=0;

	currpart=&(song->parts[seq[seqpos]]);

	
	if (stepc >= currpart->len) stepc=0;
	
	stepc=0;
	nexts=0;	
}

short Player::Next()
{
// checkstep
	if (!nexts){
		nexts=song->sps;
		
		currstep=&(currpart->steps[stepc]);
//		fprintf(stderr,"currstep=%p\n",currstep);
//		fprintf(stderr,"stepc=%d\n",stepc);

		if (currstep->ins){
			ip->TrigADSR(currstep->ins);

			amp = 1.0;
			ampstep = 0;
			f = 1.0;
			fstep = 0;
		}
		
//	fprintf(stderr,"t[seqcount]=%d\n",t[seqcount]);
		if (currstep->note){
			freqtarget = N2F[currstep->note+t[seqcount]];
			freqmul = 1.0;
		}
					
		if (currstep->eff){
			switch (currstep->eff & 0xf0){
//			case 0x10 : freqmul=1+(currstep->eff & 0xf)/(1000.0); break;
//			case 0x20 : freqmul=1-(currstep->eff & 0xf)/(1000.0); break;
			case 0x30 : freqmul=(((currstep->eff & 0xf) + 1 )/(4.0 * 1000.0)); break;

			case 0x70 : fstep = (currstep->eff & 0xf)/(32.0*1000); break;
			case 0x80 : fstep = -(currstep->eff & 0xf)/(32.0*1000); break;
			case 0x90 : fstep=0; f = ((currstep->eff & 0xf) +1)/16.0; break;

			case 0xa0 : ampstep = (currstep->eff & 0xf)/(32.0*1000); break;
			case 0xb0 : ampstep = -(currstep->eff & 0xf)/(32.0*1000); break;
			case 0xc0 : ampstep = 0; amp = (currstep->eff & 0xf)/15.0; break;
			}
		}

		// increase counters;
//fprintf(stderr,"stepc= %d\n",stepc);
		stepc++;
		if (stepc >= currpart->len){
			stepc=0;
			seqcount++;
			currpart=&(song->parts[seq[seqcount]]);
//fprintf(stderr,"seqpos=%d	currpart= %d\n",seqcount,seq[seqcount]);
			if (seqcount >= song->songlen){
				seqcount=0;
			}
		}
	}

	nexts--;

	f+=fstep;
	amp+=ampstep;

	freq= freq*(1-freqmul) + (freqmul)*freqtarget;
	ip->SetFilt(f);
	ip->SetAmp(amp);
	ip->SetFreq(freq);

	return ip->Next();
};


/*
----------------------------------------------------------
*/
void Player::DumpPart(uint8 part)
{
	fprintf(stderr,"\n -- Part %x --\nstp ins note\n",part);
	Part *p=&(song->parts[part]);
	for (int c=0;c<p->len;c++)
		fprintf(stderr,"%02x - %02x %02x\n",c,p->steps[c].ins,p->steps[c].note);
}

void Player::DumpIns(uint8 ins)
{
	fprintf(stderr,"\n -- Ins %x --\n",ins);
	Ins *i=&(song->ins[ins]);

	fprintf(stderr,"ADSR amp T [%02x %02x %02x %02x]\n",i->adsr[0],i->adsr[1],i->adsr[2],i->adsr[3]);
	fprintf(stderr,"         L [%02x %02x %02x %02x]\n\n",i->adsrlev[0],i->adsrlev[1],i->adsrlev[2],i->adsrlev[3]);

	fprintf(stderr,"ADSR flt T [%02x %02x %02x %02x]\n",i->fadsr[0],i->fadsr[1],i->fadsr[2],i->fadsr[3]);
	fprintf(stderr,"         L [%02x %02x %02x %02x]\n\n",i->fadsrlev[0],i->fadsrlev[1],i->fadsrlev[2],i->fadsrlev[3]);

	fprintf(stderr,"Sps %d\n",i->sps);
	fprintf(stderr,"len %02x\n",i->len);

	for (int c=0;c<i->len;c++)
		fprintf(stderr,"%02x- %d\n",c,i->steps[c].note);
}

