#ifndef PLAYER_H
#define PLAYER_H

#include "insply.h"
#include "song.h"

class Player
{
public:
	Player(Song *s, uint8 *sequence, int8 *transp);
	short Next();

	void DumpPart(uint8 part);
	void DumpIns(uint8 ins);
	void JumpPos(uint8 seqpos, uint8 steppos);
private:

	InsPly *ip;
	Song *song;
	uint8 *seq;
	int8 *t;

	Step *currstep;	
	Part *currpart;
	uint8 seqcount;
	uint8 stepc;		// step
	
	uint32 nexts;		// samples per step (11000 is OK)	

	float amp;
	float ampstep;
	float f;
	float fstep;
	
	float freq;
	float freqmul;
	float freqtarget;
};

#endif