#ifndef Song_H
#define Song_H

#define uint8 unsigned char 
#define uint32 unsigned int 

struct InsStep
{
	uint8 mask; //0001 bit relative | 1111 bit wform
	uint8 note;	//8bit not
	uint8 eff;	//4bits eff 4bits value
};

struct Ins
{
	// Amp
	uint8 adsr[4];
	uint8 adsrlev[4];

	// Filter
	uint8 fadsr[4];
	uint8 fadsrlev[4];

	uint32 sps;	// samples per step (5500 is OK)	
	uint8 len;	// max 16
	InsStep steps[16];
};

struct Step
{
	uint8 ins;
	uint8 note;
	uint8 eff;		//4bits eff 4bits value
};

struct Part
{
	uint8 len;		// max 64
	Step steps[64];
};

struct Song
{
	uint32 sps;			// samples per step (11000 is OK)	

	uint8 songlen;		// max 64

	Part parts[64];	// 64 parts

	uint8 seq1[64];
	int8 transp1[64];

	Ins ins[256];
};

#endif