#include "wave.h"
Wave::Wave(float freq, float amp, uint8 waveform)
{
	SetForm(waveform);
	SetFreq(freq);
	SetAmp(amp);
	SetPulseWidth(0);
}

Wave::Wave()
{
	SetForm(SAW);
	SetFreq(1760);
	SetAmp(1);
	SetPulseWidth(0);
}


void Wave::SetFilt(float filt)
{
	filter = filt;
}

void Wave::SetFreq(float freq)
{
	step = freq * 1.48607709750566893424;
//	fprintf(stderr,"(Wave)freq = %f\n",freq);
//	fprintf(stderr,"step = %f\n",step);
}

void Wave::SetAmp(float amp){			a = amp;			}
void Wave::SetForm(uint8 waveform){		form = waveform;	}
void Wave::SetPulseWidth(float pulse){	p = pulse * 29*1024;}

float Wave::Next()
{
	currval += step; if (currval>31*1024) currval-=62*1024;

	last=curr;
	switch (form){
	case SAW:	curr= currval; // saw
				break;
	case SQR:	curr= (p > currval)?(-31*1024 + p):(31*1024); // pulse
				break;
	case NOS:	curr= 2*(rand()-0x4000);
				break;
	case TRI:	curr= (0 > currval)?(short)(2*currval -((32*1024)-1)):(short)(-2*currval-((32*1024)-1));
				break;

// experimental waves
	case TRS:	curr= (0 > currval)?(short)(2*currval):(short)(-2*currval);
				break;

	default:	return 0;
	}
	curr*=a;
	curr=last*(1-filter) + filter*curr;
	return curr;
}

