#ifndef WAVE_H
#define WAVE_H

#define HOLD 0
#define SAW 1
#define SQR 2
#define TRI 3
#define NOS 4

#define TRS 5


class Wave
{
public:
	Wave(float freq, float amp, uint8 waveform);
	Wave();

	float Next();

	void SetFreq(float freq);
	void SetFilt(float filt);
	void SetAmp(float amp);

	void SetForm(uint8 waveform);
	void SetPulseWidth(float pulse);
private:

	uint8 form;

	float filter;
	float p;	
	float step;
	float currval;
	float a;

	float curr;
	float last;
};

#endif
